C000 8C BR    @>C3F5 Executes through TRAP 18
     C3              Put information in the directory of file space
     F5

C003 8C BR    @>C98E Executes through TRAP 19
     C9              Shift system alpha register 1 position to the left or the
     8E              right

C006 8C BR    @>C3E7 Executes through TRAP 20
     C3              Get information out of the directory of file space
     E7

C009 FF TRAP0        Executes through TRAP 21 [Not used]
     FF
     FF

C00C FF TRAP0        Executes through TRAP 22 [Not used]
     FF
     FF

C00F FF TRAP0        Executes through TRAP 23 [Not used]
     FF
     FF

          SBA   Address   Instruction
C012 C0   100    [C0EC]   ADV
     EC

C014 C1   102    [C127]   PRT
     27

C016 C3   104    [C310]    WB
     10

C018 C7   106    [C7C2]   Cassette I/O operations
     C2

C01A C4   108    [C419]   Set value in >2090 based on the presence of in- and
     19                   external FS. If there is File Space, the instruction
                          following this SBA is skipped. This SBA treats RAM
                          as ROM if the appropriate bit in the catalog is set.

C01C C3   10A    [C38E]   Store a file
     8E

C01E C4   10C    [C44C]   Search for file. If the file is not found, the
     4C                   instruction following this SBA is skipped.

C020 C4   10E    [C4FB]   Replace a file
     FB

C022 C5   110    [C54B]   Read a file
     4B

C024 C5   112    [C574]   Delete a file
     74

C026 C6   114    [C636]
     36

C028 C6   116    [C61B]
     1B

C02A C6   118    [C68A]
     8A

C02C C6   11A    [C6B5]
     B5

C02E C6   11C    [C603]
     03

C030 C6   11E    [C6ED]   CMS
     ED

C032 C5   120    [C5B2]
     B2

C034 C7   122    [C706]   BRK
     06

C036 C7   124    [C763]   Perform a GO, using a second copy of the BREAK
     63                   flags

C038 C7   126    [C76B]    GO
     6B

C03A C2   128    [C20F]   Performs an I/O operation, to determine if the
     0F                   printer specified by <DEV> is connected

C03C C3   12A    [C32E]
     2E

C03E CA   12C    [CABF]   Test the DockBus
     BF

C040 C8   12E    [C8E4]   Test the system RAM
     E4                   This test destroys all user memory, but saves
                          the contents of SR 2016-2139

C042 C9   130    [C979]   Calculate and check CRC for processor ROM
     79

C044 C9   132    [C9D1]   Calculate and check CRCs for 4 pages between
     D1                   >C000 and >DFFF

C046 C9   134    [C98E]   Shift system alpha register 1 position to the
     8E                   right or completely to the left [TRAP 19]

C048 C4   136    [C400]   Set value in >2090 based on the presence of in- and
     00                   external FS. If there is File Space, the instruction
                          following this SBA is skipped. This SBA treats all
                          RAM as RAM even if the ROM bit in the catalog is set.

C04A CA   138    [CA18]   Calculate and check CRC for ROM cartridge
     18                   CRC is located at >4004 [MSB] and >4005 [LSB]. This
                          SBA will place the calculated CRC at R78 [MSB] and
                          R79 [LSB]

C04C C8   13A    [C899]   Test a RAM cartridge
     99                   This test destroys the original contents

C04E CB   13C    [CB05]   Keyboard test routine
     05

C050 C6   13E    [C6DC]   TRC
     DC

C052 C3   140    [C326]   Scan for HLT or BRK. Execute pause and hold
     26                   if -> is pressed. High speed if -> is pressed
                          and released quickly

Start of code

C054 A2 MOVP  %>08,P14
     08
     0E
C057 52 MOV   %>08,B
     08
C059 A2 MOVP  %>00,P14
     00
     0E
C05C BF RLC   A
C05D E7 JNC   05            [C064]
     05
C05F A3 ANDP  %>FE,P14
     FE
     0E
C062 E0 JMP   03            [C067]
     03
C064 A4 ORP   %>01,P14
     01
     0E
C067 A3 ANDP  %>FB,P14
     FB
     0E
C06A A4 ORP   %>04,P14
     04
     0E
C06D CA DJNZ  B,ED          [C05C]
     ED
C06F B7 SWAP  A
C070 B7 SWAP  A
C071 A4 ORP   %>02,P14
     02
     0E
C074 A3 ANDP  %>F9,P14
     F9
     0E
C077 A4 ORP   %>09,P14
     09
     0E
C07A A4 ORP   %>04,P14
     04
     0E
C07D 0A RETS

C07E A7 BTJZP %>04,P14,FC   [C07E]
     04
     0E
     FC
C082 A6 BTJOP %>01,P14,FC   [C082]
     01
     0E
     FC
C086 0A RETS

C087 8E CALL  @>C24C
     C2
     4C
C08A 77 BTJZ  %>04,R49,F8   [C086] Test if flag 74 is reset
     04
     31
     F8
C08E 74 OR    %>04,R49      Set flag 74
     04
     31
C091 88 MOVD  %>0256,R1     SBA 256
     02                     Update the indicators
     56
     01
C095 F8 TRAP7
C096 A2 MOVP  %>0F,P14
     0F
     0E
C099 A4 ORP   %>01,P15
     01
     0F
C09C 8A LDA   @>22EC        Load MSB of address of databuffer
     22
     EC
C09F D0 MOV   A,R72
     48
C0A1 8A LDA   @>22ED        Load LSB of address of databuffer
     22
     ED
C0A4 D0 MOV   A,R73
     49
C0A6 A7 BTJZP %>04,P14,FC   [C0A6]
     04
     0E
     FC
C0AA 8A LDA   @>22F0        Load LSB of datalength
     22
     F0
C0AD D0 MOV   A,R64
     40
C0AF E2 JZ    0D            [C0BE]
     0D
C0B1 9A LDA   *R73
     49
C0B3 8E CALL  @>C054
     C0
     54
C0B6 DB DECD  R73
     49
C0B8 8E CALL  @>C07E
     C0
     7E
C0BB DA DJNZ  R64,F3        [C0B1]
     40
     F3
C0BE 76 BTJO  %>40,R49,0D   [C0CF] Test if flag 78 is set
     40
     31
     0D
C0C2 22 MOV   %>0D,A
     0D
C0C4 8E CALL  @>C054
     C0
     54
C0C7 22 MOV   %>0A,A
     0A
C0C9 8E CALL  @>C07E
     C0
     7E
C0CC 8E CALL  @>C054
     C0
     54
C0CF B5 CLR   A
C0D0 8B STA   @>22F8        Set I/O handshake to 0
     22
     F8
C0D3 8C BR    @>C27A
     C2
     7A

C0D6 22 MOV   %>04,A        I/O commandcode, WRITE
     04
C0D8 8B STA   @>22F6        Store in second byte of PAB
     22
     F6
C0DB 8A LDA   @>213A        Printer device number
     21
     3A
C0DE 2D CMP   %>12,A        Compare with PC-324
     12
C0E0 E2 JEQ   A5            [C087]
     A5
C0E2 88 MOVD  %>22F7,R73    Address of MSB of default PAB
     22
     F7
     49
C0E6 8C BR    @>F066        SBA 466
     F0                     Master I/O routine
     66

C0E9 8C BR    @>C241
     C2
     41

SBA 100
This SBA performs the ADV function

C0EC F3 TRAP12              Reset flags 35, 37, 38 and 59
C0ED D5 CLR   R93
     5D
C0EF 8C BR    @>C139
     C1
     39

C0F2 8E CALL  @>C20F        SBA 128
     C2                     Perform an I/O operation to determine if
     0F                     specified printer is connected
C0F5 77 BTJZ  %>04,R49,2D   [C126] Test if flag 74 is reset
     04
     31
     2D
C0F9 B5 CLR   A             Clear A
C0FA 8B STA   @>22EF        Make MSB of datalength in PAB 0
     22
     EF
C0FD B3 INC   A             Make A 1
C0FE 8B STA   @>22F0        Make LSB of datalength in PAB 1
     22
     F0
C101 88 MOVD  %>22EB,R1     Address of MSB of databuffer
     22
     EB
     01
C105 8B STA   @>22EC        Store MSB of address of databuffer in PAB
     22
     EC
C108 62 MOV   B,A
C109 8B STA   @>22ED        Store LSB of address of databuffer in PAB
     22
     ED
C10C 22 MOV   %>20,A        ASCII code for ' '
     20
C10E 8B STA   @>22EB        Store in databuffer
     22
     EB
C111 8E CALL  @>C0D6
     C0
     D6
C114 74 OR    %>04,R49      Set flag 74
     04
     31
C117 9A LDA   *R73          Returned statuscode
     49
C119 E2 JZ    0B            [C126]
     0B
C11B 2D CMP   %>19,A        Low batteries in peripheral
     19
C11D E2 JEQ   CA            [C0E9]
     CA
C11F 2D CMP   %>04,A        Device not open
     04
C121 E2 JEQ   CF            [C0F2]
     CF
C123 73 AND   %>FB,R49      Reset flag 74
     FB
     31
C126 0A RETS

SBA 102
This SBA performs the PRT function

C127 F3 TRAP12              Reset flags 35, 37, 38 and 59
C128 8E CALL  @>C2BE
     C2
     BE
C12B 8E CALL  @>C139
     C1
     39
C12E 76 BTJO  %>04,R49,F4   [C126] Test if flag 74 is set
     04
     31
     F4
C132 88 MOVD  %>025C,R1     SBA 25C
     02                     Perform a PAUSE
     5C
     01
C136 8C BR    @>F08D
     F0
     8D

C139 8A LDA   @>213A        Get devicecode
     21
     3A
C13C 8B STA   @>22F7        Store at MSB of PAB
     22
     F7
C13F 98 MOVD  R92,R81
     5C
     51
C142 12 MOV   R93,A
     5D
C144 E2 JZ    B3            [C0F9]
     B3
C146 B2 DEC   A
C147 4A SUB   R0,R81
     00
     51
C14A 7B SBB   %>00,R80
     00
     50
C14D 22 MOV   %>20,A        ASCII code for ' '
     20
C14F 9D CMPA  *R81
     51
C151 E6 JNE   08            [C15B]
     08
C153 D3 INC   R81
     51
C155 79 ADC   %>00,R80
     00
     50
C158 DA DJNZ  R93,F4        [C14F]
     5D
     F4
C15B 42 MOV   R93,R85
     5D
     55
C15E 98 MOVD  R92,R81
     5C
     51
C161 98 MOVD  R81,R1
     51
     01
C164 8B STA   @>22EC        Store MSB of begin of databuffer in PAB
     22
     EC
C167 62 MOV   B,A
C168 8B STA   @>22ED        Store LSB of begin of databuffer in PAB
     22
     ED
C16B 8A LDA   @>213B        Load devicewidth
     21
     3B
C16E 1D CMP   R85,A
     55
C170 E7 JL    34            [C1A6]
     34
C172 12 MOV   R85,A
     55
C174 4A SUB   R0,R81
     00
     51
C177 7B SBB   %>00,R80
     00
     50
C17A 8B STA   @>22F0        LSB of PAB datalength
     22
     F0
C17D 4A SUB   R0,R85
     00
     55
C180 B5 CLR   A
C181 8B STA   @>22EF        MSB of PAB datalength
     22
     EF
C184 8E CALL  @>C0D6
     C0
     D6
C187 74 OR    %>04,R49      Set flag 74
     04
     31
C18A 9A LDA   *R73          Returned statuscode
     49
C18C 2D CMP   %>19,A        Low batteries in peripheral
     19
C18E E2 JEQ   11            [C1A1]
     11
C190 2D CMP   %>04,A        Device not opened
     04
C192 E2 JEQ   71            [C205]
     71
C194 2D CMP   %>00,A
     00
C196 E6 JNE   8B            [C123]
     8B
C198 76 BTJO  %>FF,R85,C5   [C161]
     FF
     55
     C5
C19C 76 BTJO  %>78,R43,2A   [C1CA] Test if flag 27, 28, 29 or 30 is set
     78
     2B
     2A
C1A0 0A RETS

C1A1 74 OR    %>08,R49      Set flag 75
     08
     31
C1A4 E0 JMP   F2            [C198]
     F2
C1A6 77 BTJZ  %>40,R46,CA   [C174] Test if flag 54 is reset
     40
     2E
     CA
C1AA C0 MOV   A,B
C1AB 4A SUB   R0,R81
     00
     51
C1AE 7B SBB   %>00,R80
     00
     50
C1B1 22 MOV   %>20,A        ASCII code for ' '
     20
C1B3 9D CMPA  *R81
     51
C1B5 E2 JEQ   0C            [C1C3]
     0C
C1B7 D3 INC   R81
     51
C1B9 79 ADC   %>00,R80
     00
     50
C1BC CA DJNZ  B,F5          [C1B3]
     F5
C1BE 8A LDA   @>213B        Printer width
     21
     3B
C1C1 E0 JMP   B1            [C174]
     B1
C1C3 DB DECD  R81
     51
C1C5 D2 DEC   R85
     55
C1C7 62 MOV   B,A
C1C8 E0 JMP   B0            [C17A]
     B0

C1CA 73 AND   %>FD,R47      Reset flag 57
     FD
     2F
C1CD 77 BTJZ  %>01,R50,10   [C1E1] Test if flag 80 is reset
     01
     32
     10
C1D1 88 MOVD  %>224B,R81    Address of source
     22
     4B
     51
C1D5 88 MOVD  %>224F,R83    Address of destination
     22
     4F
     53
C1D9 88 MOVD  %>0010,R85    Number of bytes to move, 16
     00
     10
     55
C1DD F7 TRAP8               Move block
C1DE 7A SUB   %>04,R93
     04
     5D
C1E1 7D CMP   %>11,R93
     11
     5D
C1E4 E7 JL    0F            [C1F5]
     0F
C1E6 74 OR    %>02,R47      Set flag 57
     02
     2F
C1E9 4A SUB   R93,R92
     5D
     5C
C1EC 7B SBB   %>00,R91
     00
     5B
C1EF 78 ADD   %>10,R92
     10
     5C
C1F2 79 ADC   %>00,R91
     00
     5B
C1F5 88 MOVD  %>0256,R1     SBA 256
     02                     Update the indicators
     56
     01
C1F9 F8 TRAP7
C1FA B5 CLR   A
C1FB 8B STA   @>2104        Cursor
     21
     04
C1FE 88 MOVD  %>0260,R1     SBA 260
     02
     60
     01
C202 8C BR    @>F08D
     F0
     8D

C205 8E CALL  @>C20F        SBA 128
     C2                     Perform an I/O operation to determine if
     0F                     specified printer is connected
C208 77 BTJZ  %>04,R49,94   [C1A0] Test if flag 74 is reset
     04
     31
     94
C20C 8C BR    @>C15B
     C1
     5B

SBA 128
Performs an I/O operation, to determine if the printer specified by <DEV> is
connected

C20F 52 MOV   %>0E,B        Number of bytes to move, 14
     0E
C211 AA LDA   @>C26B(B)     Source of data
     C2                     Data: Printer PAB
     6B
C214 AB STA   @>22E8(B)     Destination, SR 2109 and 2110
     22
     E8
C217 CA DJNZ  B,F8          [C211] Loop until done
     F8
C219 8A LDA   @>213A        Load the device number
     21
     3A
C21C 8B STA   @>22F7        Store in PAB
     22
     F7
C21F 2D CMP   %>12,A        Compare devicenumber with 12, PC-324
     12
C221 E2 JEQ   29            [C24C]
     29
C223 8E CALL  @>C0E2
     C0
     E2
C226 8A LDA   @>22EB        LSB of returned buffersize
     22
     EB
C229 8B STA   @>22F2        Store in PAB
     22
     F2
C22C 8A LDA   @>22EA        MSB of returned buffersize
     22
     EA
C22F 8B STA   @>22F1        Store in PAB
     22
     F1
C232 73 AND   %>FB,R49      Reset flag 74
     FB
     31
C235 9A LDA   *R73          Returned status
     49
C237 E2 JZ    0C            [C245]
     0C
C239 2D CMP   %>05,A        Device already open
     05
C23B E2 JEQ   0B            [C248]
     0B
C23D 2D CMP   %>19,A        Low batteries in peripheral
     19
C23F E6 JNE   03            [C244]
     03
C241 74 OR    %>08,R49      Set flag 75
     08
     31
C244 0A RETS

C245 73 AND   %>F7,R49      Reset flag 75
     F7
     31
C248 74 OR    %>04,R49      Set flag 74
     04
     31
C24B 0A RETS

C24C 80 MOVP  P15,A
     0F
C24E 8B STA   @>22F8
     22
     F8
C251 80 MOVP  P14,A
     0E
C253 8B STA   @>22F9
     22
     F9
C256 74 OR    %>04,R49      Set flag 74
     04
     31
C259 88 MOVD  %>0256,R1     SBA 256
     02                     Update the indicators
     56
     01
C25D F8 TRAP7
C25E A2 MOVP  %>00,P15
     00
     0F
C261 A7 BTJZP %>02,P15,37   [C29C]
     02
     0F
     37
C265 22 MOV   %>27,A
     27
C267 8E CALL  @>C27A
     C2
     7A
C26A E0 JMP   C6            [C232]
     C6

     Printer PAB

C26C 80 Device option (Output mode)
C26D 00 Requested buffer size (MSB)
C26E 50 Requested buffer size (LSB)
C26F 22 Buffer pointer (MSB)
C270 EB Buffer pointer (LSB)
C271 00 Returned status
C272 00 Data length    (MSB)
C273 03 Data length    (LSB)
C274 00 Buffer size    (MSB)
C275 04 Buffer size    (LSB)
C276 00 Record number  (MSB)
C277 00 Record number  (LSB)
C278 00 LUNO
C279 00 Command Code   (00 = Open)

C27A 8B STA   @>22EE
     22
     EE
C27D 88 MOVD  %>22EE,R73
     22
     EE
     49
C281 A2 MOVP  %>00,P15
     00
     0F
C284 8A LDA   @>22F8
     22
     F8
C287 27 BTJZ  %>01,A,08     [C292]
     01
     08
C28A 8A LDA   @>22F9
     22
     F9
C28D 82 MOVP  A,P14
     0E
C28F A4 ORP   %>01,P15
     01
     0F
C292 73 AND   %>FB,R49      Reset flag 74
     FB
     31
C295 88 MOVD  %>0256,R1     SBA 256
     02                     Update the indicators
     56
     01
C299 8C BR    @>F08D
     F0
     8D

C29C A7 BTJZP %>01,P15,0C   [C2AC]
     01
     0F
     0C
C2A0 A4 ORP   %>01,P15
     01
     0F
C2A3 B0 CLRC
C2A4 A3 ANDP  %>FE,P15
     FE
     0F
C2A7 B0 CLRC
C2A8 A6 BTJOP %>01,P15,B9   [C265]
     01
     0F
     B9
C2AC A2 MOVP  %>0F,P14
     0F
     0E
C2AF A4 ORP   %>01,P15
     01
     0F
C2B2 22 MOV   %>FF,A
     FF
C2B4 A6 BTJOP %>02,P14,AF   [C267]
     02
     0E
     AF
C2B8 B5 CLR   A
C2B9 8B STA   @>22F8
     22
     F8
C2BC E0 JMP   A9            [C267]
     A9
C2BE 73 AND   %>FE,R50      Reset flag 80
     FE
     32
C2C1 88 MOVD  %>218F,R92    Address of first character in user alpha
     21                     register
     8F
     5C
C2C5 72 MOV   %>50,R93      Length of user alpha register
     50
     5D
C2C8 76 BTJO  %>40,R47,43   [C30F] Test if flag 62 is set
     40
     2F
     43
C2CC 72 MOV   %>10,R93      Length of system alpha register
     10
     5D
C2CF 88 MOVD  %>219F,R92    Address of first character in system alpha
     21                     register
     9F
     5C
C2D3 76 BTJO  %>20,R47,38   [C30F] Test if flag 61 is set
     20
     2F
     38
C2D7 73 AND   %>FE,R50      Reset flag 80
     FE
     32
C2DA 88 MOVD  %>022A,R1     SBA 22A
     02
     2A
     01
C2DE F8 TRAP7
C2DF 88 MOVD  %>022C,R1     SBA 22C
     02
     2C
     01
C2E3 F8 TRAP7
C2E4 76 BTJO  %>01,R45,20   [C308] Test if flag 40 is set
     01
     2D
     20
C2E8 88 MOVD  %>2240,R81    Source of data, the printer/display buffer
     22
     40
     51
C2EC 88 MOVD  %>223C,R83    Destination of data
     22
     3C
     53
C2F0 88 MOVD  %>0010,R85    Number of bytes to move, 16
     00
     10
     55
C2F4 8E CALL  @>F096        SBA 496
     F0                     Move block
     96
C2F7 22 MOV   %>20,A        ASCII code for ' '
     20
C2F9 8B STA   @>224F         Fill the last 4 positions of the
     22                        printer/display buffer with blanks
     4F                      
C2FC 8B STA   @>224E         
     22                      
     4E                      
C2FF 8B STA   @>224D         
     22                      
     4D                      
C302 8B STA   @>224C         
     22                      
     4C                     
C305 74 OR    %>01,R50      Set flag 80
     01
     32
C308 88 MOVD  %>224F,R92
     22
     4F
     5C
C30C 72 MOV   %>14,R93
     14
     5D
C30F 0A RETS

SBA 104
This SBA performs the WB function

C310 76 BTJO  %>78,R43,06   [C31A] Test if flag 27, 28, 29 or 30 is set
     78
     2B
     06
C314 74 OR    %>80,R50      Set flag 87
     80
     32
C317 8E CALL  @>C603        SBA 11C
     C6
     03
C31A 73 AND   %>BF,R46      Reset flag 54
     BF
     2E
C31D 76 BTJO  %>40,R44,03   [C324] Test if flag 38 is set
     40
     2C
     03
C321 74 OR    %>40,R46      Set flag 54
     40
     2E
C324 F3 TRAP12              Reset flags 35, 37, 38 and 59
C325 0A RETS

SBA 140
This SBA is used by the keystroke functions to display data. If the user
presses HLT or BRK during the listing, it executes the instruction following
this SBA, usually a GTO.

C326 88 MOVD  %>0262,R1     SBA 262
     02                     Scan for BRK or HLT. If neither of them is found
     62                     the next keystroke instruction is skipped
     01
C32A F8 TRAP7
C32B 8E CALL  @>C2BE
     C2
     BE

SBA 12A
This SBA is used to control the time a value remains in the display.
 - if the user doesn't press any keys, the value will remain in the display for
   approximately 1 second
 - if the user presses AND holds the -> key, the value will remain in the
   display indefinitely
 - if the user presses the -> key and releases quickly, the value will appear
   only for a short while

C32E 8E CALL  @>C139
     C1
     39
C331 76 BTJO  %>04,R49,21   [C356] Test if flag 74 is set
     04
     31
     21
C335 8E CALL  @>C1F5
     C1
     F5
C338 88 MOVD  %>0280,R1     SBA 280
     02                     Set the address of INT 2 to TRAP 3 [= >FF63]
     80
     01
C33C F8 TRAP7
C33D 72 MOV   %>1E,R69      Initial number of loops for 1 second
     1E
     45
C340 22 MOV   %>9F,A        Timer control : 1 0 0 11111
     9F
C342 52 MOV   %>8C,B        Interrupt mask: 10 00 11 00
     8C
C344 8E CALL  @>F093        SBA 493
     F0                     Start the timer and wait for an interrupt
     93
C347 88 MOVD  %>1040,R1     Values to scan for ->
     10
     40
     01
C34B 8E CALL  @>F05A        SBA 45A
     F0                     Scan for (a) specific key(s) to be pressed
     5A
C34E E2 JZ    03            [C353] Zero?, -> was not pressed
     03
C350 72 MOV   %>02,R69      Set counter to 2, to make sure that value remains
     02                     displayed as long as the user presses ->
     45
C353 DA DJNZ  R69,EA        [C340]
     45
     EA
C356 0A RETS

C357 8A LDA   @>22DD         MSB and LSB of end address of program or
     22                        registers to be saved. The LSB of the address
     DD                        is always a multiple of 8 MINUS 1
C35A D0 MOV   A,R80          
     50                      
C35C 8A LDA   @>22DE         
     22                      
     DE                      
C35F D0 MOV   A,R81          
     51                     
C361 8A LDA   @>22DB         MSB and LSB of size of program or registes
     22                        to be saved. The size is always rounded to
     DB                        the next multiple of 8
C364 D0 MOV   A,R84          
     54                      
C366 8A LDA   @>22DC         
     22                      
     DC                      
C369 D0 MOV   A,R85          
     55                     
C36B 0A RETS

C36C 88 MOVD  %>BFF3,R65    Address of LSB of used space byte in directory
     BF                     of a cartridge
     F3
     41
C370 88 MOVD  %>4000,R83    Address of bottom of cartridge
     40
     00
     53
C374 8A LDA   @>2090
     20
     90
C377 E6 JNZ   14            [C38D]
     14
C379 8A LDA   @>20B5        LSB of begin address of programmemory
     20
     B5
C37C D0 MOV   A,R65
     41
C37E 8A LDA   @>20B4        MSB of begin address of programmemory
     20
     B4
C381 D0 MOV   A,R64
     40
C383 7A SUB   %>05,R65
     05
     41
C386 7B SBB   %>00,R64
     00
     40
C389 88 MOVD  %>23E0,R83    Begin address of internal File Space
     23
     E0
     53
C38D 0A RETS

SBA 10A
This SBA is used to store a file in File Space

Input:
>2090     : 0 - store in MEM
            1 - store in NEW
>22D8-22DA: Reversed filename
>22DB-22DC: Size of program or data to be saved
>22DD-22DE: High address of program or data

Output:
File saved

C38E 8E CALL  @>C357        Retrieve high address and size of program/data
     C3                     to be saved
     57
C391 8E CALL  @>C36C        Retrieve address of begin of File Space and of
     C3                     LSB of used space indicator of directory
     6C
C394 8E CALL  @>C3ED        Store used space in a/b
     C3
     ED
C397 38 ADD   R85,B          Add length of data to used space
     55                      
C399 19 ADC   R84,A          
     54                     
C39B 98 MOVD  R1,R67        Save
     01
     43
C39E CB DECD  B              Determine high address of file to be saved
C39F 48 ADD   R1,R83         
     01                      
     53                      
C3A2 49 ADC   R0,R82         
     00                      
     52                     
C3A5 98 MOVD  R85,R69       Save length
     55
     45
C3A8 F7 TRAP8               Move block [= Save file]
C3A9 98 MOVD  R67,R1        Get new used space back
     43
     01
C3AC ED TRAP18              Store new used space in directory
C3AD EB TRAP20              Get the old free space
C3AE 3A SUB   R69,B          Subtract length of new file
     45                      
C3B0 1B SBB   R68,A          
     44                     
C3B2 5A SUB   %>08,B         Subtract 8 for directory entry
     08                      
C3B4 2B SBB   %>00,A         
     00                     
C3B6 ED TRAP18              Store new free space in directory
C3B7 EB TRAP20              Get the old number of files
C3B8 C3 INC   B              Add one file
C3B9 29 ADC   %>00,A         
     00                     
C3BB 98 MOVD  R1,R67        Save
     01
     43
C3BE ED TRAP18              Store new number of files in directory
C3BF 98 MOVD  R67,R1        Get number of file back
     43
     01
C3C2 8E CALL  @>C543        Multiply by 8
     C5
     43
C3C5 4A SUB   R1,R65         Find address of directory entry for new file
     01                      
     41                      
C3C8 4B SBB   R0,R64         
     00                      
     40                     
C3CB 52 MOV   %>FD,B         Store filename in directory
     FD                      
C3CD AA LDA   @>21DB(B)      
     21                      
     DB                      
C3D0 9B STA   *R65           
     41                      
C3D2 DB DECD  R65            
     41                      
C3D4 C3 INC   B              
C3D5 E6 JNZ   F6             [C3CD]
     F6
C3D7 12 MOV   R69,A          Store length of file in directory and fill
     45                        the three left-over bytes with zeroes
C3D9 9B STA   *R65           
     41                      
C3DB 12 MOV   R68,A          
     44                      
C3DD 52 MOV   %>04,B         
     04                      
C3DF DB DECD  R65            
     41                      
C3E1 9B STA   *R65           
     41                      
C3E3 B5 CLR   A              
C3E4 CA DJNZ  B,F9           [C3DF]
     F9
C3E6 0A RETS

TRAP 20
This TRAP is used to store the contents of R64/65 into the directory of File
Space

C3E7 78 ADD   %>02,R65
     02
     41
C3EA 79 ADC   %>00,R64
     00
     40
C3ED 9A LDA   *R65
     41
C3EF C0 MOV   A,B
C3F0 DB DECD  R65
     41
C3F2 9A LDA   *R65
     41
C3F4 0A RETS

TRAP 18
This TRAP is used to retrieve two bytes of information [Free space, used space
and number of files] from the directory of File Space

C3F5 9B STA   *R65
     41
C3F7 D3 INC   R65
     41
C3F9 79 ADC   %>00,R64
     00
     40
C3FC 62 MOV   B,A
C3FD 9B STA   *R65
     41
C3FF 0A RETS

SBA 136
This SBA sets the value of the "TMPORT" [>2090], according to the following
table:

MEM     Y  Y  N    If there is no in- and external FS, TMPORT retains its
NEW     Y  N  Y    old value. If there is FS, the instruction following
Ĵ   this SBA is skipped. This SBA modifies the signature at
TMPORT  2  0  1    >BFFF to select between ROM and RAM cartridges

C400 88 MOVD  %>038C,R1     SBA 38C
     03                     Check for, and if necessary initialize,
     8C                     a RAM cartridge
     01
C404 F8 TRAP7
C405 D5 CLR   R64
     40
C407 62 MOV   B,A
C408 E6 JNZ   22            [C42C] Non-zero indicates no cartridge
     22
C40A 8B STA   @>BFFF
     BF
     FF
C40D 8D CMPA  @>BFFF
     BF
     FF
C410 E6 JNE   1A            [C42C] Not equal indicates ROM
     1A
C412 22 MOV   %>6A,A        Cartridge signature
     6A
C414 8B STA   @>BFFF
     BF
     FF
C417 E0 JMP   10            [C429]
     10

SBA 108
This SBA sets the value of the "TMPORT" [>2090], according to the following
table:

MEM     Y  Y  N    If there is no in- and external FS, TMPORT retains its
NEW     Y  N  Y    old value. If there is FS, the instruction following
Ĵ   this SBA is skipped. This SBA uses the type-byte at
TMPORT  2  0  1    >BFFB to select between ROM and RAM cartridges

C419 88 MOVD  %>038C,R1     SBA 38C
     03                     Check for, and if necessary initialize,
     8C                     a RAM cartridge
     01
C41D F8 TRAP7
C41E D5 CLR   R64
     40
C420 C1 TSTB
C421 E6 JNZ   09            [C42C] Non-zero indicates no cartridge
     09
C423 8A LDA   @>BFFB        Cartridge info byte
     BF
     FB
C426 26 BTJO  %>20,A,03     [C42C] Bit 5 set indicates a ROM
     20
     03
C429 72 MOV   %>02,R64
     02
     40
C42C 88 MOVD  %>23E0,R1     Begin address of user memory
     23
     E0
     01
C430 8D CMPA  @>20B4        MSB of address of begin of programarea
     20
     B4
C433 E6 JNE   06            [C43B] Not equal?, there is internal FS
     06
C435 62 MOV   B,A           LSB of address of begin of programarea
C436 8D CMPA  @>20B5
     20
     B5
C439 E2 JEQ   0C            [C447] Equal?, NO internal FS present
     0C
C43B 12 MOV   R64,A
     40
C43D 8B STA   @>2090
     20
     90
C440 88 MOVD  %>038E,R1     SBA 38E
     03                     Skip the next instruction in the keystroke
     8E                     program
     01
C444 8C BR    @>F08D
     F0
     8D

C447 D2 DEC   R64           >00 to >FF, no carry
     40
C449 E3 JC    F0            [C43B]
     F0
C44B 0A RETS

SBA 10C
This SBA searches for a file. If it is not found, the instruction following it
is skipped.

Input:
>2090: 0 - search MEM
       1 - search NEW
>22DA: 1st character of filename
>22D9: 2nd character of filename
>22D8: 3rd character of filename

Output:
               MSB  LSB
Fileaddress: >2054-2055  [Also in R80/81]
Filesize   : >2056-2057
Filenum    : >2091-2092  [Also in R78/79]

C44C 88 MOVD  %>039A,R1     SBA 39A
     03                     Search for a file
     9A
     01
C450 F8 TRAP7
C451 77 BTJZ  %>80,R48,EB   [C440] Test if flag 71 is reset
     80
     30
     EB
C455 12 MOV   R78,A
     4E
C457 8B STA   @>2091        MSB of filenum
     20                     Last file in directory: 0
     91
C45A 12 MOV   R79,A
     4F
C45C 8B STA   @>2092        LSB of filenum
     20
     92
C45F 12 MOV   R80,A
     50
C461 8B STA   @>2054        MSB of beginaddress of file in FS
     20
     54
C464 12 MOV   R81,A
     51
C466 8B STA   @>2055        LSB of beginaddress of file in FS
     20
     55
C469 0A RETS

C46A 8A LDA   @>2057        Load LSB of filesize
     20
     57
C46D D0 MOV   A,R81         Save
     51
C46F 8A LDA   @>2056        Load MSB of filesize
     20
     56
C472 D0 MOV   A,R80         Save
     50
C474 8A LDA   @>22DC         Length of file to be saved, or 0000 if file
     22                        has to be deleted
     DC                      
C477 C0 MOV   A,B            
C478 8A LDA   @>22DB         
     22                      
     DB                     
C47B 3A SUB   R81,B          Size of file to be saved - size of original
     51                        file
C47D 1B SBB   R80,A          
     50                     
C47F 98 MOVD  R1,R69        Save
     01
     45
C482 8A LDA   @>2055        Load LSB of address of begin of file
     20
     55
C485 C0 MOV   A,B
C486 8A LDA   @>2054        Load MSB of address of begin of file
     20
     54
C489 48 ADD   R1,R81         Address of end of file
     01                      
     51                      
C48C 49 ADC   R0,R80         
     00                      
     50                     

Flag 28 indicates that a program is running in File Space. In this case it may
be necessary to update the PC. The PC is updated if the program is located
after the file to be deleted. If PC is in the file to be deleted, the program
will continue into the file located after it!

C48F 77 BTJZ  %>10,R43,28   [C4BB] Test if flag 28 is reset
     10
     2B
     28
C493 7D CMP   %>40,R118     MSB PC
     40
     76
C496 E7 JL    05            [C49D] PC < 4000h?, program running in MEM
     05

At this point the program is running in a cartridge

C498 7D CMP   %>40,R80      EOF
     40
     50
C49B E7 JL    1E            [C4BB] EOF < 4000h?, no update necessary
     1E

Common segment for program running in in- or external File Space

C49D 4D CMP   R80,R118      EOF / MSB PC
     50
     76
C4A0 E7 JL    19            [C4BB] PC < EOF?, no update necessary
     19
C4A2 E6 JNE   05            [C4A9] PC <> EOF & PC > EOF?, update
     05
C4A4 4D CMP   R81,R119      EOF / LSB PC
     51
     77
C4A7 E7 JL    12            [C4BB] PC < EOF?, no update necessary
     12
C4A9 48 ADD   R69,R115       Update LOW PC
     45                      
     73                      
C4AC 49 ADC   R68,R114       
     44                      
     72                     
C4AF 48 ADD   R69,R119       Update RUN PC
     45                      
     77                      
C4B2 49 ADC   R68,R118       
     44                      
     76                     
C4B5 48 ADD   R69,R117       Update HIGH PC
     45                      
     75                      
C4B8 49 ADC   R68,R116       
     44                      
     74                     
C4BB 8E CALL  @>C36C        Put beginaddress of File Space in R82/83
     C3
     6C
C4BE 8E CALL  @>C3ED        Retrieve the used space into a/b
     C3
     ED
C4C1 48 ADD   R1,R83         Calculate address of first byte of free
     01                        space in file space
     53                      
C4C4 49 ADC   R0,R82         
     00                      
     52                     
C4C7 38 ADD   R69,B          Calculate new used space
     45                      
C4C9 19 ADC   R68,A          
     44                     
C4CB ED TRAP18              Store new used space in directory
C4CC 98 MOVD  R83,R85
     53
     55
C4CF DB DECD  R83
     53
C4D1 4A SUB   R81,R85
     51
     55
C4D4 4B SBB   R80,R84
     50
     54
C4D7 E7 JNC   59            [C532]
     59
C4D9 77 BTJZ  %>80,R68,0C   [C4E9] Negative?, new file > old file
     80
     44
     0C
C4DD 98 MOVD  R81,R83       Ŀ
     51                      OLD     Ŀ
     53                               NEW 
C4E0 48 ADD   R69,R83                     
     45                                   
     53                     Ĵ         
C4E3 49 ADC   R68,R82                Ĵ
     44                     Ĵ    Ĵ
     52                         
C4E6 8C BR    @>F096        SBA 496
     F0                     Move block
     96

C4E9 12 MOV   R69,A
     45
C4EB 14 OR    R68,A
     44
C4ED E2 JZ    43            [C532] No move needed if size of new file equals
     43                            size of old file
C4EF 98 MOVD  R83,R81                  Ŀ
     53                     Ŀ     NEW 
     51                      OLD          
C4F2 48 ADD   R69,R83                     
     45                                   
     53                              Ĵ
C4F5 49 ADC   R68,R82       Ĵ         
     44                     Ĵ    Ĵ
     52                         
C4F8 8C BR    @>F051        SBA 451
     F0                     Move block
     51

SBA 10E
This SBA is used to replace a file in File Space

Input:
>2090     : 0 - replace file in MEM
            1 - replace file in NEW
>2054-2055: Address of begin of file to be replaced
>2056-2057: Original size of file to be replaced
>2091-2092: Filenum
>22DB-22DC: Size of program or data to be saved
>22DD-22DE: High address of program or data

Output:
File replaced

C4FB 8E CALL  @>C46A        Create space for new file
     C4
     6A
C4FE 8E CALL  @>C357        Retrieve high address and size of program/data
     C3                     to be saved
     57
C501 98 MOVD  R85,R67       Save size
     55
     43
C504 8A LDA   @>2055        LSB address of begin of file
     20
     55
C507 C0 MOV   A,B
C508 8A LDA   @>2054        MSB address of begin of file
     20
     54
C50B 38 ADD   R85,B
     55
C50D 19 ADC   R84,A
     54
C50F CB DECD  B
C510 98 MOVD  R1,R83        Destination
     01
     53
C513 F7 TRAP8               Move block [= replace file]
C514 EB TRAP20              Get the old free space
C515 3A SUB   R69,B          Subtract the difference between the old file
     45                        and the replacement
C517 1B SBB   R68,A          
     44                     
C519 ED TRAP18              Store the new free space in the directory
C51A EB TRAP20              Get the number of files
C51B 8E CALL  @>C533        Subtract the filenum from the number of files and
     C5                     multiply the result with 8
     33
C51E 4A SUB   R1,R65         Calculate the address of the directory entry
     01                        of the file
     41                      
C521 4B SBB   R0,R64         
     00                      
     40                     
C524 DB DECD  R65            Address of filesize
     41                      
C526 DB DECD  R65            
     41                     
C528 12 MOV   R67,A         LSB of size
     43
C52A 9B STA   *R65          Store in directory
     41
C52C 12 MOV   R66,A         MSB of size
     42
C52E DB DECD  R65
     41
C530 9B STA   *R65          Store in directory
     41
C532 0A RETS

C533 B8 PUSH  A
C534 8A LDA   @>2092        LSB of filenum
     20
     92
C537 D0 MOV   A,R69
     45
C539 8A LDA   @>2091        MSB of filenum
     20
     91
C53C D0 MOV   A,R68
     44
C53E B9 POP   A
C53F 3A SUB   R69,B
     45
C541 1B SBB   R68,A
     44
C543 B0 CLRC
C544 CF RLC   B
C545 BF RLC   A
C546 CF RLC   B
C547 BF RLC   A
C548 CF RLC   B
C549 BF RLC   A
C54A 0A RETS

SBA 110
This SBA is used to read a file back into memory

Input:
>2090     : 0 - read from MEM
            1 - read from NEW
>2054-2055: Address of begin of file
>2056-2057: Size of file
>22DD-22DE: High address of destination

Output:
File read

C54B 8A LDA   @>22DE
     22
     DE
C54E D0 MOV   A,R83         LSB of address of destination
     53
C550 8A LDA   @>22DD
     22
     DD
C553 D0 MOV   A,R82         MSB of address of destination
     52
C555 8A LDA   @>2057        Filesize [LSB]
     20
     57
C558 D0 MOV   A,R85
     55
C55A 8A LDA   @>2056        Filesize [MSB]
     20
     56
C55D D0 MOV   A,R84
     54
C55F 8A LDA   @>2055
     20
     55
C562 D0 MOV   A,R81         Absolute address of file [LSB]
     51
C564 8A LDA   @>2054
     20
     54
C567 D0 MOV   A,R80         Absolute address of file [MSB]
     50
C569 48 ADD   R85,R81
     55
     51
C56C 49 ADC   R84,R80
     54
     50
C56F DB DECD  R81
     51
C571 8C BR    @>F051        SBA 451
     F0                     Move block
     51

SBA 112
This SBA is used to delete a file in File Space

Input:
>2090     : 0 - delete from MEM
            1 - delete from NEW
>2054-2055: Address of begin of file to be deleted
>2056-2057: Size of file to be deleted
>2091-2092: Filenum

Output:
File deleted

C574 B5 CLR   A
C575 8B STA   @>22DC         Size of "new" file, 0 bytes
     22                      
     DC                      
C578 8B STA   @>22DB         
     22                      
     DB                     
C57B 8E CALL  @>C46A        Delete the old file
     C4
     6A
C57E EB TRAP20              Get the old free space
C57F 3A SUB   R69,B          Subtract the negative size of the old file
     45                      
C581 1B SBB   R68,A          
     44                     
C583 58 ADD   %>08,B         Add 8 bytes for directory entry
     08                      
C585 29 ADC   %>00,A         
     00                     
C587 ED TRAP18              Store new free space in directory
C588 EB TRAP20              Get the old number of files
C589 98 MOVD  R1,R67        Save
     01
     43
C58C CB DECD  B             Subtract one file
C58D ED TRAP18              Store new number of files in directory
C58E 98 MOVD  R67,R1
     43
     01
C591 8E CALL  @>C533         Calculate address of directory entry that has
     C5                        to be deleted
     33                      
C594 4A SUB   R1,R65         
     01                      
     41                      
C597 4B SBB   R0,R64         
     00                      
     40                     
C59A 98 MOVD  R65,R83       Destination
     41
     53
C59D 98 MOVD  R65,R81        Source, address of next directory entry
     41                      
     51                      
C5A0 7A SUB   %>08,R81       
     08                      
     51                      
C5A3 7B SBB   %>00,R80       
     00                      
     50                     
C5A6 98 MOVD  R69,R1        File number
     45
     01
C5A9 8E CALL  @>C543        Multiply by 8
     C5
     43
C5AC 98 MOVD  R1,R85        Number of bytes to move up
     01
     55
C5AF 8C BR    @>F051        SBA 451
     F0                     Move block
     51

SBA 120

C5B2 76 BTJO  %>08,R43,5E   [C614] Test if flag 27 is set
     08
     2B
     5E
C5B6 73 AND   %>FE,R50      Reset flag 80
     FE
     32
C5B9 88 MOVD  %>026A,R1     SBA 26A
     02                     Fill the first 20 positions of the PD buffer
     6A                     with blanks
     01
C5BD F8 TRAP7
C5BE 52 MOV   %>06,B         Move the first 6 characters from the user
     06                        alpha register [=<DIR><FIL>] to the PD buffer
C5C0 AA LDA   @>2189(B)      
     21                      
     89                      
C5C3 AB STA   @>2249(B)      
     22                      
     49                      
C5C6 CA DJNZ  B,F8           [C5C0]
     F8
C5C8 E0 JMP   39            [C603]
     39
C5CA 77 BTJZ  %>10,R48,47   [C615] Test if flag 68 is reset
     10
     30
     47
C5CE 77 BTJZ  %>10,R50,06   [C5D8] Test if flag 84 is reset
     10
     32
     06
C5D2 8E CALL  @>C2D7
     C2
     D7
C5D5 8E CALL  @>C62A
     C6
     2A
C5D8 76 BTJO  %>20,R50,59   [C635] Test if flag 85 is set
     20
     32
     59
C5DC 73 AND   %>FE,R50      Reset flag 80
     FE
     32
C5DF 88 MOVD  %>026A,R1     SBA 26A
     02                     Fill the first 20 positions of the PD buffer
     6A                     with blanks
     01
C5E3 F8 TRAP7
C5E4 52 MOV   %>4F,B
     4F
C5E6 76 BTJO  %>08,R50,08   [C5F2] Test if flag 83 is set
     08
     32
     08
C5EA 77 BTJZ  %>40,R44,04   [C5F2] Test if flag 38 is reset
     40
     2C
     04
C5EE 8E CALL  @>C6BF
     C6
     BF
C5F1 C2 DEC   B
C5F2 88 MOVD  %>2053,R81
     20
     53
     51
C5F6 8E CALL  @>C6C3
     C6
     C3
C5F9 C2 DEC   B
C5FA 62 MOV   B,A
C5FB 8B STA   @>2050
     20
     50
C5FE 7D CMP   %>D5,R36      Instructioncode for SF, first field instruction
     D5
     24
C601 E3 JHS   32            [C635]
     32

SBA 11C

C603 88 MOVD  %>224F,R92    Begin address of PD buffer
     22
     4F
     5C
C607 72 MOV   %>10,R93
     10
     5D
C60A 76 BTJO  %>70,R43,02   [C610] Test if flag 28, 29 or 30 is set
     70
     2B
     02
C60E E0 JMP   3C            [C64C]
     3C
C610 76 BTJO  %>10,R48,50   [C664] Test if flag 68 is set
     10
     30
     50
C614 0A RETS

C615 76 BTJO  %>70,R43,1C   [C635] Test if flag 28, 29 or 30 is set
     70
     2B
     1C
C619 E0 JMP   BD            [C5D8]
     BD

SBA 116

C61B 77 BTJZ  %>10,R48,16   [C635] Test if flag 68 is reset
     10
     30
     16
C61F 77 BTJZ  %>80,R50,12   [C635] Test if flag 87 is reset
     80
     32
     12
C623 76 BTJO  %>20,R48,0E   [C635] Test if flag 69 is set
     20
     30
     0E
C627 8E CALL  @>C2BE
     C2
     BE
C62A 8E CALL  @>C139
     C1
     39
C62D 76 BTJO  %>04,R49,04   [C635] Test if flag 74 is set
     04
     31
     04
C631 76 BTJO  %>70,R43,3D   [C672] Test if flag 28, 29 or 30 is set
     70
     2B
     3D
C635 0A RETS

SBA 114

C636 76 BTJO  %>08,R43,FB   [C635] Test if flag 27 is set
     08
     2B
     FB
C63A 77 BTJZ  %>40,R50,8C   [C5CA] Test if flag 86 is reset
     40
     32
     8C
C63E 77 BTJZ  %>10,R48,03   [C645] Test if flag 68 is reset
     10
     30
     03
C642 8E CALL  @>C6A0
     C6
     A0
C645 76 BTJO  %>70,R43,14   [C65D] Test if flag 28, 29 or 30 is set
     70
     2B
     14
C649 8E CALL  @>C67C
     C6
     7C
C64C 77 BTJZ  %>10,R48,03   [C653] Test if flag 68 is reset
     10
     30
     03
C650 8E CALL  @>C139
     C1
     39
C653 76 BTJO  %>01,R50,03   [C65A] Test if flag 80 is set
     01
     32
     03
C657 72 MOV   %>10,R93
     10
     5D
C65A 8C BR    @>C1CA
     C1
     CA

C65D 77 BTJZ  %>10,R48,D4   [C635] Test if flag 68 is reset
     10
     30
     D4
C661 8E CALL  @>C67C
     C6
     7C
C664 8E CALL  @>C139
     C1
     39
C667 76 BTJO  %>04,R49,CA   [C635] Test if flag 74 is set
     04
     31
     CA
C66B 76 BTJO  %>01,R50,03   [C672] Test if flag 80 is set
     01
     32
     03
C66F 72 MOV   %>10,R93
     10
     5D
C672 8E CALL  @>C1CA
     C1
     CA
C675 88 MOVD  %>0268,R1     SBA 268
     02                     Delay program execution for approximately one
     68                     second. The display is not updated
     01
C679 8C BR    @>F08D
     F0
     8D

C67C 8E CALL  @>C2D7
     C2
     D7
C67F 52 MOV   %>03,B        Number of characters to move
     03
C681 AA LDA   @>2050(B)     Load character of mnemonic
     20
     50
C684 AB STA   @>223B(B)     Store in printer/display buffer
     22
     3B
C687 CA DJNZ  B,F8          [C681] Repeat for entire mnemonic
     F8
C689 0A RETS

SBA 118

C68A 76 BTJO  %>08,R43,A7   [C635] Test if flag 27 is set
     08
     2B
     A7
C68E 77 BTJZ  %>10,R48,A3   [C635] Test if flag 68 is reset
     10
     30
     A3
C692 8E CALL  @>C6A0
     C6
     A0
C695 8E CALL  @>C67C
     C6
     7C
C698 8E CALL  @>C139
     C1
     39
C69B 76 BTJO  %>70,R43,C8   [C667] Test if flag 28, 29 or 30 is set
     70
     2B
     C8
C69F 0A RETS

C6A0 76 BTJO  %>08,R50,91   [C635] Test if flag 83 is set
     08
     32
     91
C6A4 77 BTJZ  %>40,R44,8D   [C635] Test if flag 38 is reset
     40
     2C
     8D
C6A8 74 OR    %>01,R50      Set flag 80
     01
     32
C6AB 88 MOVD  %>026A,R1     SBA 26A
     02                     Fill the first 20 positions of the PD buffer
     6A                     with blanks
     01
C6AF F8 TRAP7
C6B0 52 MOV   %>3E,B
     3E
C6B2 8E CALL  @>C6BF
     C6
     BF

SBA 11A

C6B5 88 MOVD  %>224F,R92    Begin address of PD buffer
     22
     4F
     5C
C6B9 72 MOV   %>14,R93
     14
     5D
C6BC 8C BR    @>C62A
     C6
     2A

C6BF 88 MOVD  %>C6DB,R81    Address of 'INV'
     C6
     DB
     51
C6C3 72 MOV   %>03,R85      Number of bytes to move, 3
     03
     55
C6C6 E0 JMP   05            [C6CD]
     05
C6C8 2D CMP   %>20,A        ASCII code for ' '
     20
C6CA E6 JNE   01            [C6CD]
     01
C6CC C3 INC   B
C6CD 9A LDA   *R81
     51
C6CF AB STA   @>2200(B)
     22
     00
C6D2 C2 DEC   B
C6D3 DB DECD  R81
     51
C6D5 DA DJNZ  R85,F0        [C6C8]
     55
     F0
C6D8 0A RETS

Text for INV command:

C6D9 56 'V'
C6DA 4E 'N'
C6DB 49 'I'

SBA 13E
This SBA performs the TRC function

C6DC 74 OR    %>10,R48      Set flag 68
     10
     30
C6DF 77 BTJZ  %>40,R44,03   [C6E6] Test if flag 38 is reset
     40
     2C
     03
C6E3 73 AND   %>EF,R48      Reset flag 68
     EF
     30
C6E6 D5 CLR   R50           Reset flags 80-87
     32
C6E8 8E CALL  @>C636        SBA 114
     C6
     36
C6EB F3 TRAP12              Reset flags 35, 37, 38 and 59
C6EC 0A RETS

SBA 11E
This SBA performs the CMS function

C6ED F3 TRAP12              Reset flags 35, 37, 38 and 59
C6EE 88 MOVD  %>3FFF,R85    End address of user memory
     3F
     FF
     55
C6F2 98 MOVD  R85,R83
     55
     53
C6F5 8A LDA   @>20B3        LSB of begin address of register area
     20
     B3
C6F8 C0 MOV   A,B
C6F9 8A LDA   @>20B2        MSB of begin address of register area
     20
     B2
C6FC CB DECD  B             Decrement
C6FD 4A SUB   R1,R85         Calculate length of registerarea
     01                      
     55                      
C700 4B SBB   R0,R84         
     00                      
     54                     
C703 8C BR    @>F099        SBA 499
     F0                     Clear block
     99

SBA 122
This SBA performs the BRK function

C706 76 BTJO  %>78,R43,07   [C711] Test if flag 27, 28, 29 or 30 is set
     78
     2B
     07
C70A 8A LDA   @>22B7        Load the before-break run flags
     22
     B7
C70D E6 JNZ   28            [C737] Unequal zero?, GO already defined
     28
C70F F3 TRAP12              Reset flags 35, 37, 38 and 59
C710 0A RETS

C711 76 BTJO  %>02,R43,03   [C718] Test if flag 25 is set
     02
     2B
     03
C715 73 AND   %>FE,R43      Reset flag 24
     FE
     2B
C718 12 MOV   R43,A         Get run flags
     2B
C71A 8B STA   @>22B7        Store at save before-break flags location
     22
     B7
C71D 8B STA   @>22B6        Second copy, for use by the keystroke programmed
     22                     ROM programs
     B6
C720 88 MOVD  %>22B5,R83    Save address
     22
     B5
     53
C724 88 MOVD  %>0077,R81    Source address
     00                     Data: Begin and end address of interrupted
     77                     program and PC at interrupt
     51
C728 88 MOVD  %>0006,R85    Number of bytes to move, 6
     00
     06
     55
C72C F7 TRAP8               Move block
C72D 52 MOV   %>03,B        Number of bytes to move
     03
C72F AA LDA   @>20AC(B)     Source address
     20                     Data: Current filename
     AC
C732 AB STA   @>22B7(B)     Save address
     22
     B7
C735 CA DJNZ  B,F8          [C72F] Repeat for entire filename
     F8
C737 88 MOVD  %>0392,R1     SBA 392
     03                     Clear the system Fx keys
     92
     01
C73B F8 TRAP7
C73C 88 MOVD  %>0126,R1      Define address of F1 (SBA 126)
     01                      
     26                      
     01                      
C740 8B STA   @>20F5         
     20                      
     F5                      
C743 62 MOV   B,A            
C744 8B STA   @>20F6         
     20                      
     F6                      
C747 22 MOV   %>01,A         
     01                      
C749 8B STA   @>20F4         
     20                      
     F4                     
C74C 22 MOV   %>47,A        'G'
     47
C74E 8B STA   @>20E6        Store above F1
     20
     E6
C751 22 MOV   %>4F,A        'O'
     4F
C753 8B STA   @>20E7        Store above F1
     20
     E7
C756 74 OR    %>01,R43      Set flag 24
     01
     2B
C759 73 AND   %>FD,R43      Reset flag 25
     FD
     2B
C75C 88 MOVD  %>0352,R1     SBA 352
     03                     Perform the HLT function
     52
     01
C760 8C BR    @>F08D
     F0
     8D

SBA 124
Perform the last GO again, using a second copy of the BREAK flags. This SBA is
used by the keystroke programmed ROM functions, to restart a user-program
after casette tape operations

C763 8A LDA   @>22B6
     22
     B6
C766 8B STA   @>22B7
     22
     B7
C769 E0 JMP   08            [C773]
     08

SBA 126
This SBA performs the GO function

C76B 8E CALL  @>C603        SBA 11C
     C6
     03
C76E 88 MOVD  %>0224,R1     SBA 224
     02                     Put blanks in the LCD RAM of the Fx keys
     24
     01
C772 F8 TRAP7
C773 88 MOVD  %>0392,R1     SBA 392
     03                     Clear the system Fx keys
     92
     01
C777 F8 TRAP7
C778 73 AND   %>BF,R44      Reset flag 38
     BF
     2C
C77B 73 AND   %>F7,R47      Reset flag 59
     F7
     2F
C77E 8A LDA   @>22B7        Load the before-break run flags
     22
     B7
C781 23 AND   %>73,A        "Reset" flags 26, 27 and 31
     73
C783 73 AND   %>0C,R43      Reset flags 24, 25, 28, 29, 30 and 31
     0C
     2B
C786 48 ADD   R0,R43        Restore before-break run flags
     00
     2B
C789 88 MOVD  %>22B5,R81    Source of data
     22                     Data: Begin and end address of interrupted
     B5                     program and value of PC at interrupt
     51
C78D 88 MOVD  %>0077,R83    Destination of data
     00
     77
     53
C791 88 MOVD  %>0006,R85    Number of bytes to move, 6
     00
     06
     55
C795 F7 TRAP8               Move block
C796 52 MOV   %>03,B        Number of bytes to move
     03
C798 AA LDA   @>22B7(B)     Name of interrupted programfile
     22
     B7
C79B AB STA   @>20AC(B)     Name of running file
     20
     AC
C79E CA DJNZ  B,F8          [C798] Repeat until entire name has been restored
     F8
C7A0 B5 CLR   A
C7A1 8B STA   @>22B7        Clear the before-break run flags, to disable
     22                     the GO command
     B7
C7A4 0A RETS

C7A5 8A LDA   @>22DC        LSB of size of program/data to be saved
     22
     DC
C7A8 D0 MOV   A,R81
     51
C7AA 8A LDA   @>22DB        MSB of size of program/data to be saved
     22
     DB
C7AD D0 MOV   A,R80
     50
C7AF 8A LDA   @>22DE        LSB of address of end of program/data to be
     22                     saved
     DE
C7B2 D0 MOV   A,R83
     53
C7B4 8A LDA   @>22DD        MSB of address of end of program/data to be
     22                     saved
     DD
C7B7 D0 MOV   A,R82
     52
C7B9 0A RETS

C7BA 22 MOV   %>02,A
     02
C7BC D0 MOV   A,R84
     54
C7BE 8B STA   @>22DF
     22
     DF
C7C1 0A RETS

SBA 106
This SBA is used in the cassette I/O operations

C7C2 8A LDA   @>22DF        Operation code
     22
     DF
C7C5 E1 JN    F3            [C7BA]
     F3
C7C7 C0 MOV   A,B
C7C8 5D CMP   %>07,B
     07
C7CA E3 JHS   EE            [C7BA]
     EE
C7CC CE RL    B             Multiply by 2
C7CD AA LDA   @>C7DA(B)      Create a return address on the stack, to
     C7                        call the requested routine by means of a
     DA                        RETS
C7D0 B8 PUSH  A              
C7D1 AA LDA   @>C7DB(B)      
     C7                      
     DB                     
C7D4 B8 PUSH  A
C7D5 C5 CLR   B
C7D6 8A LDA   @>2106
     21
     06
C7D9 0A RETS                This RETS functions as a CALL!

         B   Address

C7DA C7  0    C7E8
C7DB E8
C7DC C8  1    C84C
C7DD 4C
C7DE C8  2    C820
C7DF 20
C7E0 C8  3    C839
C7E1 39
C7E2 C8  4    C81C
C7E3 1C
C7E4 C8  5    C846
C7E5 46
C7E6 C8  6    C846
C7E7 46

Entry point for SBA 106 with >22DF = 0

C7E8 72 MOV   %>84,R84
     84
     54
C7EB 88 MOVD  %>0005,R81
     00
     05
     51
C7EF 88 MOVD  %>22DC,R83
     22
     DC
     53
C7F3 8E CALL  @>F0AB        SBA 4AB
     F0
     AB
C7F6 E5 JPZ   10            [C808]
     10
C7F8 22 MOV   %>80,A
     80
C7FA 8B STA   @>2106
     21
     06
C7FD 22 MOV   %>03,A
     03
C7FF 8B STA   @>22DF
     22
     DF
C802 E0 JMP   BE            [C7C2]
     BE
C804 22 MOV   %>01,A
     01
C806 E0 JMP   02            [C80A]
     02
C808 22 MOV   %>02,A
     02
C80A 2D CMP   %>05,A
     05
C80C E7 JL    02            [C810]
     02
C80E 22 MOV   %>02,A
     02
C810 8B STA   @>22DF
     22
     DF
C813 A2 MOVP  %>0B,P14
     0B
     0E
C816 A2 MOVP  %>00,P15
     00
     0F
C819 D0 MOV   A,R84
     54
C81B 0A RETS

Entry point for SBA 106 with >22DF = 4

C81C 0E PUSHST
C81D 52 MOV   %>FF,B
     FF
C81F 08 POPST

Entry point for SBA 106 with >22DF = 2

C820 E2 JZ    E6            [C808]
     E6
C822 E1 JN    E4            [C808]
     E4
C824 8E CALL  @>C7A5
     C7
     A5
C827 57 BTJZ  %>FF,B,05     [C82F]
     FF
     05
C82A 8E CALL  @>F0AE        SBA 4AE
     F0
     AE
C82D E0 JMP   03            [C832]
     03
C82F 8E CALL  @>F0A8        SBA 4A8
     F0
     A8
C832 E5 JPZ   D6            [C80A]
     D6
C834 26 BTJO  %>04,A,D1     [C808]
     04
     D1
C837 E0 JMP   0D            [C846]
     0D

Entry point for SBA 106 with >22DF = 3

C839 E5 JPZ   CD            [C808]
     CD
C83B 8E CALL  @>C7A5
     C7
     A5
C83E 72 MOV   %>82,R84
     82
     54
C841 8E CALL  @>F0AB        SBA 4AB
     F0
     AB
C844 E5 JPZ   C2            [C808]
     C2

Entry point for SBA 106 with >22DF = 5 or 6

C846 B5 CLR   A
C847 8B STA   @>2106
     21
     06
C84A E0 JMP   BE            [C80A]
     BE

Entry point for SBA 106 with >22DF = 1

C84C E6 JNZ   BA            [C808]
     BA
C84E 88 MOVD  %>0005,R81
     00
     05
     51
C852 88 MOVD  %>0059,R83
     00
     59
     53
C856 8E CALL  @>F0AE        SBA 4AE
     F0
     AE
C859 E1 JN    06            [C861]
     06
C85B 2D CMP   %>03,A
     03
C85D E2 JEQ   EF            [C84E]
     EF
C85F E0 JMP   A9            [C80A]
     A9
C861 27 BTJZ  %>04,A,EA     [C84E]
     04
     EA
C864 88 MOVD  %>0057,R83
     00
     57
     53
C868 52 MOV   %>03,B
     03
C86A 9A LDA   *R83
     53
C86C D2 DEC   R83
     53
C86E AD CMPA  @>22D7(B)
     22
     D7
C871 E6 JNE   15            [C888]
     15
C873 CA DJNZ  B,F5          [C86A]
     F5
C875 98 MOVD  R89,R1
     59
     01
C878 8B STA   @>22DB
     22
     DB
C87B 62 MOV   B,A
C87C 8B STA   @>22DC
     22
     DC
C87F 22 MOV   %>40,A
     40
C881 8B STA   @>2106
     21
     06
C884 B5 CLR   A
C885 8C BR    @>C80A
     C8
     0A

C888 52 MOV   %>03,B
     03
C88A 72 MOV   %>57,R83
     57
     53
C88D 9A LDA   *R83
     53
C88F D2 DEC   R83
     53
C891 AB STA   @>213C(B)
     21
     3C
C894 CA DJNZ  B,F7          [C88D]
     F7
C896 8C BR    @>C804
     C8
     04

SBA 13A
This SBA is called by the SELFTESTS: menu and it is used to check the correct
functioning of an appended RAM cartridge. It does so by filling the cartridge
with data which is later read-out again.
Note that this test destroys the original contents of the cartridge!!

C899 8A LDA   @>BFFC        Load cartridge size byte
     BF
     FC
C89C D0 MOV   A,R65
     41
C89E 88 MOVD  %>BFFF,R67    Top of cartridge
     BF
     FF
     43
C8A2 42 MOV   R66,R64
     42
     40
C8A5 7A SUB   %>20,R64      Start address of 8K block
     20
     40
C8A8 8E CALL  @>C95B        Fill block with testdata
     C9
     5B
C8AB EC TRAP19              Shift ALPHA
C8AC E6 JNZ   2A            [C8D8] Non-zero?, user pressed HLT
     2A
C8AE 22 MOV   %>A5,A        Testvalue
     A5
C8B0 78 ADD   %>20,R66      Restore end of block
     20
     42
C8B3 8E CALL  @>C96C        Check the testdata
     C9
     6C
C8B6 E6 JNZ   26            [C8DE] Non-zero?, ERROR
     26
C8B8 EC TRAP19              Shift ALPHA
C8B9 E6 JNZ   1D            [C8D8] Non-zero?, user pressed HLT
     1D
C8BB 22 MOV   %>5A,A        Second value to test
     5A
C8BD 78 ADD   %>20,R66      Restore end of block
     20
     42
C8C0 8E CALL  @>C95D        Fill block with testdata
     C9
     5D
C8C3 EC TRAP19              Shift ALPHA
C8C4 E6 JNZ   12            [C8D8] Non-zero?, user pressed HLT
     12
C8C6 22 MOV   %>5A,A        Testvalue
     5A
C8C8 78 ADD   %>20,R66      Restore end of block
     20
     42
C8CB 8E CALL  @>C96C        Check the testdata
     C9
     6C
C8CE E6 JNZ   0E            [C8DE] Non-zero?, error
     0E
C8D0 7A SUB   %>08,R65      Next block of 8K
     08
     41
C8D3 E2 JZ    03            [C8D8] Zero?, done
     03
C8D5 EC TRAP19              Shift ALPHA
C8D6 E2 JZ    CA            [C8A2] Non-zero?, user pressed HLT
     CA
C8D8 88 MOVD  %>038C,R1     SBA 38C
     03                     Check for, and if necessary initialize,
     8C                     a RAM cartridge
     01
C8DC F8 TRAP7
C8DD 0A RETS

C8DE 8E CALL  @>C8D8
     C8
     D8
C8E1 8C BR    @>C440        Call SBA 38E
     C4                     Skip next keystroke instruction
     40

SBA 12E
This SBA is called by the SELFTESTS: menu and it is used to check the correct
functioning of the system RAM. It does so by filling the RAM with data which is
later read-out again.
Note that this test destroys the original contents of RAM, except for the
contents of SR 2016-2139.

C8E4 88 MOVD  %>3FFF,R67
     3F
     FF
     43
C8E8 72 MOV   %>23,R64
     23
     40
C8EB 8E CALL  @>C95B        Fill >2400 - >3FFF with testdata
     C9
     5B
C8EE EC TRAP19              Shift ALPHA
C8EF E6 JNZ   76            [C967] Non-zero?, user pressed HLT
     76
C8F1 22 MOV   %>A5,A
     A5
C8F3 8E CALL  @>C968        Check the testdata
     C9
     68
C8F6 E6 JNZ   60            [C958] Non-zero?, ERROR
     60
C8F8 EC TRAP19              Shift ALPHA
C8F9 E6 JNZ   6C            [C967] Non-zero?, user pressed HLT
     6C
C8FB 22 MOV   %>5A,A        Second testvalue
     5A
C8FD 88 MOVD  %>3FFF,R67
     3F
     FF
     43
C901 8E CALL  @>C95D        Fill >2400 - >3FFF with testdata
     C9
     5D
C904 EC TRAP19              Shift ALPHA
C905 E6 JNZ   60            [C967] Non-zero?, user pressed HLT
     60
C907 22 MOV   %>5A,A
     5A
C909 8E CALL  @>C968        Check the testdata
     C9
     68
C90C E6 JNZ   4A            [C958] Non-zero?, ERROR
     4A
C90E EC TRAP19              Shift ALPHA
C90F E6 JNZ   56            [C967] Non-zero?< ERROR
     56
C911 88 MOVD  %>23FF,R81     Save SR 2016 - SR 2139 plus the first
     23                        32 bytes of user memory
     FF                      
     51                      
C915 88 MOVD  %>27FF,R83     
     27                      
     FF                      
     53                      
C919 88 MOVD  %>0400,R85     
     04                      
     00                      
     55                     
C91D F7 TRAP8               Move block
C91E 88 MOVD  %>23FF,R67
     23
     FF
     43
C922 72 MOV   %>1F,R64
     1F
     40
C925 8E CALL  @>C95B        Fill >2000 - >23FF with testdata
     C9
     5B
C928 88 MOVD  %>23FF,R67
     23
     FF
     43
C92C 8E CALL  @>C96C        Check the testdata
     C9
     6C
C92F E6 JNZ   24            [C955] Non-zero?, ERROR
     24
C931 22 MOV   %>5A,A        Second testvalue
     5A
C933 88 MOVD  %>23FF,R67
     23
     FF
     43
C937 8E CALL  @>C95D        Fill >2000 - >23FF with testdata
     C9
     5D
C93A 88 MOVD  %>23FF,R67
     23
     FF
     43
C93E 8E CALL  @>C96C        Check the testdata
     C9
     6C
C941 E6 JNZ   12            [C955] Non-zero?, ERROR
     12
C943 88 MOVD  %>27FF,R81     Restore SR 2016 - SR 2139
     27                      
     FF                      
     51                      
C947 88 MOVD  %>23FF,R83     
     23                      
     FF                      
     53                      
C94B 88 MOVD  %>0400,R85     
     04                      
     00                      
     55                     
C94F F7 TRAP8               Move block
C950 B5 CLR   A             Clear A
C951 8B STA   @>2058        Store at cold start constant, to generate a
     20                     'MEMORY CLEARED'
     58
C954 0A RETS

C955 8E CALL  @>C943        Restore SR 2016 - SR 2139
     C9
     43
C958 8C BR    @>C440        Skip next keystroke instruction
     C4
     40

C95B 22 MOV   %>A5,A
     A5
C95D 9B STA   *R67
     43
C95F BE RL    A
C960 DB DECD  R67
     43
C962 4D CMP   R64,R66
     40
     42
C965 E6 JNE   F6            [C95D]
     F6
C967 0A RETS

C968 88 MOVD  %>3FFF,R67
     3F
     FF
     43
C96C 9D CMPA  *R67
     43
C96E E6 JNE   08            [C978]
     08
C970 BE RL    A
C971 DB DECD  R67
     43
C973 4D CMP   R64,R66
     40
     42
C976 E6 JNE   F4            [C96C]
     F4
C978 0A RETS

SBA 130
This SBA checks the TMS 70C46 ROM by calculating its CRC and comparing it to
the value that is stored at locations >F002-F003.

C979 88 MOVD  %>F000,R81    Address of first byte of TMS 70C46 ROM
     F0
     00
     51
C97D D5 CLR   R64           MSB of end address of page F + 1
     40
C97F 88 MOVD  %>F002,R83    Address of MSB of CRC
     F0
     02
     53
C983 8E CALL  @>CA0D        Routine to move CRC routine into systemregisters,
     CA                     where it can be used indepently of the selected
     0D                     systempage.
C986 B5 CLR   A
C987 8E CALL  @>2318        Call routine in RAM
     23
     18
C98A B0 TSTA
C98B E6 JNZ   CB            [C958] Non-zero?, skip next keystroke instruction
     CB
C98D 0A RETS

SBA 134/TRAP 19
This SBA/TRAP is used to indicate that the SELFTESTS" functions are working by
shifting the contents of the system alpha register one position to the right.
If there are no more spaces on the right, the contents are shifted all the way
back to the left.
After the shift it scans the keyboard for HLT, so that the user can stop the
test before it has officially ended.

C98E 22 MOV   %>20,A        ASCII code for ' '
     20
C990 8D CMPA  @>2190        Compare with the last position of the system
     21                     alpharegister
     90
C993 E2 JEQ   26            [C9BB] Last position contains a space, so we
     26                     have to shift the entire contents to the right

The following four instructions shift the contents of the system alpha register
one position to the left.

C995 88 MOVD  %>219E,R81    From address
     21
     9E
     51
C999 88 MOVD  %>219F,R83    To address
     21
     9F
     53
C99D 88 MOVD  %>000F,R85    Number of bytes to move, 15
     00
     0F
     55
C9A1 F7 TRAP8               Move block
C9A2 22 MOV   %>20,A        ASCII code for ' '
     20
C9A4 8B STA   @>2190        Store in the last position of the system alpha
     21                     register
     90
C9A7 8D CMPA  @>219F        Compare with contents of the first position of
     21                     the system alpha register
     9F
C9AA E2 JEQ   E9            [C995] Repeat the shifting process until the
     E9                     first position contains a non-blank character
C9AC 74 OR    %>20,R47      Set flag 61
     20
     2F
C9AF 88 MOVD  %>0226,R1     SBA 226
     02                     Pause without delay
     26
     01
C9B3 F8 TRAP7
C9B4 88 MOVD  %>0202,R1     Values to scan for HLT
     02
     02
     01
C9B8 8C BR    @>F05A        SBA 45A
     F0                     Scan for (a) specific key(s) to be pressed
     5A

The following four instructions shift the contents of the system alpha register
one position to the right.

C9BB 88 MOVD  %>2190,R83    To address
     21
     90
     53
C9BF 88 MOVD  %>2191,R81    From address
     21
     91
     51
C9C3 88 MOVD  %>000F,R85    Number of bytes to move, 15
     00
     0F
     55
C9C7 8E CALL  @>F096        SBA 496
     F0                     Move block
     96
C9CA 22 MOV   %>20,A        ASCII code for ' '
     20
C9CC 8B STA   @>219F        Store in first position of system alpha register
     21
     9F
C9CF E0 JMP   DB            [C9AC]
     DB

SBA 132
This SBA checks the four system ROM pages by calculating their CRC and
comparing the obtained values to the values stored at location >DFFE-DFFF.

C9D1 8E CALL  @>CA0D        Routine to move CRC routine into systemregisters,
     CA                     where it can be used indepently of the selected
     0D                     systempage
C9D4 22 MOV   %>03,A        Select page 3
     03
C9D6 8E CALL  @>C9FF        Calculate checksum
     C9
     FF
C9D9 B0 TSTA
C9DA E6 JNZ   20            [C9FC] Non-zero?, ERROR
     20
C9DC EC TRAP19              Shift ALPHA
C9DD E6 JNZ   38            [CA17] Non-zero?, user pressed HLT
     38
C9DF 22 MOV   %>02,A        Select page 2
     02
C9E1 8E CALL  @>C9FF        Calculate checksum
     C9
     FF
C9E4 B0 TSTA
C9E5 E6 JNZ   15            [C9FC] Non-zero?, ERROR
     15
C9E7 EC TRAP19              Shift ALPHA
C9E8 E6 JNZ   2D            [CA17] Non-zero?, user pressed HLT
     2D
C9EA 22 MOV   %>01,A        Select page 1
     01
C9EC 8E CALL  @>C9FF        Calculate checksum
     C9
     FF
C9EF B0 TSTA
C9F0 E6 JNZ   0A            [C9FC] Non-zero?, ERROR
     0A
C9F2 EC TRAP19              Shift ALPHA
C9F3 E6 JNZ   22            [CA17] Non-zero?, user pressed HLT
     22
C9F5 B5 CLR   A             Select page 0
C9F6 8E CALL  @>C9FF        Calculate checksum
     C9
     FF
C9F9 B0 TSTA
C9FA E2 JZ    1B            [CA17] Zero?, OK
     1B
C9FC 8C BR    @>C440        Skip next keystroke instruction
     C4
     40

C9FF 88 MOVD  %>C000,R81    Address of first byte of pages 0 - 3
     C0
     00
     51
CA03 72 MOV   %>E0,R64      MSB of end address of page + 1
     E0
     40
CA06 88 MOVD  %>DFFE,R83    Address of MSB of CRC
     DF
     FE
     53
CA0A 8C BR    @>2318        Branch to routine in RAM
     23
     18

The following 4 instructions move the code starting at address >CA62 into the
systemregisters, where they can be used indepently of the selected systempage.

CA0D 52 MOV   %>5D,B        Number of bytes to move, 93
     5D
CA0F AA LDA   @>CA61(B)     Source address
     CA
     61
CA12 AB STA   @>2317(B)     Destination address
     23
     17
CA15 CA DJNZ  B,F8          [CA0F]
     F8
CA17 0A RETS

SBA 138
This SBA checks the a ROM cartridge by calculating its CRC and comparing the
obtained value to the value stored at location >4004-4005.

CA18 8E CALL  @>CA0D        Routine to move CRC routine into systemregisters,
     CA                     where it can be used indepently of the selected
     0D                     systempage.
CA1B 88 MOVD  %>4000,R81    Initialize pointer to address of first byte in
     40                     cartridge
     00
     51
CA1F 8A LDA   @>BFFC        Load byte containing cartridge size
     BF
     FC
CA22 C5 CLR   B             Clear B

The next 4 instructions calculate the size of the cartridge in number of blocks
of 8Kb

CA23 C3 INC   B             Increment B
CA24 E3 JC    D6            [C9FC] B > 255?, ERROR
     D6
CA26 2A SUB   %>08,A        Subtract 8 from size
     08
CA28 E6 JNZ   F9            [CA23] Unequal zero?, repeat
     F9

CA2A 5D CMP   %>05,B        Compare number of 8K blocks with 5
     05
CA2C E3 JHS   CE            [C9FC] Size > 32K?, ERROR
     CE
CA2E C8 PUSH  B             Save number of 8K blocks
CA2F D5 CLR   R78           Clear R78
     4E
CA31 D5 CLR   R79           Clear R79
     4F
CA33 88 MOVD  %>4004,R83    Address of MSB of cartridge CRC
     40
     04
     53
CA37 42 MOV   R80,R64       MSB of address of first byte in 8K block
     50
     40
CA3A 78 ADD   %>20,R64      MSB of end address of 8K block
     20
     40
CA3D B5 CLR   A
CA3E 8E CALL  @>231C        Call CRC routine
     23
     1C
CA41 C9 POP   B             Restore number of 8K blocks
CA42 CA DJNZ  B,02          [CA46] Repeat for all 8K blocks
     02
CA44 E0 JMP   B3            [C9F9]
     B3
CA46 C8 PUSH  B
CA47 D8 PUSH  R80
     50
CA49 D8 PUSH  R81
     51
CA4B D8 PUSH  R78
     4E
CA4D D8 PUSH  R79
     4F
CA4F EC TRAP19              Shift ALPHA
CA50 E6 JNZ   0A            [CA5C]
     0A
CA52 D9 POP   R79
     4F
CA54 D9 POP   R78
     4E
CA56 D9 POP   R81
     51
CA58 D9 POP   R80
     50
CA5A E0 JMP   D7            [CA33]
     D7
CA5C B9 POP   A
CA5D B9 POP   A
CA5E B9 POP   A
CA5F B9 POP   A
CA60 B9 POP   A
CA61 0A RETS

The following routine is moved into RAM, to access it from all systempages. It
will be placed starting at address >2318.

CA62 D5 CLR   R78           Clear first working register
     4E
CA64 D5 CLR   R79           Clear second working register
     4F
CA66 91 MOVP  P6,B          Get current systempage
     06
CA68 A3 ANDP  %>FC,P6       Set systempage to 0
     FC
     06
CA6B C8 PUSH  B             Save systempage
CA6C 84 ORP   A,P6          Select systempage based on value in A
     06
CA6E 9A LDA   *R81          Load byte
     51
CA70 15 XOR   R78,A         XOR A with R78
     4E
CA72 42 MOV   R79,R78       Move R78 to R79
     4F
     4E
CA75 C0 MOV   A,B           Move XOR'ed code to B
CA76 B5 CLR   A             Clear A
CA77 72 MOV   %>08,R66      Initialize counter
     08
     42
CA7A 65 XOR   B,A           XOR code with A
CA7B CF RLC   B             Rotate B through the carry
CA7C DA DJNZ  R66,FB        [CA7A] Repeat 8 times
     42
     FB
CA7F D0 MOV   A,R79         Move A to R79
     4F
CA81 C0 MOV   A,B           Move A to B
CA82 B5 CLR   A             Clear A
CA83 CF RLC   B             Rotate B once more
CA84 BF RLC   A             Rotate A
CA85 45 XOR   R0,R78
     00
     4E
CA88 12 MOV   R79,A
     4F
CA8A C5 CLR   B
CA8B BD RRC   A
CA8C CD RRC   B
CA8D BD RRC   A
CA8E CD RRC   B
CA8F 45 XOR   R0,R79
     00
     4F
CA92 45 XOR   R1,R78
     01
     4E
CA95 D3 INC   R81            Increment pointer
     51                      
CA97 79 ADC   %>00,R80       
     00                      
     50                     
CA9A 4D CMP   R81,R83       Compare LSB of pointer with LSB of CRC address
     51
     53
CA9D E6 JNE   0B            [CAAA]
     0B
CA9F 4D CMP   R80,R82       Compare MSB of pointer with MSB of CRC address
     50
     52
CAA2 E6 JNE   06            [CAAA]
     06
CAA4 78 ADD   %>02,R81
     02
     51
CAA7 79 ADC   %>00,R80
     00
     50
CAAA 4D CMP   R80,R64       Compare MSB of pointer with R64, containing the
     50                     MSB of the end address
     40
CAAD E6 JNE   BF            [CA6E]
     BF
CAAF 9A LDA   *R83          Load the first byte of the CRC
     53
CAB1 1A SUB   R78,A
     4E
CAB3 E6 JNZ   06            [CABB]
     06
CAB5 D3 INC   R83
     53
CAB7 9A LDA   *R83          Load the second byte of the CRC
     53
CAB9 1A SUB   R79,A
     4F
CABB C9 POP   B             Get old systempage back from stack
CABC 92 MOVP  B,P6          Restore old systempage
     06
CABE 0A RETS

SBA 12C
This SBA is used by the SELFTESTS: menu to check for correct operation of the
Dockbus system.

CABF A2 MOVP  %>00,P15
     00
     0F
CAC2 A7 BTJZP %>02,P15,06   [CACC]
     02
     0F
     06
CAC6 A2 MOVP  %>00,P15
     00
     0F
CAC9 8C BR    @>C440        Skip next keystroke instruction
     C4
     40

CACC A7 BTJZP %>01,P15,0C   [CADC]
     01
     0F
     0C
CAD0 A4 ORP   %>01,P15
     01
     0F
CAD3 B0 CLRC
CAD4 A3 ANDP  %>FE,P15
     FE
     0F
CAD7 B0 CLRC
CAD8 A6 BTJOP %>01,P15,EA   [CAC6] Error
     01
     0F
     EA
CADC A2 MOVP  %>02,P15
     02
     0F
CADF 22 MOV   %>0F,A
     0F
CAE1 A7 BTJZP %>02,P15,E1   [CAC6] Error
     02
     0F
     E1
CAE5 82 MOVP  A,P14
     0E
CAE7 A4 ORP   %>01,P15
     01
     0F
CAEA B0 CLRC
CAEB A7 BTJZP %>01,P15,D7   [CAC6] Error
     01
     0F
     D7
CAEF 91 MOVP  P14,B
     0E
CAF1 53 AND   %>0F,B
     0F
CAF3 6D CMP   B,A
CAF4 E6 JNE   D0            [CAC6] Error
     D0
CAF6 A3 ANDP  %>FE,P15
     FE
     0F
CAF9 B0 CLRC
CAFA A6 BTJOP %>01,P15,C8   [CAC6] Error
     01
     0F
     C8
CAFE B2 DEC   A
CAFF E3 JC    E4            [CAE5]
     E4
CB01 A2 MOVP  %>00,P15
     00
     0F
CB04 0A RETS

SBA 13C
This SBA is used by the SELFTESTS: menu to check(?) the correct operation of
the keyboard.

CB05 88 MOVD  %>CBF7,R81    End of keyboard test table
     CB
     F7
     51
CB09 72 MOV   %>41,R79      # of entries, 65
     41                     65: All keys except OFF, but RUN and CLEAR twice!
     4F
CB0C 9A LDA   *R81          Load first character
     51
CB0E 8B STA   @>2198        Store in 8th position of system alpha
     21                     register
     98
CB11 DB DECD  R81           Decrement pointer
     51
CB13 9A LDA   *R81          Load second character
     51
CB15 8B STA   @>2197        Store in 9th position of system alpha
     21                     register
     97
CB18 88 MOVD  %>0226,R1     SBA 226
     02                     Pause without delay
     26
     01
CB1C F8 TRAP7
CB1D DB DECD  R81           Decrement pointer to point to scancode
     51
CB1F 88 MOVD  %>0234,R1     SBA 234
     02                     Wait for key
     34
     01
CB23 F8 TRAP7
CB24 12 MOV   R37,A         Move resulting scancode to A
     25
CB26 9D CMPA  *R81          Compare with table
     51
CB28 E6 JNE   06            [CB30] Wrong key pressed
     06
CB2A DB DECD  R81           Next entry
     51
CB2C DA DJNZ  R79,DD        [CB0C] Repeat for all keys
     4F
     DD
CB2F 0A RETS

CB30 2D CMP   %>09,A        Test for 'HLT'
     09
CB32 E6 JNE   EB            [CB1F] If keypressed was not 'HLT',
     EB                     repeat scan
CB34 0A RETS

Table for keyboard test function. The table is read from CBF7 and the three
byte entries are composed of a two-byte abbreviation for the key, preceded by a
one byte entry containing the scancode for the key.

CB35 38
CB36 20 ' '
CB37 3D '='
CB38 3C
CB39 2D '-'
CB3A 2B '+'
CB3B 34
CB3C 20 ' '
CB3D 2E '.'
CB3E 2C
CB3F 20 ' '
CB40 30 '0'
CB41 37
CB42 4C 'L'
CB43 43 'C'
CB44 27
CB45 45 'E'
CB46 43 'C'
CB47 26
CB48 3E '>'
CB49 2D '-'
CB4A 25
CB4B 2D '-'
CB4C 3C '<'
CB4D 24
CB4E 55 'U'
CB4F 52 'R'
CB50 24
CB51 55 'U'
CB52 52 'R'
CB53 23
CB54 4C 'L'
CB55 4F 'O'
CB56 20
CB57 45 'E'
CB58 48 'H'
CB59 21
CB5A 4C 'L'
CB5B 41 'A'
CB5C 22
CB5D 45 'E'
CB5E 4C 'L'
CB5F 31
CB60 20 ' '
CB61 2B '+'
CB62 29
CB63 20 ' '
CB64 33 '3'
CB65 39
CB66 20 ' '
CB67 32 '2'
CB68 3F
CB69 20 ' '
CB6A 31 '1'
CB6B 37
CB6C 4C 'L'
CB6D 43 'C'
CB6E 2F
CB6F 49 'I'
CB70 4C 'L'
CB71 1F
CB72 55 'U'
CB73 46 'F'
CB74 1E
CB75 45 'E'
CB76 54 'T'
CB77 1D
CB78 4C 'L'
CB79 46 'F'
CB7A 1C
CB7B 55 'U'
CB7C 4E 'N'
CB7D 1B
CB7E 4F 'O'
CB7F 43 'C'
CB80 1A
CB81 54 'T'
CB82 53 'S'
CB83 19
CB84 49 'I'
CB85 46 'F'
CB86 18
CB87 4F 'O'
CB88 49 'I'
CB89 32
CB8A 20 ' '
CB8B 2D '-'
CB8C 2A
CB8D 20 ' '
CB8E 36 '6'
CB8F 3A
CB90 20 ' '
CB91 35 '5'
CB92 3E
CB93 20 ' '
CB94 34 '4'
CB95 36
CB96 6E 'n'
CB97 32 '2'
CB98 2E
CB99 5E '^'
CB9A 79 'y'
CB9B 17
CB9C 2F '/'
CB9D 31 '1'
CB9E 16
CB9F 54 'T'
CBA0 52 'R'
CBA1 15
CBA2 5E '^'
CBA3 78 'x'
CBA4 14
CBA5 4F 'O'
CBA6 4C 'L'
CBA7 13
CBA8 4E 'N'
CBA9 4C 'L'
CBAA 12
CBAB 41 'A'
CBAC 54 'T'
CBAD 11
CBAE 4F 'O'
CBAF 43 'C'
CBB0 10
CBB1 49 'I'
CBB2 53 'S'
CBB3 33
CBB4 20 ' '
CBB5 2A '*'
CBB6 2B
CBB7 20 ' '
CBB8 39 '9'
CBB9 3B
CBBA 20 ' '
CBBB 38 '8'
CBBC 3D
CBBD 20 ' '
CBBE 37 '7'
CBBF 35
CBC0 4E 'N'
CBC1 49 'I'
CBC2 2D
CBC3 43 'C'
CBC4 52 'R'
CBC5 0F
CBC6 54 'T'
CBC7 53 'S'
CBC8 0E
CBC9 58 'X'
CBCA 45 'E'
CBCB 0D
CBCC 4E 'N'
CBCD 49 'I'
CBCE 0C
CBCF 59 'Y'
CBD0 48 'H'
CBD1 0B
CBD2 74 't'
CBD3 78 'x'
CBD4 0A
CBD5 47 'G'
CBD6 53 'S'
CBD7 09
CBD8 41 'A'
CBD9 48 'H'
CBDA 08
CBDB 52 'R'
CBDC 42 'B'
CBDD 30
CBDE 20 ' '
CBDF 2F '/'
CBE0 28
CBE1 20 ' '
CBE2 29 ')'
CBE3 07
CBE4 20 ' '
CBE5 28 '('
CBE6 01
CBE7 45 'E'
CBE8 45 'E'
CBE9 06
CBEA 35 '5'
CBEB 46 'F'
CBEC 05
CBED 34 '4'
CBEE 46 'F'
CBEF 04
CBF0 33 '3'
CBF1 46 'F'
CBF2 03
CBF3 32 '2'
CBF4 46 'F'
CBF5 02
CBF6 31 '1'
CBF7 46 'F'

CBF8 FF
CBF9 FF
CBFA FF
CBFB FF
CBFC FF
CBFD FF
CBFE FF
CBFF FF