C000 8C BR    @>D6A6 Executes through TRAP 18
     D6              Store a character in the PD buffer
     A6

C003 8C BR    @>D3D3 Executes through TRAP 19
     D3              Put a mnemonic in the PD buffer
     D3

C006 8C BR    @>C225 Executes through TRAP 20
     C2              Reset flags 35, 37, 38, 56, 61 and 62
     25

C009 8C BR    @>C6B6 Executes through TRAP 21
     C6              Send command to LCD controller
     B6

C00C 8C BR    @>C653 Executes through TRAP 22
     C6              Send data to LCD controller
     53

C00F FF TRAP0        Executes through TRAP 23 [Not used]
     FF
     FF

          SBA   Address   Instruction
C012 C0   200    [C0AD]   0-9
     AD

C014 C1   202    [C111]     .
     11

C016 C1   204    [C145]   +/-
     45

C018 C1   206    [C1C6]    EE
     C6

C01A C2   208    [C2B0]   Calculate the exponent after termination of digit
     B0                   entry

C01C C4   20A    [C434]    CE
     34

C01E C2   20C    [C242]   Backarrow key
     42

C020 C4   20E    [C4BB]   ASCII
     BB

C022 C4   210    [C44B]   INV
     4B

C024 C4   212    [C427]   CLR
     27

C026 C5   214    [C528]   Alpha DEL
     28

C028 C5   216    [C56B]   Performs LC function
     6B

C02A C5   218    [C562]   Alpha INS
     62

C02C C4   21A    [C4B7]   Performs 2nd function
     B7

C02E C5   21C    [C5A4]   Stores ASCII code of last key pressed in >2107
     A4

C030 C6   21E    [C664]   Initialize the LCD
     64

C032 C8   220    [C803]   Put 16 characters in the LCD RAM of the display
     03

C034 C8   222    [C813]   Put 15 characters in the LCD RAM of the Fx keys
     13

C036 C7   224    [C7AD]   Put spaces in the LCD RAM of the Fx keys
     AD

C038 C7   226    [C757]   Pause without delay
     57

C03A C0   228    [C0F7]   NOP
     F7

C03C CA   22A    [CA04]
     04

C03E CB   22C    [CB85]
     85

C040 C2   22E    [C202]   ENG
     02

C042 C8   230    [C8E6]   Display test routine
     E6

C044 D0   232    [D0A7]   Fill the filenames above the Fx keys upon RUN <DIR>
     A7

C046 CF   234    [CF8A]
     8A

C048 CF   236    [CF66]
     66

C04A C6   238    [C65F]   Send command at >22BF to LCD controller
     5F

C04C C6   23A    [C650]   Send data  at >22BE to LCD controller
     50

C04E C9   23C    [C92A]   Test the LCD RAM
     2A

C050 CD   23E    [CD48]
     48

C052 C5   240    [C572]   Arrow key
     72

C054 D1   242    [D16E]   Effectuate new partitioning
     6E

C056 D3   244    [D30E]   Find the end of the program in PGM and the length
     0E                   of the last instruction

C058 D3   246    [D36D]
     6D

C05A D7   248    [D757]   Enter a non-field instruction in programmemory
     57

C05C C0   24A    [C0A4]   A-F
     A4

C05E D7   24C    [D752]
     52

C060 D7   24E    [D783]   Learn DEL
     83

C062 D7   250    [D796]   Learn INS
     96

C064 D7   252    [D7BA]   Enter a field instruction in programmemory
     BA

C066 DA   254    [DA01]   Enter a SHW instruction in programmemory
     01

C068 C8   256    [C83D]   Updates the indicator information in the display
     3D

C06A DA   258    [DA6A]   ASM
     6A

C06C DA   25A    [DA1A]    CP function
     1A

C06E C8   25C    [C8BD]   PAU
     BD

C070 D0   25E    [D05B]    KW
     5B

C072 C7   260    [C7A7]
     A7

C074 D0   262    [D077]   Scan for HLT or BRK. Skip next keystroke instruction
     77                   if neither of them is pressed

C076 C4   264    [C453]   HYP
     53

C078 CD   266    [CDEF]   13d
     EF

C07A C8   268    [C8C9]   Delays program for approximately 1 second
     C9

C07C CD   26A    [CD30]   Fill the first 20 positions of the PD buffer with
     30                   blanks

C07E C4   26C    [C48C]
     8C

C080 D2   26E    [D278]   Clear the internal File Space and set the amount
     78                   of free space to the size - 8 bytes

C082 CE   270    [CE7E]    R#
     7E

C084 DB   272    [DBE8]    Used in LP
     E8

C086 DE   274    [DE5E]    Used in LL
     5E

C088 C6   276    [C6A2]
     A2

C08A CE   278    [CE18]   RND
     18

C08C DF   27A    [DF12]   Calculates length of next instruction. Result is
     12                   stored in R79 [>004F]

C08E D0   27C    [D095]   Suspends program until no keys are held down
     95

C090 DA   27E    [DA28]   Executes CP. This function is used by the RD and
     28                   GET functions, but only for program files!

C092 D0   280    [D001]   Set address of INT 2 to TRAP 3 [= >FF63]
     01

C094 DA   282    [DA4E]   PAR
     4E

Begin of code

C096 2D CMP   %>05,A        Octal and hexadecimal mode do not allow more
     05                     than 10 digits to be entered. [5 = F - 10]
C098 E2 JEQ   50            [C0EA]
     50
C09A 76 BTJO  %>04,R45,25   [C0C3] Test if flag 42 is set
     04
     2D
     25
C09E 76 BTJO  %>08,R36,48   [C0EA] Octal mode only allows digits 0-7
     08
     24
     48
C0A2 E0 JMP   1F            [C0C3]
     1F

SBA 24A [A..F]

C0A4 76 BTJO  %>08,R43,05   [C0AD] Test if flag 27 is set
     08
     2B
     05
C0A8 76 BTJO  %>05,R45,01   [C0AD] Test if flag 40 or 42 is set
     05
     2D
     01
C0AC 0A RETS

SBA 200 [0..9]

C0AD 8E CALL  @>C0F8        Initiate digit entry/check if already in
     C0                     progress
     F8
C0B0 8A LDA   @>21A1        Location of next digit in display
     21
     A1
C0B3 76 BTJO  %>40,R45,34   [C0EB] Test if flag 46 is set
     40
     2D
     34
C0B7 76 BTJO  %>08,R43,08   [C0C3] Test if flag 27 is set
     08
     2B
     08
C0BB 76 BTJO  %>01,R45,12   [C0D1] Test if flag 40 is set
     01
     2D
     12
C0BF 76 BTJO  %>06,R45,D3   [C096] Test if flag 41 or 42 is set
     06
     2D
     D3
C0C3 2D CMP   %>02,A        Only 13 digits can be entered in decimal mode
     02                     [2 = F - 13]
C0C5 E2 JEQ   23            [C0EA]
     23
C0C7 76 BTJO  %>20,R45,06   [C0D1] Test if flag 45 is set
     20
     2D
     06
C0CB 76 BTJO  %>FF,R63,02   [C0D1]
     FF
     3F
     02
C0CF 22 MOV   %>0F,A
     0F
C0D1 C0 MOV   A,B
C0D2 E1 JN    16            [C0EA]
     16
C0D4 B2 DEC   A
C0D5 8B STA   @>21A1
     21
     A1
C0D8 12 MOV   R36,A         Move programcode to A
     24
C0DA 23 AND   %>0F,A        Clear first 4 bits of it, to obtain number
     0F
C0DC CD RRC   B             Divide B by 2
C0DD E7 JNC   01            [C0E0] Test for remainder, no carry=no remainder
     01
C0DF B7 SWAP  A             Swap nibbles of A
C0E0 D0 MOV   A,R64         Store temporarily
     40
C0E2 AA LDA   @>0038(B)     Load current byte from display
     00
     38
C0E5 18 ADD   R64,A         Add new digit to correct nibble
     40
C0E7 AB STA   @>0038(B)     Store back in display
     00
     38
C0EA 0A RETS

C0EB D7 SWAP  R56           Swap MSD and LSD of exponent
     38
C0ED 73 AND   %>F0,R56      Clear the previous MSD of the exponent
     F0
     38
C0F0 12 MOV   R36,A         Move programcode to A
     24
C0F2 23 AND   %>0F,A        Clear first 4 bits of it, to obtain number
     0F
C0F4 48 ADD   R0,R56        Move to LSB of exponent
     00
     38

SBA 228 [NOP]

C0F7 0A RETS

C0F8 EB TRAP20              Reset flags 35, 37, 38, 56, 61 and 62
C0F9 76 BTJO  %>80,R45,13   [C110] Test if flag 47 is set
     80
     2D
     13
C0FD 74 OR    %>80,R45      Set flag 47
     80
     2D
C100 73 AND   %>9F,R45      Reset flags 45 and 46
     9F
     2D
C103 8E CALL  @>C41E        Clear the display
     C4
     1E
C106 22 MOV   %>FE,A
     FE
C108 8B STA   @>21A0        Decimal point location save area
     21
     A0
C10B 22 MOV   %>0F,A        Position of digit in display
     0F
C10D 8B STA   @>21A1        Digit position save area
     21
     A1
C110 0A RETS

SBA 202 [.]

C111 76 BTJO  %>08,R43,04   [C119] Test if flag 27 is set
     08
     2B
     04
C115 76 BTJO  %>07,R45,19   [C132] Test if flag 40, 41 or 42 is set
     07
     2D
     19
C119 8E CALL  @>C0F8        Initiate digit entry/check if already in
     C0                     progress
     F8
C11C 76 BTJO  %>60,R45,12   [C132] Test if flag 45 or 46 is set
     60
     2D
     12
C120 8A LDA   @>21A1
     21
     A1
C123 76 BTJO  %>FF,R63,05   [C12C]
     FF
     3F
     05
C127 22 MOV   %>0F,A
     0F
C129 8B STA   @>21A1
     21
     A1
C12C 8B STA   @>21A0
     21
     A0
C12F 74 OR    %>20,R45      Set flag 45
     20
     2D
C132 0A RETS

C133 EB TRAP20              Reset flags 35, 37, 38, 56, 61 and 62
C134 77 BTJZ  %>01,R49,22   [C15A] Test if flag 72 is reset
     01
     31
     22
C138 8E CALL  @>C2B0        SBA 208
     C2                     Calculate the exponent
     B0
C13B 74 OR    %>C0,R50      Set flags 86 and 87
     C0
     32
C13E 88 MOVD  %>0114,R1     SBA 114
     01
     14
     01
C142 F8 TRAP7
C143 E0 JMP   15            [C15A]
     15

SBA 204 [+/-]

C145 76 BTJO  %>08,R43,08   [C151] Test if flag 27 is set
     08
     2B
     08
C149 76 BTJO  %>01,R45,10   [C15D] Test if flag 40 is set
     01
     2D
     10
C14D 76 BTJO  %>06,R45,E2   [C133] Test if flag 41 or 42 is set
     06
     2D
     E2
C151 EB TRAP20              Reset flags 35, 37, 38, 56, 61 and 62
C152 77 BTJZ  %>80,R45,14   [C16A] Test if flag 47 is reset
     80
     2D
     14
C156 76 BTJO  %>40,R45,04   [C15E] Test if flag 46 is set
     40
     2D
     04
C15A 75 XOR   %>04,R57      Change sign of mantissa
     04
     39
C15D 0A RETS

C15E 75 XOR   %>08,R57      Change sign of exponent
     08
     39
C161 0A RETS

C162 72 MOV   %>80,R36      Programcode for 0
     80
     24
C165 8E CALL  @>C0AD        SBA 200
     C0                     Enter a digit
     AD
C168 E0 JMP   F0            [C15A]
     F0

C16A 12 MOV   R63,A
     3F
C16C E2 JZ    F4            [C162]
     F4
C16E 75 XOR   %>04,R57      Change sign of mantissa
     04
     39
C171 76 BTJO  %>78,R43,27   [C19C] Test if flag 27, 28, 29 or 30 is set
     78
     2B
     27
C175 8E CALL  @>C754        Reset flag 39 + SBA 226
     C7
     54
C178 8E CALL  @>CF66        SBA 236
     CF                     Wait for key
     66
C17B 7D CMP   %>A3,R37      Scancode for NOP
     A3
     25
C17E E2 JEQ   F5            [C175]
     F5
C180 7D CMP   %>3C,R37      Scancode for +/-
     3C
     25
C183 E2 JEQ   D5            [C15A]
     D5
C185 74 OR    %>80,R46      Set flag 55
     80
     2E
C188 7D CMP   %>34,R37      Scancode for . (Decimal point)
     34
     25
C18B E2 JEQ   08            [C195]
     08
C18D 88 MOVD  %>0324,R1     SBA 324
     03                     Test if scancode comes from a digit
     24
     01
C191 F8 TRAP7
C192 C1 TSTB
C193 E1 JN    06            [C19B]
     06
C195 8E CALL  @>C0F8        Initiate digit entry/check if already in
     C0                     progress
     F8
C198 74 OR    %>04,R57      Make the mantissa negative
     04
     39
C19B 0A RETS

C19C 76 BTJO  %>08,R43,1D   [C1BD] Test if flag 27 is set
     08
     2B
     1D
C1A0 8E CALL  @>F057        SBA 457
     F0                     Fetch code at RUN PC and increment RUN PC,
     57                     set flag 71 if RUN PC out of range
C1A3 76 BTJO  %>80,R48,15   [C1BC] Test if flag 71 is set
     80
     30
     15
C1A7 B0 CLRC
C1A8 E2 JZ    F2            [C19C] Code is NOP?, repeat fetch
     F2
C1AA 2D CMP   %>0D,A        Compare code with +/-
     0D
C1AC E2 JEQ   AC            [C15A]
     AC
C1AE DB DECD  R119          Decrement RUN PC
     77
C1B0 2D CMP   %>0E,A        Compare code with . (decimal point)
     0E
C1B2 E2 JEQ   E1            [C195]
     E1
C1B4 2D CMP   %>80,A        Compare code with digit 0
     80
C1B6 E7 JL    04            [C1BC]
     04
C1B8 2D CMP   %>8A,A        Compare code with digit A
     8A
C1BA E7 JL    D9            [C195]
     D9
C1BC 0A RETS

C1BD 88 MOVD  %>F07E,R71    SBA 47E
     F0                     Increment SYS PC, change SYS page and load code
     7E                     at new PC
     47
C1C1 F0 TRAP15
C1C2 DB DECD  R39
     27
C1C4 E0 JMP   EA            [C1B0]
     EA

SBA 206 [EE]

C1C6 76 BTJO  %>08,R43,04   [C1CE] Test if flag 27 is set
     08
     2B
     04
C1CA 76 BTJO  %>07,R45, 33  [C201] Test if flag 40, 41 or 42 is set
     07
     2D
     33
C1CE 76 BTJO  %>40,R44,44   [C216] Test if flag 38 is set
     40
     2C
     44
C1D2 EB TRAP20              Reset flags 35, 37, 38, 56, 61 and 62
C1D3 74 OR    %>50,R45      Set flag 44 and 46
     50
     2D
C1D6 76 BTJO  %>80,R45,27   [C201] Test if flag 47 is set
     80
     2D
     27
C1DA 74 OR    %>A0,R45      Set flags 45 and 47
     A0
     2D
C1DD 22 MOV   %>0E,A
     0E
C1DF 8B STA   @>21A0
     21
     A0
C1E2 52 MOV   %>02,B
     02
C1E4 72 MOV   %>03,R64
     03
     40
C1E7 AA LDA   @>0038(B)
     00
     38
C1EA 26 BTJO  %>0F,A,0F     [C1FC]
     0F
     0F
C1ED D3 INC   R64
     40
C1EF 7D CMP   %>0E,R64
     0E
     40
C1F2 E2 JEQ   08            [C1FC]
     08
C1F4 26 BTJO  %>F0,A,05     [C1FC]
     F0
     05
C1F7 D3 INC   R64
     40
C1F9 C3 INC   B
C1FA E0 JMP   EB            [C1E7]
     EB

C1FC 12 MOV   R64,A
     40
C1FE 8B STA   @>21A1
     21
     A1
C201 0A RETS

SBA 22E [ENG]

C202 76 BTJO  %>08,R43,04   [C20A] Test if flag 27 is set
     08
     2B
     04
C206 76 BTJO  %>07,R45,F7   [C201] Test if flag 40, 41 or 42 is set
     07
     2D
     F7
C20A 74 OR    %>08,R45      Set flag 43
     08
     2D
C20D 77 BTJZ  %>40,R44,11   [C222] Test if flag 38 is reset
     40
     2C
     11
C211 73 AND   %>F7,R45      Reset flag 43
     F7
     2D
C214 E0 JMP   0C            [C222]
     0C

C216 76 BTJO  %>08,R43,08   [C222] Test if flag 27 is set
     08
     2B
     08
C21A 72 MOV   %>C0,R50      Reset flags 80..85, set flags 86 and 87
     C0
     32
C21D 88 MOVD  %>0114,R1     SBA 114
     01
     14
     01
C221 F8 TRAP7
C222 73 AND   %>EF,R45      Reset flag 44
     EF
     2D

TRAP 20

C225 73 AND   %>97,R44      Reset flags 35, 37 and 38
     97
     2C
C228 73 AND   %>97,R47      Reset flags 56, 61 and 62
     97
     2F
C22B 0A RETS

C22C 22 MOV   %>1E,A
     1E
C22E 8B STA   @>20AA
     20
     AA
C231 73 AND   %>FB,R47      Reset flag 58
     FB
     2F
C234 8A LDA   @>22CE
     22
     CE
C237 E2 JZ    31            [C26A]
     31
C239 4A SUB   R0,R119
     00
     77
C23C 7B SBB   %>00,R118
     00
     76
C23F 8C BR    @>D36D        SBA 246
     D3
     6D

SBA 20C
This SBA is executed if the backarrow key is pressed

C242 76 BTJO  %>20,R48,E6   [C22C] Test if flag 69 is set
     20
     30
     E6
C246 77 BTJZ  %>80,R45,48   [C292] Test if flag 47 is reset
     80
     2D
     48
C24A 76 BTJO  %>40,R45,3E   [C28C] Test if flag 46 is set
     40
     2D
     3E
C24E 77 BTJZ  %>20,R45,19   [C26B] Test if flag 45 is reset
     20
     2D
     19
C252 8A LDA   @>21A0
     21
     A0
C255 8D CMPA  @>21A1
     21
     A1
C258 E6 JNE   11            [C26B]
     11
C25A 2D CMP   %>0F,A
     0F
C25C E6 JNE   04            [C262]
     04
C25E B2 DEC   A
C25F 8B STA   @>21A1
     21
     A1
C262 73 AND   %>DF,R45      Reset flag 45
     DF
     2D
C265 22 MOV   %>FE,A
     FE
C267 8B STA   @>21A0
     21
     A0
C26A 0A RETS

C26B 8A LDA   @>21A1
     21
     A1
C26E B3 INC   A
C26F 2D CMP   %>0F,A
     0F
C271 E7 JL    04            [C277]
     04
C273 77 BTJZ  %>20,R45,03   [C27A] Test if flag 45 is reset
     20
     2D
     03
C277 8B STA   @>21A1
     21
     A1
C27A C0 MOV   A,B
C27B 72 MOV   %>F0,R64
     F0
     40
C27E CD RRC   B
C27F E7 JNC   02            [C283]
     02
C281 D7 SWAP  R64
     40
C283 AA LDA   @>0038(B)
     00
     38
C286 13 AND   R64,A
     40
C288 AB STA   @>0038(B)
     00
     38
C28B 0A RETS

C28C 73 AND   %>F0,R56
     F0
     38
C28F D7 SWAP  R56
     38
C291 0A RETS

C292 77 BTJZ  %>40,R47,D4   [C26A] Test if flag 62 is reset
     40
     2F
     D4
C296 F3 TRAP12              Reset flags 35, 37, 38 and 59
C297 77 BTJZ  %>10,R47,0B   [C2A6] Test if flag 60 is reset
     10
     2F
     0B
C29B 8A LDA   @>2138        Load the user cursor
     21
     38
C29E B2 DEC   A             Decrement
C29F E6 JNZ   01            [C2A2] Not equal 0?, OK
     01
C2A1 B3 INC   A             Increment it to 1
C2A2 8B STA   @>2138        Store back
     21
     38
C2A5 0A RETS

C2A6 74 OR    %>01,R47      Set flag 56
     01
     2F
C2A9 0A RETS

C2AA 76 BTJO  %>01,R45,6D   [C31B] Test if flag 40 is set
     01
     2D
     6D
C2AE E0 JMP   2B            [C2DB]
     2B

SBA 208
This SBA is used to calculate the exponent after digit entry has been
terminated.

C2B0 77 BTJZ  %>80,R45,F6   [C2AA] Test if flag 47 is reset
     80
     2D
     F6
C2B4 76 BTJO  %>08,R43,04   [C2BC] Test if flag 27 is set
     08
     2B
     04
C2B8 76 BTJO  %>01,R45,5F   [C31B] Test if flag 40 is set
     01
     2D
     5F
C2BC 76 BTJO  %>20,R45,06   [C2C6] Test if flag 45 is set
     20
     2D
     06
C2C0 8A LDA   @>21A1
     21
     A1
C2C3 8B STA   @>21A0
     21
     A0
C2C6 8A LDA   @>21A0
     21
     A0
C2C9 2D CMP   %>0E,A
     0E
C2CB E2 JEQ   0E            [C2DB]
     0E
C2CD E3 JHS   09            [C2D8]
     09
C2CF B3 INC   A
C2D0 8B STA   @>21A0
     21
     A0
C2D3 8E CALL  @>C3D8
     C3
     D8
C2D6 E0 JMP   EE            [C2C6]
     EE

C2D8 8E CALL  @>C409
     C4
     09
C2DB 76 BTJO  %>F0,R63,35   [C314]
     F0
     3F
     35
C2DF 76 BTJO  %>F0,R57,0E   [C2F1]
     F0
     39
     0E
C2E3 52 MOV   %>06,B
     06
C2E5 AA LDA   @>0039(B)
     00
     39
C2E8 E6 JNZ   07            [C2F1]
     07
C2EA CA DJNZ  B,F9          [C2E5]
     F9
C2EC 8E CALL  @>C41E        Clear the display
     C4
     1E
C2EF E0 JMP   2A            [C31B]
     2A

C2F1 42 MOV   R57,R64
     39
     40
C2F4 73 AND   %>0F,R57
     0F
     39
C2F7 D7 SWAP  R64
     40
C2F9 52 MOV   %>FA,B
     FA
C2FB AA LDA   @>FF40(B)
     FF
     40
C2FE B7 SWAP  A
C2FF B8 PUSH  A
C300 23 AND   %>F0,A
     F0
C302 73 AND   %>0F,R64
     0F
     40
C305 14 OR    R64,A
     40
C307 AB STA   @>FF40(B)
     FF
     40
C30A D9 POP   R64
     40
C30C C3 INC   B
C30D E6 JNZ   EC            [C2FB]
     EC
C30F 8E CALL  @>C409
     C4
     09
C312 E0 JMP   C7            [C2DB]
     C7

C314 76 BTJO  %>FF,R56,03   [C31B]
     FF
     38
     03
C318 73 AND   %>F7,R57
     F7
     39
C31B 77 BTJZ  %>80,R45,0B   [C32A] Test if flag 47 is reset
     80
     2D
     0B
C31F 73 AND   %>7F,R45      Reset flag 47
     7F
     2D
C322 76 BTJO  %>08,R43,04   [C32A] Test if flag 27 is set
     08
     2B
     04
C326 76 BTJO  %>06,R45,1B   [C345] Test if flag 41 or 42 is set
     06
     2D
     1B
C32A 0A RETS

C32B 77 BTJZ  %>01,R49,23   [C352] Test if flag 72 is reset
     01
     31
     23
C32F 7D CMP   %>44,R96
     44
     60
C332 E6 JNE   1E            [C352]
     1E
C334 22 MOV   %>37,A
     37
C336 76 BTJO  %>02,R45,02   [C33C] Test if flag 41 is set
     02
     2D
     02
C33A 22 MOV   %>7F,A
     7F
C33C 1D CMP   R97,A
     61
C33E E3 JHS   12            [C352]
     12
C340 74 OR    %>80,R45      Set flag 47
     80
     2D
C343 E0 JMP   0D            [C352]
     0D

C345 D8 PUSH  R90
     5A
C347 D8 PUSH  R89
     59
C349 8E CALL  @>F03F        SBA 43F
     F0                     Convert STD in SR 2007 to FP in SR 2012
     3F
C34C D8 PUSH  R96
     60
C34E E5 JPZ   DB            [C32B]
     DB
C350 D4 INV   R96
     60
C352 8E CALL  @>CB41        Move SR 2012 to SR 2007
     CB
     41
C355 22 MOV   %>40,A
     40
C357 8B STA   @>2103
     21
     03
C35A 8E CALL  @>F018        SBA 418
     F0                     Clear SR 2012
     18
C35D 8A LDA   @>2103
     21
     03
C360 4D CMP   R0,R56
     00
     38
C363 E7 JL    3A            [C39F]
     3A
C365 B3 INC   A
C366 8B STA   @>2103
     21
     03
C369 C0 MOV   A,B
C36A AA LDA   @>FFF8(B)
     FF
     F8
C36D B8 PUSH  A
C36E 8E CALL  @>F021        SBA 421
     F0                     Move SR 2012 to SR 2009
     21
C371 8E CALL  @>CDD8        Put 64 or 256 in SR 2012
     CD
     D8
C374 F1 TRAP14              SR 2012:= SR 2009 * SR 2012
C375 B9 POP   A
C376 77 BTJZ  %>02,R45,07   [C381] Test if flag 41 is reset
     02
     2D
     07
C37A C0 MOV   A,B            Convert an "octal" byte to hexadecimal
C37B 53 AND   %>0F,B         
     0F                      
C37D 23 AND   %>F0,A         
     F0                      
C37F BC RR    A              
C380 68 ADD   B,A           
C381 D0 MOV   A,R64
     40
C383 88 MOVD  %>03A4,R1     SBA 3A4
     03                     Convert R64 to BCD in R64/65
     A4
     01
C387 F8 TRAP7
C388 88 MOVD  %>0306,R1     SBA 306
     03                     Clear SR 2009
     06
     01
C38C F8 TRAP7
C38D 72 MOV   %>41,R72
     41
     48
C390 98 MOVD  R65,R74
     41
     4A
C393 E6 JNZ   07            [C39C]
     07
C395 D2 DEC   R72
     48
C397 42 MOV   R74,R73
     4A
     49
C39A D5 CLR   R74
     4A
C39C EF TRAP16              SR 2012:= SR 2009 + SR 2012
C39D E0 JMP   BE            [C35D]
     BE

C39F 77 BTJZ  %>80,R45,13   [C3B6] Test if flag 47 is reset
     80
     2D
     13
C3A3 73 AND   %>7F,R45      Reset flag 47
     7F
     2D
C3A6 88 MOVD  %>C3D7,R71    FD of FFFFFFFFFF + 1
     C3
     D7
     47
C3AA 76 BTJO  %>04,R45,04   [C3B2] Test if flag 42 is set
     04
     2D
     04
C3AE 88 MOVD  %>C3CF,R71    FD of 7777777777 + 1
     C3
     CF
     47
C3B2 F6 TRAP9               Move data addressed by R70/71 into SR 2009
C3B3 D4 INV   R72           Change sign of SR 2009
     48
C3B5 EF TRAP16              SR 2012:= SR 2009 + SR 2012
C3B6 B9 POP   A
C3B7 E5 JPZ   02            [C3BB]
     02
C3B9 D4 INV   R96
     60
C3BB 88 MOVD  %>03B4,R1     SBA 3B4
     03                     Convert 14d to 13d
     B4
     01
C3BF F8 TRAP7
C3C0 8E CALL  @>F042        SBA 442
     F0                     Convert FP in SR 2012 to STD in SR 2007
     42
C3C3 D9 POP   R89
     59
C3C5 D9 POP   R90
     5A
C3C7 0A RETS

Data

C3C8 44  1073741824
C3C9 10    Largest octal number [7777777777] + 1
C3CA 73  
C3CB 74  
C3CC 18  
C3CD 24  
C3CE 00  
C3CF 00 

C3D0 46  1.099511627776 E12
C3D1 01    Largest hexadecimal number [FFFFFFFFFF] + 1
C3D2 09  
C3D3 95  
C3D4 11  
C3D5 62  
C3D6 77  
C3D7 76 

The following routine is used to adjust the exponent. If the adjusted exponent
exceeds +99, an overflow is generated.

C3D8 76 BTJO  %>08,R57,1E   [C3FA] Jump if the sign of the exponent < 0
     08
     39
     1E
C3DC 7E DAC   %>01,R56      Add 1 to the exponent
     01
     38
C3DF E7 JNC   18            [C3F9] No carry?, OK
     18
C3E1 42 MOV   R57,R111      Get the sign and 13th digit byte
     39
     6F
C3E4 73 AND   %>0F,R111     Clear the 13th digit
     0F
     6F
C3E7 22 MOV   %>99,A
     99
C3E9 52 MOV   %>08,B
     08
C3EB AB STA   @>0037(B)     Fill the display with nines
     00
     37
C3EE CA DJNZ  B,FB          [C3EB] Loop until done
     FB
C3F0 73 AND   %>F0,R57      Get rid of the "9" signdigit
     F0
     39
C3F3 48 ADD   R111,R57      Add the original sign
     6F
     39
C3F6 72 MOV   %>01,R111     Set errorcode to 1, OVERFLOW
     01
     6F
C3F9 0A RETS

The following routine is executed if the sign of the exponent is negative

C3FA 7F DSB   %>00,R56      Subtract 1 from the exponent
     00
     38
C3FD E7 JNC   03            [C402] Resulting exponent < 0?, adjust
     03
C3FF E2 JZ    04            [C405] Resulting exponent zero?, adjust sign
     04
C401 0A RETS

C402 72 MOV   %>01,R56      Make exponent 1
     01
     38
C405 73 AND   %>F7,R57      Set signs to + + or - +
     F7
     39
C408 0A RETS

The following routine is used to adjust the exponent. If the adjusted exponent
becomes less than -99, the underflow number is set to zero

C409 76 BTJO  %>08,R57,0C   [C419] Jump if the sign of the exponent < 0
     08
     39
     0C
C40D 7F DSB   %>00,R56      Subtract 1 from the exponent
     00
     38
C410 E3 JC    06            [C418] Carry?, resulting exponent > 0
     06
C412 72 MOV   %>01,R56      Make exponent 1
     01
     38
C415 74 OR    %>08,R57      Set signs to - - or + -
     08
     39
C418 0A RETS

The following routine is executed if the sign of the exponent is negative

C419 7E DAC   %>01,R56      Add 1 to the exponent
     01
     38
C41C E7 JNC   FA            [C418] No carry?, OK
     FA

The following routine clears the display

C41E 52 MOV   %>08,B        Number of bytes to clear, 8
     08
C420 B5 CLR   A             Source
C421 AB STA   @>0037(B)     Destination, the display
     00
     37
C424 CA DJNZ  B,FB          [C421] Loop until done
     FB
C426 0A RETS

SBA 212
This SBA performs the CLR function

C427 8E CALL  @>C41E        Clear the display
     C4
     1E
C42A 73 AND   %>EF,R45      Reset flag 44
     EF
     2D
C42D D5 CLR   R54           Set AOS stack counter to 0
     36
C42F 73 AND   %>DF,R46      Reset flag 53
     DF
     2E
C432 D5 CLR   R111
     6F

SBA 20A
This SBA performs the CE function

C434 EB TRAP20              Reset flags 35, 37, 38, 56, 61 and 62
C435 76 BTJO  %>10,R47,09   [C442] Test if flag 60 is set
     10
     2F
     09
C439 77 BTJZ  %>80,R45,DB   [C418] Test if flag 47 is reset
     80
     2D
     DB
C43D 73 AND   %>7F,R45      Reset flag 47
     7F
     2D
C440 E0 JMP   DC            [C41E] Clear the display
     DC

C442 88 MOVD  %>036A,R1     SBA 36A
     03                     Clear the ALPHA register
     6A
     01
C446 F8 TRAP7
C447 74 OR    %>40,R47      Set flag 62
     40
     2F
C44A 0A RETS

SBA 210
This SBA performs the INV function.

C44B 75 XOR   %>40,R44      Toggle flag 38
     40
     2C
C44E 73 AND   %>F7,R47      Reset flag 59
     F7
     2F
C451 E0 JMP   26            [C479]
     26

SBA 264
This SBA performs the HYP function

C453 75 XOR   %>20,R44      Toggle flag 37
     20
     2C
C456 73 AND   %>97,R47      Reset flags 59, 61 and 62
     97
     2F
C459 76 BTJO  %>08,R43,56   [C4B3] Test if flag 27 is set
     08
     2B
     56
C45D 77 BTJZ  %>10,R48,18   [C479] Test if flag 68 is reset
     10
     30
     18
C461 74 OR    %>01,R50      Set flag 80
     01
     32
C464 8E CALL  @>CD30        SBA 26A
     CD                     Fill the first 20 positions of the PD buffer
     30                     with blanks
C467 88 MOVD  %>223E,R83
     22
     3E
     53
C46B 22 MOV   %>48,A        ASCII code for 'H'
     48
C46D ED TRAP18
C46E 22 MOV   %>59,A        ASCII code for 'Y'
     59
C470 ED TRAP18
C471 22 MOV   %>50,A        ASCII code for 'P'
     50
C473 ED TRAP18
C474 88 MOVD  %>011A,R1     SBA 11A
     01
     1A
     01
C478 F8 TRAP7
C479 77 BTJZ  %>20,R44,36   [C4B3] Test if flag 37 is reset
     20
     2C
     36
C47D 88 MOVD  %>2053,R83    Trace mnemonic location
     20
     53
     53
C481 22 MOV   %>48,A        ASCII code for 'H'
     48
C483 ED TRAP18
C484 22 MOV   %>59,A        ASCII code for 'Y'
     59
C486 ED TRAP18
C487 22 MOV   %>50,A        ASCII code for 'P'
     50
C489 ED TRAP18
C48A D5 CLR   R106
     6A

SBA 26C

C48C 76 BTJO  %>78,R43,23   [C4B3] Test if flag 27, 28, 29 or 30 is set
     78
     2B
     23
C490 76 BTJO  %>01,R45,1F   [C4B3] Test if flag 40 is set
     01
     2D
     1F
C494 74 OR    %>02,R50      Set flag 81
     02
     32
C497 8E CALL  @>CA04        SBA 22A
     CA
     04
C49A 8E CALL  @>CB85        SBA 22C
     CB
     85
C49D 88 MOVD  %>2053,R81
     20
     53
     51
C4A1 7D CMP   %>07,R106     Operatorcode for xy
     07
     6A
C4A4 E6 JNE   04            [C4AA]
     04
C4A6 88 MOVD  %>C4B6,R81    Source of data
     C4
     B6
     51
C4AA 88 MOVD  %>0003,R85    Number of bytes to move
     00
     03
     55
C4AE 88 MOVD  %>2242,R83    Destination of data, last 3 positions of the
     22                     display
     42
     53
C4B2 F7 TRAP8               Move block
C4B3 0A RETS

Trace mnemonic for the INV y^x function

C4B4 79 'x'
     E8 ''
     78 'y'

SBA 21A
This SBA performs the 2nd function

C4B7 75 XOR   %>80,R44      Toggle flag 39
     80
     2C
C4BA 0A RETS

SBA 20E
This SBA is executed for all ASCII codes.

C4BB 88 MOVD  %>036C,R1     SBA 36C
     03                     Clear the ALPHA register if flag 61 and 62 are
     6C                     reset
     01
C4BF F8 TRAP7
C4C0 76 BTJO  %>08,R43,32   [C4F6] Test if flag 27 is set
     08
     2B
     32
C4C4 77 BTJZ  %>08,R47,16   [C4DE] Test if flag 59 is reset
     08
     2F
     16
C4C8 8A LDA   @>2138        Load the user cursor
     21
     38
C4CB 72 MOV   %>50,R64      Length of user alpha register, 80
     50
     40
C4CE 4A SUB   R0,R64        Calculate number of positions after cursor
     00
     40
C4D1 E2 JZ    0B            [C4DE] Zero?, cursor is at last position
     0B
C4D3 C5 CLR   B             Set pointer to 0
C4D4 AA LDA   @>2141(B)     Load character at position B
     21
     41
C4D7 AB STA   @>2140(B)     Store at position B + 1
     21
     40
C4DA C3 INC   B             Increment pointer
C4DB DA DJNZ  R64,F6        [C4D4] Repeat for all characters after and
     40                     including the cursor
     F6
C4DE 8A LDA   @>2138        Load user cursor
     21
     38
C4E1 C0 MOV   A,B           Move to B
C4E2 B3 INC   A             Increment cursor
C4E3 2D CMP   %>50,A        Compare with 80, length of user alpha register
     50
C4E5 E7 JL    02            [C4E9] Less than 80?, OK
     02
C4E7 22 MOV   %>50,A        Store 80 in A
     50
C4E9 8B STA   @>2138        Store at user cursor location
     21
     38
C4EC 22 MOV   %>50,A        Store 80 in A
     50
C4EE 6A SUB   B,A           Calculate position of new character
C4EF C0 MOV   A,B           Move to pointer
C4F0 12 MOV   R36,A         Load the current programcode
     24
C4F2 AB STA   @>2140(B)     Store in user alpha register
     21
     40
C4F5 0A RETS

If a systemfunction is executing, the following code will be executed for all
ASCII codes.

C4F6 77 BTJZ  %>08,R47,16   [C510] Test if flag 59 is reset
     08
     2F
     16
C4FA 8A LDA   @>2139        Load the system cursor
     21
     39
C4FD 72 MOV   %>10,R64      Length of the system alpha register
     10
     40
C500 4A SUB   R0,R64        Calculate number of positions after cursor
     00
     40
C503 E2 JZ    0B            [C510] Zero?, cursor is at last position
     0B
C505 C5 CLR   B             Set pointer to 0
C506 AA LDA   @>2191(B)     Load character at position B
     21
     91
C509 AB STA   @>2190(B)     Store at position B + 1
     21
     90
C50C C3 INC   B             Increment pointer
C50D DA DJNZ  R64,F6        [C506] Repeat for all characters after and
     40                     including the cursor
     F6
C510 8A LDA   @>2139        Load system cursor
     21
     39
C513 C0 MOV   A,B           Move to B
C514 B3 INC   A             Increment cursor
C515 2D CMP   %>10,A        Compare with 16, length of system alpha register
     10
C517 E7 JL    02            [C51B] Less than 16?, OK
     02
C519 22 MOV   %>10,A        Store 16 in A
     10
C51B 8B STA   @>2139        Store at system cursor location
     21
     39
C51E 22 MOV   %>10,A        Store 16 in A
     10
C520 6A SUB   B,A           Calculate position of new character
C521 C0 MOV   A,B           Move to pointer
C522 12 MOV   R36,A         Load the current programcode
     24
C524 AB STA   @>2190(B)     Store in system alpha register
     21
     90
C527 0A RETS

SBA 214
This SBA performs the alpha DEL function

C528 73 AND   %>F7,R47      Reset flag 59
     F7
     2F
C52B 88 MOVD  %>036C,R1     SBA 36C
     03                     Clear the ALPHA register if flag 61 and 62 are
     6C                     reset
     01
C52F F8 TRAP7
C530 76 BTJO  %>08,R43,17   [C54B] Test if flag 27 is set
     08
     2B
     17
C534 8A LDA   @>2138        Load the user cursor
     21
     38
C537 52 MOV   %>50,B        Length of user alpha register
     50
C539 3A SUB   R0,B          Calculate number of characters after the cursor
     00
C53B E2 JZ    08            [C545] Are we already at the last position?
     08
C53D AA LDA   @>213F(B)     Get character at the (81-B) th position after
     21                     the cursor
     3F
C540 AB STA   @>2140(B)     Store at the (80-B) th position
     21
     40
C543 CA DJNZ  B,F8          [C53D] Repeat for all characters to be moved
     F8
C545 22 MOV   %>20,A        ASCII code for ' '
     20
C547 8B STA   @>2140        Store in last position of user alpha register
     21
     40
C54A 0A RETS

If flag 27 is set, the DEL function should be applied to the system alpha
register, using almost the same code.

C54B 8A LDA   @>2139        Load the system cursor
     21
     39
C54E 52 MOV   %>10,B        Length of system alpha register
     10
C550 3A SUB   R0,B          Calculate number of characters after the cursor
     00
C552 E2 JZ    08            [C55C] Are we already at the last position?
     08
C554 AA LDA   @>218F(B)     Get character at (17-B) th position after
     21                     the cursor
     8F
C557 AB STA   @>2190(B)     Store at (16-B) th position
     21
     90
C55A CA DJNZ  B,F8          [C554] Repeat for all characters to be moved
     F8
C55C 22 MOV   %>20,A        ASCII code for ' '
     20
C55E 8B STA   @>2190        Store in the last position of the system alpha
     21                     register
     90
C561 0A RETS

SBA 218
This SBA performs the alpha INS function

C562 88 MOVD  %>036C,R1     SBA 36C
     03                     Clear the ALPHA register if flag 61 and 62 are
     6C                     reset
     01
C566 F8 TRAP7
C567 74 OR    %>08,R47      Set flag 59
     08
     2F
C56A 0A RETS

SBA 216
This SBA performs the LC function

C56B 75 XOR   %>80,R47      Toggle flag 63
     80
     2F
C56E 73 AND   %>97,R44      Reset flags 35, 37 and 38
     97
     2C
C571 0A RETS

SBA 240
This SBA is executed whenever the arrow key is pressed

C572 76 BTJO  %>20,R48,1A   [C590] Test if flag 69 is set
     20
     30
     1A
C576 77 BTJZ  %>10,R47,15   [C58F] Test if flag 60 is reset
     10
     2F
     15
C57A 88 MOVD  %>036C,R1     SBA 36C
     03                     Clear the ALPHA register if flag 61 and 62 are
     6C                     reset
     01
C57E F8 TRAP7
C57F 73 AND   %>F7,R47      Reset flag 59
     F7
     2F
C582 8A LDA   @>2138        Load user cursor
     21
     38
C585 B3 INC   A             Increment
C586 2D CMP   %>51,A        Compare with 81
     51
C588 E7 JL    02            [C58C] Less than 81?, OK
     02
C58A 22 MOV   %>50,A        Make it 80
     50
C58C 8B STA   @>2138        Store back
     21
     38
C58F 0A RETS

C590 22 MOV   %>1E,A
     1E
C592 8B STA   @>20AA
     20
     AA
C595 73 AND   %>FB,R47      Reset flag 58
     FB
     2F
C598 8A LDA   @>22CF
     22
     CF
C59B 48 ADD   R0,R119
     00
     77
C59E 79 ADC   %>00,R118
     00
     76
C5A1 8C BR    @>D76C
     D7
     6C

SBA 21C
This SBA stores the ASCII code of the last key pressed at >2107. If the key has
no corresponding ASCII code, a zero is stored at >2107. The result is also
stored in B.

C5A4 73 AND   %>7F,R44      Reset flag 39
     7F
     2C
C5A7 32 MOV   R37,B         Get scancode of last key pressed
     25
C5A9 E5 JPZ   05            [C5B0] Positive?, not a 2nd function
     05
C5AB 55 XOR   %>C0,B        Bring B in the range 64..127, the second half of
     C0                     the lookup table
C5AD 74 OR    %>80,R44      Set flag 39
     80
     2C
C5B0 AA LDA   @>C5D0(B)     Load code from table
     C5
     D0
C5B3 E2 JZ    16            [C5CB] Zero?, key has no corresponding ASCII code
     16
C5B5 E4 JP    0F            [C5C6] Code > 0?, we have a real ASCII code
     0F
C5B7 23 AND   %>7F,A        Convert code to uppercase ASCII
     7F
C5B9 77 BTJZ  %>80,R47,03   [C5C0] Test if flag 63 is reset
     80
     2F
     03
C5BD 75 XOR   %>80,R44      Toggle flag 39
     80
     2C
C5C0 77 BTJZ  %>80,R44,02   [C5C6] Test if flag 39 is reset
     80
     2C
     02
C5C4 28 ADD   %>20,A        Add >20 to A, to obtain a lowercase ASCII code
     20
C5C6 D0 MOV   A,R37         Store the generated ASCII code in register 37
     25
C5C8 73 AND   %>7F,R44      Reset flag 39
     7F
     2C
C5CB C0 MOV   A,B           Store the generated ASCII code in B
C5CC 8B STA   @>2107        Store the ASCII code, if any, at address >2107
     21
     07
C5CF 0A RETS

Character tabel for SBA 21C

C5D0 00
C5D1 60 '`'
C5D2 00
C5D3 00
C5D4 00
C5D5 00
C5D6 00
C5D7 28 '('
C5D8 D1 'Q'
C5D9 D7 'W'
C5DA C5 'E'
C5DB D2 'R'
C5DC D4 'T'
C5DD D9 'Y'
C5DE D5 'U'
C5DF C9 'I'
C5E0 C1 'A'
C5E1 D3 'S'
C5E2 C4 'D'
C5E3 C6 'F'
C5E4 C7 'G'
C5E5 C8 'H'
C5E6 CA 'J'
C5E7 CB 'K'
C5E8 DA 'Z'
C5E9 D8 'X'
C5EA C3 'C'
C5EB D6 'V'
C5EC C2 'B'
C5ED CE 'N'
C5EE CD 'M'
C5EF 2C ','
C5F0 00
C5F1 00
C5F2 00
C5F3 00
C5F4 20 ' '
C5F5 00
C5F6 00
C5F7 00
C5F8 29 ')'
C5F9 33 '3'
C5FA 36 '6'
C5FB 39 '9'
C5FC 30 '0'
C5FD CF 'O'
C5FE CC 'L'
C5FF 2E '.'
C600 2F '/'
C601 2B '+'
C602 2D '-'
C603 2A '*'
C604 2E '.'
C605 D0 'P'
C606 00
C607 00
C608 3D '='
C609 32 '2'
C60A 35 '5'
C60B 38 '8'
C60C 7C '|'
C60D 37 '7'
C60E 34 '4'
C60F 31 '1'

Character tabel for SBA 21C (2nd functions)

C610 00
C611 7B '{'
C612 00
C613 00
C614 00
C615 00
C616 00
C617 5B '['
C618 D1 'q'
C619 D7 'w'
C61A C5 'e'
C61B D2 'r'
C61C D4 't'
C61D D9 'y'
C61E D5 'u'
C61F C9 'i'
C620 C1 'a'
C621 D3 's'
C622 C4 'd'
C623 C6 'f'
C624 C7 'g'
C625 C8 'h'
C626 CA 'j'
C627 CB 'k'
C628 DA 'z'
C629 D8 'x'
C62A C3 'c'
C62B D6 'v'
C62C C2 'b'
C62D CE 'n'
C62E CD 'm'
C62F 22 '"'
C630 00
C631 00
C632 00
C633 00
C634 20 ' '
C635 00
C636 00
C637 00
C638 5D ']'
C639 3B ';'
C63A 40 '@'
C63B 3E '>'
C63C 24 '$'
C63D CF 'o'
C63E CC 'l'
C63F 27 '''
C640 5C '\'
C641 26 '&'
C642 5F '_'
C643 5E '^'
C644 3F '?'
C645 D0 'p'
C646 00
C647 00
C648 7E '~'
C649 3A ':'
C64A 25 '%'
C64B 3C '<'
C64C 21 '!'
C64D 7D '}'
C64E 00
C64F 23 '#'

SBA 23A
Send data to the LCD controller

C650 8A LDA   @>22BE
     22
     BE

TRAP 22
This TRAP is used to send data to the LCD controller

C653 B8 PUSH  A             Save data temporarily on the stack
C654 8A LDA   @>1000        Load the LCD status
     10
     00
C657 26 BTJO  %>80,A,FA     [C654] Wait until not busy
     80
     FA
C65A B9 POP   A             Get the data back from the stack
C65B 8B STA   @>1001        Send it to the LCD CGRAM
     10
     01
C65E 0A RETS

SBA 238
Send a command to the LCD controller

C65F 8A LDA   @>22BF
     22
     BF
C662 E0 JMP   52            [C6B6]
     52

SBA 21E
This SBA is used to initialize the LCD.

C664 52 MOV   %>07,B
     07
C666 AA LDA   @>C682(B)
     C6
     82
C669 EA TRAP21              Send command to the LCD controller
C66A CA DJNZ  B,FA          [C666]
     FA
C66C 88 MOVD  %>C6A1,R65    Address of definitions of CHR 005-007
     C6
     A1
     41
C670 52 MOV   %>18,B
     18
C672 9A LDA   *R65
     41
C674 DB DECD  R65
     41
C676 E9 TRAP22              Send data to the LCD controller
C677 CA DJNZ  B,F9          [C672]
     F9
C679 22 MOV   %>CF,A        LCD command
     CF
C67B EA TRAP21              Send command to the LCD controller
C67C 22 MOV   %>07,A
     07
C67E E9 TRAP22              Send data to the LCD controller
C67F 22 MOV   %>02,A        LCD command
     02
C681 E0 JMP   33            [C6B6]
     33

Commands for LCD controller

The commands to perform the initialization are:

C683 68  Set the RAM address to CHR(5)
C684 0C  Turn on the display
C685 06  Set the cursor move direction to increment
C686 01  Clear the entire display and return the cursor to the home position
C687 38  Set the number of lines to 2
C688 30
C689 30  Set the interface data length to 8 bits, the number of lines to 1 and
         the font to 5x7 dots.

Data for LCD ram

C68A 00 Define CHR 007 as ' '
C68B 00
C68C 00
C68D 00
C68E 00
C68F 00
C690 00
C691 00

C692 00 Define CHR 006 as '~`
C693 00 CHR 006 is used to replace the standard HD44780 arrow character
C694 00
C695 02
C696 15
C697 08
C698 00
C699 00

C69A 00 Define CHR 005 as '\'
C69B 00 CHR 005 is used to replace the standard HD44780 YEN character
C69C 01
C69D 02
C69E 04
C69F 08
C6A0 10
C6A1 00

SBA 276

C6A2 8A LDA   @>2104        Cursor
     21
     04
C6A5 C0 MOV   A,B
C6A6 23 AND   %>7F,A
     7F
C6A8 2D CMP   %>10,A
     10
C6AA E7 JL    02            [C6AE]
     02
C6AC 28 ADD   %>30,A
     30
C6AE 24 OR    %>80,A
     80
C6B0 EA TRAP21              Send command to the LCD controller
C6B1 57 BTJZ  %>80,B,0E     [C6C2]
     80
     0E
C6B4 22 MOV   %>0D,A
     0D

TRAP 21
This TRAP is used to send commands to the LCD controller

C6B6 B8 PUSH  A
C6B7 8A LDA   @>1000        Read the LCD status
     10
     00
C6BA 26 BTJO  %>80,A,FA     [C6B7] Wait until not busy
     80
     FA
C6BD B9 POP   A
C6BE 8B STA   @>1000        Send the command
     10
     00
C6C1 0A RETS

C6C2 22 MOV   %>0C,A
     0C
C6C4 E0 JMP   F0            [C6B6]
     F0

C6C6 8A LDA   @>2138        Load user cursor
     21
     38
C6C9 B2 DEC   A
C6CA C0 MOV   A,B
C6CB 5A SUB   %>0F,B
     0F
C6CD E7 JNC   0D            [C6DC]
     0D
C6CF E2 JZ    0B            [C6DC]
     0B
C6D1 4A SUB   R1,R92
     01
     5C
C6D4 7B SBB   %>00,R91
     00
     5B
C6D7 74 OR    %>02,R47      Set flag 57
     02
     2F
C6DA 22 MOV   %>0F,A
     0F
C6DC 24 OR    %>80,A
     80
C6DE 8B STA   @>2104
     21
     04
C6E1 8E CALL  @>C83D        SBA 256
     C8                     Update the indicators
     3D
C6E4 8C BR    @>C7A7        SBA 260
     C7
     A7

C6E7 88 MOVD  %>218F,R92
     21
     8F
     5C
C6EB 76 BTJO  %>10,R47,D7   [C6C6] Test if flag 60 is set
     10
     2F
     D7
C6EF 8E CALL  @>C6C2
     C6
     C2
C6F2 98 MOVD  R92,R66
     5C
     42
C6F5 72 MOV   %>40,R64      Number of characters in user alpha register,
     40                     outside the display
     40
C6F8 C5 CLR   B             Set pointer to zero
C6F9 AA LDA   @>2140(B)     Load character from alpha register
     21
     40
C6FC 2D CMP   %>20,A        Compare with ' '
     20
C6FE E6 JNE   04            [C704] Not ' '?, scroll
     04
C700 C3 INC   B             Increment pointer
C701 DA DJNZ  R64,F5        [C6F9] Repeat for entire alpharegister outside
     40                     the display
     F5
C704 77 BTJZ  %>01,R47,37   [C73F] Test if flag 56 is reset
     01
     2F
     37
C708 73 AND   %>FE,R47      Reset flag 56
     FE
     2F
C70B 72 MOV   %>2D,R67
     2D
     43
C70E 8E CALL  @>D001        SBA 280
     D0                     Set the address of INT 2 to TRAP 3 [= >FF63]
     01
C711 8E CALL  @>C803        SBA 220
     C8                     Put 16 characters in the LCD RAM of the display
     03
C714 D2 DEC   R64
     40
C716 E7 JNC   A9            [C6C1]
     A9
C718 DB DECD  R66
     42
C71A 98 MOVD  R66,R92
     42
     5C
C71D 22 MOV   %>9F,A        Timer control : 1 0 0 11111
     9F
C71F 52 MOV   %>8C,B        Interrupt mask: 10 00 11 00
     8C
C721 8E CALL  @>F093        SBA 493
     F0                     Start the timer and wait for an interrupt
     93
C724 DA DJNZ  R67,F6        [C71D]
     43
     F6
C727 72 MOV   %>09,R67
     09
     43
C72A 88 MOVD  %>1040,R1     Values to scan for ->
     10
     40
     01
C72E 8E CALL  @>F05A        SBA 45A
     F0                     Scan for (a) specific key(s) to be pressed
     5A
C731 E6 JNZ   B4            [C6E7]
     B4
C733 76 BTJO  %>02,R47,DA   [C711] Test if flag 57 is set
     02
     2F
     DA
C737 74 OR    %>02,R47      Set flag 57
     02
     2F
C73A 8E CALL  @>C83D        SBA 256
     C8                     Update the indicators
     3D
C73D E0 JMP   D2            [C711]
     D2

C73F 12 MOV   R64,A
     40
C741 E2 JZ    0C            [C74F]
     0C
C743 4A SUB   R0,R92
     00
     5C
C746 7B SBB   %>00,R91
     00
     5B
C749 74 OR    %>02,R47      Set flag 57
     02
     2F
C74C 8E CALL  @>C83D        SBA 256
     C8                     Update the indicators
     3D
C74F 8C BR    @>C803        SBA 220
     C8                     Put 16 characters in the LCD RAM of the display
     03

C752 E0 JMP   93            [C6E7]
     93

C754 73 AND   %>7F,R44      Reset flag 39
     7F
     2C

SBA 226
This SBA performs a pause, but without the one second delay of the PAU function

C757 73 AND   %>FD,R47      Reset flag 57
     FD
     2F
C75A 8E CALL  @>C83D        SBA 256
     C8                     Update the indicators
     3D
C75D 76 BTJO  %>01,R43,0D   [C76E] Test if flag 24 is set
     01
     2B
     0D
C761 77 BTJZ  %>20,R48,04   [C769] Test if flag 69 is reset
     20
     30
     04
C765 76 BTJO  %>40,R48,14   [C77D] Test if flag 70 is set
     40
     30
     14
C769 8E CALL  @>C7AD        SBA 224
     C7                     Put blanks in the LCD RAM of the Fx keys
     AD
C76C E0 JMP   0F            [C77D]
     0F

C76E 88 MOVD  %>20B8,R92    Address of first character of user Fx
     20                     definitions
     B8
     5C
C772 76 BTJO  %>02,R43,04   [C77A] Test if flag 25 is set
     02
     2B
     04
C776 88 MOVD  %>20E5,R92    Address of first character of system Fx
     20                     definitions
     E5
     5C
C77A 8E CALL  @>C813        SBA 222
     C8                     Put 15 characters in the LCD RAM of the Fx keys
     13
C77D B5 CLR   A
C77E 8B STA   @>2104
     21
     04
C781 76 BTJO  %>20,R48,3E   [C7C3] Test if flag 69 is set
     20
     30
     3E
C785 76 BTJO  %>02,R50,1A   [C7A3] Test if flag 81 is set
     02
     32
     1A
C789 76 BTJO  %>80,R45,48   [C7D5] Test if flag 47 is set
     80
     2D
     48
C78D 88 MOVD  %>219F,R92    Address of first character of system alpha
     21                     register
     9F
     5C
C791 76 BTJO  %>20,R47,12   [C7A7] Test if flag 61 is set
     20
     2F
     12
C795 76 BTJO  %>40,R47,B9   [C752] Test if flag 62 is set
     40
     2F
     B9
C799 76 BTJO  %>10,R47,29   [C7C6] Test if flag 60 is set
     10
     2F
     29
C79D 8E CALL  @>CA04        SBA 22A
     CA
     04
C7A0 8E CALL  @>CB85        SBA 22C
     CB
     85
C7A3 88 MOVD  %>224F,R92    Address of first character in the PD buffer
     22
     4F
     5C

SBA 260

C7A7 8E CALL  @>C803        SBA 220
     C8                     Put 16 characters in the LCD RAM of the display
     03
C7AA 8C BR    @>C6A2        SBA 276
     C6
     A2

SBA 224
Store spaces in the LCD RAM above the Fx keys

C7AD 8A LDA   @>1000        Load LCD status
     10
     00
C7B0 E1 JN    FB            [C7AD] Wait until not busy
     FB
C7B2 B8 PUSH  A             Save current status
C7B3 88 MOVD  %>C00F,R1
     C0
     0F
     01
C7B7 8E CALL  @>C7BC
     C7
     BC
C7BA E0 JMP   6F            [C82B]
     6F

C7BC EA TRAP21              Send command to the LCD controller
C7BD 22 MOV   %>20,A        ASCII code for ' '
     20
C7BF E9 TRAP22              Send data to the LCD controller
C7C0 CA DJNZ  B,FD          [C7BF]
     FD
C7C2 0A RETS

C7C3 8C BR    @>D401
     D4
     01

C7C6 88 MOVD  %>8010,R1
     80
     10
     01
C7CA 8E CALL  @>C7BC
     C7
     BC
C7CD 22 MOV   %>80,A
     80
C7CF 8B STA   @>2104
     21
     04
C7D2 8C BR    @>C6A2        SBA 276
     C6
     A2

C7D5 8E CALL  @>CD30        SBA 26A
     CD                     Fill the first 20 positions of the PD buffer
     30                     with blanks
C7D8 22 MOV   %>8F,A
     8F
C7DA 8B STA   @>2104
     21
     04
C7DD 8E CALL  @>CB6C
     CB
     6C
C7E0 72 MOV   %>40,R64
     40
     40
C7E3 76 BTJO  %>40,R45,0E   [C7F5] Test if flag 46 is set
     40
     2D
     0E
C7E7 D3 INC   R64
     40
C7E9 8A LDA   @>21A1
     21
     A1
C7EC E5 JPZ   02            [C7F0]
     02
C7EE D2 DEC   R64
     40
C7F0 8E CALL  @>CC03
     CC
     03
C7F3 E0 JMP   AE            [C7A3]
     AE

C7F5 8E CALL  @>CC3E
     CC
     3E
C7F8 8A LDA   @>21A1
     21
     A1
C7FB 2D CMP   %>04,A
     04
C7FD E3 JHS   F1            [C7F0]
     F1
C7FF 22 MOV   %>04,A
     04
C801 E0 JMP   ED            [C7F0]
     ED

SBA 220
Put 16 characters in the LCD RAM of the display

C803 88 MOVD  %>8010,R1
     80
     10
     01
C807 EA TRAP21              Send command to the LCD controller
C808 9A LDA   *R92
     5C
C80A 8E CALL  @>C830        Translate Yen and arrow into backslash and tilde
     C8
     30
C80D DB DECD  R92
     5C
C80F E9 TRAP22              Send data to the LCD controller
C810 CA DJNZ  B,F6          [C808]
     F6
C812 0A RETS

SBA 222
Put 15 characters in the LCD RAM of the function keys

C813 8A LDA   @>1000
     10
     00
C816 E1 JN    FB            [C813]
     FB
C818 B8 PUSH  A
C819 88 MOVD  %>C00F,R1
     C0
     0F
     01
C81D EA TRAP21              Send command to the LCD controller
C81E 9A LDA   *R92
     5C
C820 8E CALL  @>C830        Translate Yen and arrow into backslash and tilde
     C8
     30
C823 D3 INC   R92
     5C
C825 79 ADC   %>00,R91
     00
     5B
C828 E9 TRAP22              Send data to the LCD controller
C829 CA DJNZ  B,F3          [C81E]
     F3
C82B B9 POP   A
C82C 24 OR    %>80,A
     80
C82E EA TRAP21              Send command to the LCD controller
C82F 0A RETS

The following routine replaces the standard HD44780 characters '' and '->'
by '\' and '~'

C830 2D CMP   %>5C,A        ASCII code for YEN
     5C
C832 E6 JNE   02            [C836]
     02
C834 22 MOV   %>05,A        Replace YEN by '\'
     05
C836 2D CMP   %>7E,A        ASCII code for arrow
     7E
C838 E6 JNE   02            [C83C]
     02
C83A 22 MOV   %>06,A        Replace arrow by '~'
     06
C83C 0A RETS

SBA 256
This SBA is used to update the indicator information of the display

The various indicators are mapped into CHR 007. The mapping is:

Row 1: HEX   OCT   I/O   RUN   SYS
Row 2: DE    INS   LC    G     RAD
Row 5: LOW   2ND   ALPHA ERROR INV
Row 8: P     <

C83D 8A LDA   @>1000        Read the status of LCD controller
     10
     00
C840 E1 JN    FB            [C83D] Wait until not busy
     FB
C842 B8 PUSH  A
C843 22 MOV   %>78,A        Command to point to row 1 of CHR(7)
     78
C845 EA TRAP21              Send command to the LCD controller
C846 B5 CLR   A
C847 77 BTJZ  %>04,R45,02   [C84D] Test if flag 42 is reset
     04
     2D
     02
C84B 24 OR    %>10,A        Set bit for HEX indicator
     10
C84D 77 BTJZ  %>02,R45,02   [C853] Test if flag 41 is reset
     02
     2D
     02
C851 24 OR    %>08,A        Set bit for OCT indicator
     08
C853 77 BTJZ  %>20,R49,02   [C859] Test if flag 77 is reset
     20
     31
     02
C857 24 OR    %>04,A        Set bit for I/O indicator
     04
C859 76 BTJO  %>70,R43,02   [C85F] Test if flag 28, 29 or 30 is set
     70
     2B
     02
C85D E0 JMP   02            [C861]
     02

C85F 24 OR    %>02,A        Set bit for RUN indicator
     02
C861 77 BTJZ  %>02,R46,02   [C867] Test if flag 49 is reset
     02
     2E
     02
C865 24 OR    %>01,A        Set bit for SYS indicator
     01
C867 E9 TRAP22              Send data to the LCD controller
C868 22 MOV   %>01,A        Set bit for RAD indicator
     01
C86A 76 BTJO  %>02,R44,08   [C876] Test if flag 33 is set
     02
     2C
     08
C86E 24 OR    %>02,A        Set bit for GRAD indicator
     02
C870 76 BTJO  %>04,R44,02   [C876] Test if flag 34 is set
     04
     2C
     02
C874 25 XOR   %>11,A        Reset bit 0 and 1 for DEG indicator
     11
C876 77 BTJZ  %>80,R47,02   [C87C] Test if flag 63 is reset
     80
     2F
     02
C87A 24 OR    %>04,A        Set bit for LC indicator
     04
C87C 76 BTJO  %>0C,R47,02   [C882] Test if flag 58 or 59 is set
     0C
     2F
     02
C880 E0 JMP   02            [C884]
     02

C882 24 OR    %>08,A        Set bit for INS indicator
     08
C884 E9 TRAP22              Send data to the LCD controller
C885 22 MOV   %>7C,A        Command to point to row 5 of CHR(7)
     7C
C887 EA TRAP21              Send command to the LCD controller
C888 12 MOV   R49,A         Get flags 72..79
     31
C88A 23 AND   %>10,A        Reset all, except 76 [LOW indicator]
     10
C88C 77 BTJZ  %>80,R44,02   [C892] Test if flag 39 is reset
     80
     2C
     02
C890 24 OR    %>08,A        Set bit for 2nd indicator
     08
C892 77 BTJZ  %>10,R47,02   [C898] Test if flag 60 is reset
     10
     2F
     02
C896 24 OR    %>04,A        Set bit for ALPHA indicator
     04
C898 77 BTJZ  %>20,R46,02   [C89E] Test if flag 53 is reset
     20
     2E
     02
C89C 24 OR    %>02,A        Set bit for ERROR indicator
     02
C89E 76 BTJO  %>70,R43,06   [C8A8] Test if flag 28, 29 or 30 is set
     70
     2B
     06
C8A2 77 BTJZ  %>40,R44,02   [C8A8] Test if flag 38 is reset
     40
     2C
     02
C8A6 24 OR    %>01,A        Set bit for INV indicator
     01
C8A8 E9 TRAP22              Send data to the LCD controller
C8A9 22 MOV   %>7F,A        Command to point to row 8 of CHR(7)
     7F
C8AB EA TRAP21              Send command to the LCD controller
C8AC B5 CLR   A
C8AD 77 BTJZ  %>08,R49,02   [C8B3] Test if flag 75 is reset
     08
     31
     02
C8B1 24 OR    %>10,A        Set bit for P indicator
     10
C8B3 77 BTJZ  %>02,R47,02   [C8B9] Test if flag 57 is reset
     02
     2F
     02
C8B7 24 OR    %>08,A        Set bit for < indicator
     08
C8B9 E9 TRAP22              Send data to the LCD controller
C8BA 8C BR    @>C82B
     C8
     2B

SBA 25C
This SBA performs the PAU function

C8BD F3 TRAP12              Reset flags 35, 37, 38 and 59
C8BE 74 OR    %>01,R47      Set flag 56
     01
     2F
C8C1 76 BTJO  %>78,R43,01   [C8C6] Test if flag 27, 28, 29 or 30 is set
     78
     2B
     01
C8C5 0A RETS

C8C6 8E CALL  @>C757        SBA 226
     C7                     Pause without delay
     57

SBA 268
This SBA delays program execution for approximately 1 second. The display is
not updated.

C8C9 8E CALL  @>D001        SBA 280
     D0                     Set the address of INT 2 to TRAP 3 [= >FF63]
     01
C8CC 72 MOV   %>1E,R64
     1E
     40
C8CF 22 MOV   %>9F,A        Timer control : 1 0 0 11111
     9F
C8D1 52 MOV   %>8C,B        Interrupt mask: 10 00 11 00
     8C
C8D3 8E CALL  @>F093        SBA 493
     F0                     Start the timer and wait for an interrupt
     93
C8D6 DA DJNZ  R64,FA        [C8D3]
     40
     FA
C8D9 0A RETS

Data for display testpatterns

C8DA FF
C8DB FF
C8DC 15
C8DD 0A
C8DE 0A
C8DF 15
C8E0 15
C8E1 15
C8E2 0A
C8E3 0A
C8E4 FF
C8E5 FF

SBA 230
This SBA is used to display a series of display testpatterns

C8E6 22 MOV   %>48,A        Command to point at CHR(1)
     48
C8E8 EA TRAP21              Send command to the LCD controller
C8E9 52 MOV   %>0B,B
     0B
C8EB 72 MOV   %>04,R64
     04
     40
C8EE AA LDA   @>C8D9(B)
     C8
     D9
C8F1 E9 TRAP22              Send data to the LCD controller
C8F2 AA LDA   @>C8DA(B)
     C8
     DA
C8F5 E9 TRAP22              Send data to the LCD controller
C8F6 DA DJNZ  R64,F5        [C8EE]
     40
     F5
C8F9 C2 DEC   B
C8FA C2 DEC   B
C8FB E4 JP    EE            [C8EB]
     EE
C8FD 22 MOV   %>06,A
     06
C8FF 8B STA   @>22BE
     22
     BE
C902 B5 CLR   A
C903 8B STA   @>2104
     21
     04
C906 8E CALL  @>C6A2        SBA 276
     C6
     A2
C909 8E CALL  @>C650        SBA 23A
     C6                     Send data at >22BE to LCD controller
     50
C90C 8A LDA   @>2104
     21
     04
C90F B3 INC   A
C910 8B STA   @>2104
     21
     04
C913 2D CMP   %>20,A
     20
C915 E6 JNE   EF            [C906]
     EF
C917 8E CALL  @>CF66        SBA 236
     CF                     Wait for key
     66
C91A 73 AND   %>7F,R44      Reset flag 39
     7F
     2C
C91D 7D CMP   %>09,R37      Scancode for HLT
     09
     25
C920 E2 JEQ   05            [C927]
     05
C922 8A LDA   @>22BE
     22
     BE
C925 BA DJNZ  A,D8          [C8FF]
     D8
C927 8C BR    @>C664        SBA 21E
     C6                     Initialize the LCD
     64

SBA 23C
This SBA is used to test the LCD controller

C92A B5 CLR   A
C92B 8E CALL  @>C978
     C9
     78
C92E E6 JNZ   42            [C972]
     42
C930 52 MOV   %>5A,B
     5A
C932 8E CALL  @>C97D
     C9
     7D
C935 E6 JNZ   3B            [C972]
     3B
C937 22 MOV   %>10,A
     10
C939 8E CALL  @>C978
     C9
     78
C93C E6 JNZ   34            [C972]
     34
C93E 52 MOV   %>5A,B
     5A
C940 8E CALL  @>C97D
     C9
     7D
C943 E6 JNZ   2D            [C972]
     2D
C945 22 MOV   %>A5,A
     A5
C947 B8 PUSH  A
C948 22 MOV   %>40,A
     40
C94A EA TRAP21              Send command to the LCD controller
C94B 52 MOV   %>40,B
     40
C94D B9 POP   A
C94E B8 PUSH  A
C94F E9 TRAP22              Send data to the LCD controller
C950 BE RL    A
C951 CA DJNZ  B,FC          [C94F]
     FC
C953 22 MOV   %>40,A
     40
C955 EA TRAP21              Send command to the LCD controller
C956 52 MOV   %>40,B
     40
C958 B9 POP   A
C959 8E CALL  @>C967
     C9
     67
C95C E6 JNE   14            [C972]
     14
C95E BE RL    A
C95F CA DJNZ  B,F8          [C959]
     F8
C961 B4 INV   A
C962 27 BTJZ  %>80,A,E2     [C947]
     80
     E2
C965 E0 JMP   C0            [C927]
     C0

C967 B8 PUSH  A
C968 8A LDA   @>1000
     10
     00
C96B E1 JN    FB            [C968]
     FB
C96D B9 POP   A
C96E 8D CMPA  @>1001
     10
     01
C971 0A RETS

C972 8E CALL  @>C664        SBA 21E
     C6                     Initialize the LCD
     64
C975 8C BR    @>D0CF
     D0
     CF

C978 8B STA   @>2104
     21
     04
C97B 52 MOV   %>A5,B
     A5
C97D C8 PUSH  B
C97E 8E CALL  @>C6A2        SBA 276
     C6
     A2
C981 22 MOV   %>08,A
     08
C983 EA TRAP21              Send command to the LCD controller
C984 52 MOV   %>28,B
     28
C986 B9 POP   A
C987 B8 PUSH  A
C988 E9 TRAP22              Send data to the LCD controller
C989 BE RL    A
C98A CA DJNZ  B,FC          [C988]
     FC
C98C 8E CALL  @>C6A2        SBA 276
     C6
     A2
C98F 22 MOV   %>08,A
     08
C991 EA TRAP21              Send command to the LCD controller
C992 52 MOV   %>28,B
     28
C994 B9 POP   A
C995 8E CALL  @>C967
     C9
     67
C998 E6 JNZ   04            [C99E]
     04
C99A BE RL    A
C99B CA DJNZ  B,F8          [C995]
     F8
C99D B5 CLR   A
C99E 0A RETS

C99F 88 MOVD  %>003F,R81    Source of data, the display
     00
     3F
     51
C9A3 88 MOVD  %>22A7,R83    Destination of data
     22
     A7
     53
C9A7 88 MOVD  %>0008,R85    Number of bytes to move, 8
     00
     08
     55
C9AB 8C BR    @>F051        SBA 451
     F0                     Move block
     51

C9AE 8E CALL  @>C41E        Clear the display
     C4
     1E
C9B1 E0 JMP   7E            [CA31]
     7E

C9B3 76 BTJO  %>08,R57,F7   [C9AE]
     08
     39
     F7
C9B7 77 BTJZ  %>04,R45,0B   [C9C6] Test if flag 42 is reset
     04
     2D
     0B
C9BB 7D CMP   %>13,R56
     13
     38
C9BE E7 JL    71            [CA31]
     71
C9C0 E0 JMP   04            [C9C6]
     04

C9C2 76 BTJO  %>06,R45,ED   [C9B3] Test if flag 41 or 42 is set
     06
     2D
     ED
C9C6 74 OR    %>02,R48      Set flag 65
     02
     30
C9C9 77 BTJZ  %>08,R45,1B   [C9E8] Test if flag 43 is reset
     08
     2D
     1B
C9CD D5 CLR   R64
     40
C9CF 4D CMP   R64,R56
     40
     38
C9D2 E2 JEQ   14            [C9E8]
     14
C9D4 E7 JL    06            [C9DC]
     06
C9D6 B0 CLRC
C9D7 7E DAC   %>03,R64
     03
     40
C9DA E0 JMP   F3            [C9CF]
     F3

C9DC 8E CALL  @>C409
     C4
     09
C9DF 8A LDA   @>21A0
     21
     A0
C9E2 B2 DEC   A
C9E3 8B STA   @>21A0
     21
     A0
C9E6 E0 JMP   E5            [C9CD]
     E5

C9E8 8A LDA   @>21A0
     21
     A0
C9EB 76 BTJO  %>02,R48,11   [CA00] Test if flag 65 is set
     02
     30
     11
C9EF 77 BTJZ  %>08,R48,0D   [CA00] Test if flag 67 is reset
     08
     30
     0D
C9F3 C0 MOV   A,B
C9F4 8A LDA   @>21A6        Number of digits after decimal point
     21
     A6
C9F7 3A SUB   R0,B
     00
C9F9 E7 JNC   05            [CA00]
     05
C9FB 62 MOV   B,A
C9FC 2D CMP   %>08,A
     08
C9FE E3 JHS   02            [CA02]
     02
CA00 22 MOV   %>08,A
     08
CA02 E0 JMP   6D            [CA71]
     6D

SBA 22A

CA04 8E CALL  @>C2B0        SBA 208
     C2                     Calculate the exponent
     B0
CA07 73 AND   %>F9,R48      Reset flags 65 and 66
     F9
     30
CA0A 76 BTJO  %>01,R45,91   [C99F] Test if flag 40 is set
     01
     2D
     91
CA0E 8E CALL  @>CB6C
     CB
     6C
CA11 12 MOV   R56,A
     38
CA13 2D CMP   %>A0,A
     A0
CA15 E3 JHS   05            [CA1C]
     05
CA17 B7 SWAP  A
CA18 2D CMP   %>A0,A
     A0
CA1A E7 JL    05            [CA21]
     05
CA1C D5 CLR   R56
     38
CA1E 73 AND   %>F7,R57
     F7
     39
CA21 73 AND   %>FD,R48      Reset flag 65
     FD
     30
CA24 22 MOV   %>0E,A
     0E
CA26 8B STA   @>21A0
     21
     A0
CA29 76 BTJO  %>18,R45,9C   [C9C9] Test if flag 43 or 44 is set
     18
     2D
     9C
CA2D 76 BTJO  %>F0,R56,91   [C9C2]
     F0
     38
     91
CA31 76 BTJO  %>08,R57,11   [CA46]
     08
     39
     11
CA35 7D CMP   %>00,R56
     00
     38
CA38 E2 JEQ   1D            [CA57]
     1D
CA3A 8E CALL  @>C409
     C4
     09
CA3D 8A LDA   @>21A0
     21
     A0
CA40 B2 DEC   A
CA41 8B STA   @>21A0
     21
     A0
CA44 E0 JMP   EF            [CA35]
     EF

CA46 22 MOV   %>0F,A
     0F
CA48 8B STA   @>21A0
     21
     A0
CA4B E0 JMP   03            [CA50]
     03

CA4D 8E CALL  @>CB4B
     CB
     4B
CA50 8E CALL  @>C3D8
     C3
     D8
CA53 76 BTJO  %>08,R57,F6   [CA4D]
     08
     39
     F6
CA57 8A LDA   @>21A0
     21
     A0
CA5A 76 BTJO  %>06,R45,13   [CA71] Test if flag 41 or 42 is set
     06
     2D
     13
CA5E 77 BTJZ  %>08,R48,0D   [CA6F] Test if flag 67 is reset
     08
     30
     0D
CA62 C0 MOV   A,B
CA63 8A LDA   @>21A6
     21
     A6
CA66 3A SUB   R0,B
     00
CA68 E7 JNC   05            [CA6F]
     05
CA6A 62 MOV   B,A
CA6B 2D CMP   %>05,A
     05
CA6D E3 JHS   02            [CA71]
     02
CA6F 22 MOV   %>05,A
     05
CA71 8B STA   @>21A7
     21
     A7
CA74 2D CMP   %>02,A
     02
CA76 E2 JEQ   7F            [CAF7]
     7F
CA78 72 MOV   %>01,R64
     01
     40
CA7B C0 MOV   A,B
CA7C CD RRC   B
CA7D E3 JC    0F            [CA8E]
     0F
CA7F D7 SWAP  R64
     40
CA81 AA LDA   @>0038(B)
     00
     38
CA84 B8 PUSH  A
CA85 23 AND   %>F0,A
     F0
CA87 AB STA   @>0038(B)
     00
     38
CA8A B9 POP   A
CA8B B7 SWAP  A
CA8C E0 JMP   03            [CA91]
     03

CA8E AA LDA   @>0038(B)
     00
     38
CA91 76 BTJO  %>04,R48,4E   [CAE3] Test if flag 66 is set
     04
     30
     4E
CA95 2D CMP   %>50,A
     50
CA97 E7 JL    4A            [CAE3]
     4A
CA99 8A LDA   @>21A7
     21
     A7
CA9C B3 INC   A
CA9D BD RRC   A
CA9E C0 MOV   A,B
CA9F 26 BTJO  %>F8,A,1B     [CABD]
     F8
     1B
CAA2 AA LDA   @>0038(B)
     00
     38
CAA5 1E DAC   R64,A
     40
CAA7 E0 JMP   08            [CAB1]
     08

CAA9 AA LDA   @>0038(B)
     00
     38
CAAC 08 POPST
CAAD E7 JNC   34            [CAE3]
     34
CAAF 2E DAC   %>00,A
     00
CAB1 0E PUSHST
CAB2 AB STA   @>0038(B)
     00
     38
CAB5 C3 INC   B
CAB6 5D CMP   %>08,B
     08
CAB8 E7 JL    EF            [CAA9]
     EF
CABA 08 POPST
CABB E7 JNC   26            [CAE3]
     26
CABD 76 BTJO  %>08,R97,0E   [CACF]
     08
     61
     0E
CAC1 7D CMP   %>99,R56
     99
     38
CAC4 E7 JL    09            [CACF]
     09
CAC6 74 OR    %>04,R48      Set flag 66
     04
     30
CAC9 8E CALL  @>CB41
     CB
     41
CACC 8C BR    @>CA21
     CA
     21

CACF 8E CALL  @>C41E        Clear the display
     C4
     1E
CAD2 42 MOV   R96,R56
     60
     38
CAD5 42 MOV   R97,R57
     61
     39
CAD8 73 AND   %>0F,R57
     0F
     39
CADB 72 MOV   %>10,R63
     10
     3F
CADE 8E CALL  @>C3D8
     C3
     D8
CAE1 E0 JMP   E9            [CACC]
     E9

CAE3 8A LDA   @>21A7
     21
     A7
CAE6 B2 DEC   A
CAE7 C0 MOV   A,B
CAE8 CD RRC   B
CAE9 B5 CLR   A
CAEA E0 JMP   04            [CAF0]
     04

CAEC AB STA   @>0038(B)
     00
     38
CAEF C2 DEC   B
CAF0 5D CMP   %>02,B
     02
CAF2 E3 JHS   F8            [CAEC]
     F8
CAF4 73 AND   %>0F,R57
     0F
     39
CAF7 8A LDA   @>21A0
     21
     A0
CAFA 2D CMP   %>0F,A
     0F
CAFC E6 JNE   15            [CB13]
     15
CAFE 12 MOV   R59,A
     3B
CB00 23 AND   %>0F,A
     0F
CB02 E6 JNZ   0F            [CB13]
     0F
CB04 8E CALL  @>CB4B
     CB
     4B
CB07 22 MOV   %>0E,A
     0E
CB09 8B STA   @>21A0
     21
     A0
CB0C 8A LDA   @>21A7
     21
     A7
CB0F B2 DEC   A
CB10 8B STA   @>21A7
     21
     A7
CB13 76 BTJO  %>02,R48,04   [CB1B] Test if flag 65 is set
     02
     30
     04
CB17 76 BTJO  %>08,R48,23   [CB3E] Test if flag 67 is set
     08
     30
     23
CB1B 8A LDA   @>21A7
     21
     A7
CB1E 8D CMPA  @>21A0
     21
     A0
CB21 E3 JHS   1B            [CB3E]
     1B
CB23 B3 INC   A
CB24 C0 MOV   A,B
CB25 CD RRC   B
CB26 E3 JC    06            [CB2E]
     06
CB28 AA LDA   @>0038(B)
     00
     38
CB2B B7 SWAP  A
CB2C E0 JMP   03            [CB31]
     03

CB2E AA LDA   @>0038(B)
     00
     38
CB31 23 AND   %>F0,A
     F0
CB33 E6 JNZ   09            [CB3E]
     09
CB35 8A LDA   @>21A7
     21
     A7
CB38 B3 INC   A
CB39 8B STA   @>21A7
     21
     A7
CB3C E0 JMP   E0            [CB1E]
     E0

CB3E 8E CALL  @>C99F
     C9
     9F
CB41 88 MOVD  %>0067,R81    Address of MSB of SR 2012
     00
     67
     51
CB45 88 MOVD  %>003F,R83    Address of MSB of SR 2007
     00
     3F
     53
CB49 E0 JMP   29            [CB74]
     29

CB4B 52 MOV   %>06,B
     06
CB4D D5 CLR   R64
     40
CB4F AA LDA   @>0039(B)
     00
     39
CB52 B7 SWAP  A
CB53 B8 PUSH  A
CB54 23 AND   %>0F,A
     0F
CB56 73 AND   %>F0,R64
     F0
     40
CB59 14 OR    R64,A
     40
CB5B AB STA   @>0039(B)
     00
     39
CB5E D9 POP   R64
     40
CB60 CA DJNZ  B,ED          [CB4F]
     ED
CB62 73 AND   %>F0,R64
     F0
     40
CB65 73 AND   %>0F,R57
     0F
     39
CB68 44 OR    R64,R57
     40
     39
CB6B 0A RETS

CB6C 88 MOVD  %>003F,R81    Source of data, the display
     00
     3F
     51
CB70 88 MOVD  %>0067,R83    Destination of data, SR 2012
     00
     67
     53
CB74 88 MOVD  %>0008,R85    Number of bytes to move
     00
     08
     55
CB78 8C BR    @>F051        SBA 451
     F0                     Move block
     51

The following routine places '**********' in the display for octal- and hexa-
decimal numbers that are to large to be displayed

CB7B 22 MOV   %>2A,A        ASCII code for '*'
     2A
CB7D 52 MOV   %>0A,B        Number of '*' to place
     0A
CB7F AB STA   @>2243(B)     Destination of '*'s, the PD buffer
     22
     43
CB82 CA DJNZ  B,FB          [CB7F] Loop until all are placed
     FB
CB84 0A RETS

SBA 22C

CB85 8E CALL  @>CD30        SBA 26A
     CD                     Fill the first 20 positions of the PD buffer
     30                     with blanks
CB88 76 BTJO  %>06,R45,19   [CBA5] Test if flag 41 or 42 is set
     06
     2D
     19
CB8C 88 MOVD  %>22A7,R81
     22
     A7
     51
CB90 8E CALL  @>CB70
     CB
     70
CB93 77 BTJZ  %>01,R45,5B   [CBF2] Test if flag 40 is reset
     01
     2D
     5B
CB97 72 MOV   %>40,R64
     40
     40
CB9A 22 MOV   %>FF,A
     FF
CB9C 8B STA   @>21A7
     21
     A7
CB9F B2 DEC   A
CBA0 8B STA   @>21A0
     21
     A0
CBA3 E0 JMP   5B            [CC00]
     5B

CBA5 76 BTJO  %>02,R48,D2   [CB7B] Test if flag 65 is set
     02
     30
     D2
CBA9 8E CALL  @>CCFD
     CC
     FD
CBAC 76 BTJO  %>02,R45,56   [CC06] Test if flag 41 is set
     02
     2D
     56
CBB0 8E CALL  @>CD48        SBA 23E
     CD
     48
CBB3 56 BTJO  %>01,B,C5     [CB7B] Display '**********'
     01
     C5
CBB6 77 BTJZ  %>01,R49,2E   [CBE8] Test if flag 72 is reset
     01
     31
     2E
CBBA 76 BTJO  %>04,R97,0B   [CBC9]
     04
     61
     0B
CBBE 7D CMP   %>09,R96
     09
     60
CBC1 E6 JNE   25            [CBE8]
     25
CBC3 76 BTJO  %>80,R103,B4  [CB7B]
     80
     67
     B4
CBC7 E0 JMP   1F            [CBE8]
     1F

CBC9 8E CALL  @>CCFD
     CC
     FD
CBCC 88 MOVD  %>0060,R87
     00
     60
     57
CBD0 8E CALL  @>F05D        SBA 45D
     F0                     Convert STD to FP
     5D
CBD3 88 MOVD  %>C3D7,R71    Address of data
     C3
     D7
     47
CBD7 F6 TRAP9               Move data addressed by R70/71 into SR 2009
CBD8 EF TRAP16              SR 2012:= SR 2009 + SR 2012
CBD9 8E CALL  @>CD54
     CD
     54
CBDC 56 BTJO  %>01,B,9C     [CB7B]
     01
     9C
CBDF 7D CMP   %>09,R96
     09
     60
CBE2 E6 JNE   97            [CB7B]
     97
CBE4 77 BTJZ  %>80,R103,93  [CB7B]
     80
     67
     93
CBE8 22 MOV   %>0E,A
     0E
CBEA 1A SUB   R96,A
     60
CBEC 8B STA   @>21A0
     21
     A0
CBEF 8B STA   @>21A7
     21
     A7
CBF2 72 MOV   %>44,R64
     44
     40
CBF5 76 BTJO  %>18,R45,04   [CBFD] Test if flag 43 or 44 is set
     18
     2D
     04
CBF9 77 BTJZ  %>02,R48,03   [CC00] Test if flag 65 is reset
     02
     30
     03
CBFD 8E CALL  @>CC3E
     CC
     3E
CC00 8A LDA   @>21A7
     21
     A7
CC03 C0 MOV   A,B
CC04 E0 JMP   13            [CC19]
     13

CC06 E0 JMP   4B            [CC53]
     4B

CC08 C8 PUSH  B
CC09 CD RRC   B
CC0A E3 JC    05            [CC11]
     05
CC0C AA LDA   @>0060(B)
     00
     60
CC0F E0 JMP   04            [CC15]
     04

CC11 AA LDA   @>0060(B)
     00
     60
CC14 B7 SWAP  A
CC15 C9 POP   B
CC16 8E CALL  @>CD1D        Convert 0-F to ASCII '0'-'F'
     CD
     1D
CC19 8A LDA   @>21A0
     21
     A0
CC1C 6D CMP   B,A
CC1D E6 JNE   0A            [CC29]
     0A
CC1F D6 XCHB  R64
     40
CC21 22 MOV   %>2E,A        ASCII code for '.'
     2E
CC23 AB STA   @>2200(B)
     22
     00
CC26 C3 INC   B
CC27 D6 XCHB  R64
     40
CC29 C3 INC   B
CC2A 5D CMP   %>10,B
     10
CC2C E7 JL    DA            [CC08]
     DA
CC2E 76 BTJO  %>01,R45,0B   [CC3D] Test if flag 40 is set
     01
     2D
     0B
CC32 77 BTJZ  %>04,R97,07   [CC3D] Test for negative exponent
     04
     61
     07
CC36 32 MOV   R64,B
     40
CC38 22 MOV   %>2D,A        ASCII code for '-'
     2D
CC3A AB STA   @>2200(B)
     22
     00
CC3D 0A RETS

CC3E 12 MOV   R96,A
     60
CC40 8E CALL  @>CD1D        Convert 0-F to ASCII '0'-'F'
     CD
     1D
CC43 12 MOV   R96,A
     60
CC45 B7 SWAP  A
CC46 8E CALL  @>CD1D        Convert 0-F to ASCII '0'-'F'
     CD
     1D
CC49 77 BTJZ  %>08,R97,03   [CC50]
     08
     61
     03
CC4D 8E CALL  @>CC36
     CC
     36
CC50 D3 INC   R64
     40
CC52 0A RETS

CC53 88 MOVD  %>0060,R87    Destination, SR 2012
     00
     60
     57
CC57 8E CALL  @>F05D        SBA 45D
     F0                     Convert STD to FP
     5D
CC5A D8 PUSH  R96
     60
CC5C E5 JPZ   10            [CC6E]
     10
CC5E D4 INV   R96
     60
CC60 77 BTJZ  %>01,R49,0A   [CC6E] Test if flag 72 is reset
     01
     31
     0A
CC64 88 MOVD  %>0306,R1     SBA 306
     03                     Clear SR 2009
     06
     01
CC68 F8 TRAP7
CC69 88 MOVD  %>BF01,R73    FP: -1
     BF
     01
     49
CC6D EF TRAP16              SR 2012:= SR 2009 + SR 2012
CC6E 8E CALL  @>F021        SBA 421
     F0                     Move SR 2012 to SR 2009
     21
CC71 8E CALL  @>CB6C
     CB
     6C
CC74 F5 TRAP10              Push SR 2012 onto the FP stack
CC75 8E CALL  @>C41E        Clear the display
     C4
     1E
CC78 72 MOV   %>11,R56
     11
     38
CC7B 22 MOV   %>04,A
     04
CC7D 8B STA   @>2103
     21
     03
CC80 8E CALL  @>F0B1        SBA 4B1
     F0                     Push SR 2009 onto the FP stack
     B1
CC83 8E CALL  @>F018        SBA 418
     F0                     Clear SR 2012
     18
CC86 88 MOVD  %>4008,R97    FP: 8
     40
     08
     61
CC8A EE TRAP17              SR 2012:= SR 2009 / SR 2012
CC8B 88 MOVD  %>038A,R1     SBA 38A
     03                     SR 2012:= INT(SR 2012)
     8A
     01
CC8F F8 TRAP7
CC90 F5 TRAP10              Push SR 2012 onto the FP stack
CC91 8E CALL  @>F021        SBA 421
     F0                     Move SR 2012 to SR 2009
     21
CC94 8E CALL  @>F018        SBA 418
     F0                     Clear SR 2012
     18
CC97 88 MOVD  %>4008,R97    FP: 8
     40
     08
     61
CC9B F1 TRAP14              SR 2012:= SR 2009 * SR 2012
CC9C 7A SUB   %>08,R113
     08
     71
CC9F F4 TRAP11              Pop the FP stack into SR 2009
CCA0 8E CALL  @>F009        SBA 409
     F0                     SR 2012:= SR 2009 - SR 2012
     09
CCA3 8A LDA   @>2103
     21
     03
CCA6 2D CMP   %>0E,A
     0E
CCA8 E3 JHS   45            [CCEF]
     45
CCAA C0 MOV   A,B
CCAB B3 INC   A
CCAC 8B STA   @>2103
     21
     03
CCAF CD RRC   B
CCB0 E7 JNC   02            [CCB4]
     02
CCB2 D7 SWAP  R97
     61
CCB4 AA LDA   @>0038(B)
     00
     38
CCB7 18 ADD   R97,A
     61
CCB9 AB STA   @>0038(B)
     00
     38
CCBC 78 ADD   %>10,R113
     10
     71
CCBF F4 TRAP11              Pop the FP stack into SR 2009
CCC0 7A SUB   %>08,R113
     08
     71
CCC3 12 MOV   R73,A
     49
CCC5 E6 JNZ   B9            [CC80]
     B9
CCC7 77 BTJZ  %>01,R49,04   [CCCF] Test if flag 72 is reset
     01
     31
     04
CCCB 76 BTJO  %>40,R62,20   [CCEF]
     40
     3E
     20
CCCF B9 POP   A
CCD0 E5 JPZ   17            [CCE9]
     17
CCD2 74 OR    %>04,R57
     04
     39
CCD5 77 BTJZ  %>01,R49,10   [CCE9] Test if flag 72 is reset
     01
     31
     10
CCD9 73 AND   %>FB,R57
     FB
     39
CCDC 52 MOV   %>05,B
     05
CCDE AA LDA   @>0039(B)
     00
     39
CCE1 B4 INV   A
CCE2 23 AND   %>77,A
     77
CCE4 AB STA   @>0039(B)
     00
     39
CCE7 CA DJNZ  B,F5          [CCDE]
     F5
CCE9 8E CALL  @>CDC6
     CD
     C6
CCEC 8C BR    @>CBE8
     CB
     E8

CCEF B9 POP   A
CCF0 88 MOVD  %>206F,R113
     20
     6F
     71
CCF4 8E CALL  @>F033        SBA 433
     F0                     Pop the FP stack into SR 2012
     33
CCF7 8E CALL  @>CB41
     CB
     41
CCFA 8C BR    @>CB7B
     CB
     7B

CCFD 88 MOVD  %>22A7,R71    Address of MSB of SR 2100
     22
     A7
     47
CD01 F6 TRAP9               Move data addressed by R70/71 into SR 2009
CD02 12 MOV   R79,A
     4F
CD04 E6 JNZ   03            [CD09]
     03
CD06 73 AND   %>FB,R73
     FB
     49
CD09 8A LDA   @>21A0
     21
     A0
CD0C 52 MOV   %>0E,B
     0E
CD0E B6 XCHB  A
CD0F 6A SUB   B,A
CD10 2D CMP   %>0A,A
     0A
CD12 E7 JL    02            [CD16]
     02
CD14 28 ADD   %>06,A
     06
CD16 D0 MOV   A,R72
     48
CD18 88 MOVD  %>0048,R85
     00
     48
     55
CD1C 0A RETS

The following routine converts a nibble to its ASCII equivalent

CD1D 23 AND   %>0F,A        Mask out first 4 bits
     0F
CD1F 28 ADD   %>30,A        Add >30, ASCII for '0'
     30
CD21 2D CMP   %>3A,A
     3A
CD23 E7 JL    02            [CD27] Less than >3A?, no hexdigit
     02
CD25 28 ADD   %>07,A        Add >7 more to obtain >41..>46 [A..F]
     07
CD27 D6 XCHB  R64
     40
CD29 AB STA   @>2200(B)     Store in display buffer
     22
     00
CD2C C3 INC   B
CD2D D6 XCHB  R64
     40
CD2F 0A RETS

SBA 26A
This SBA fills the first 20 positions of the PD buffer with blanks

CD30 22 MOV   %>20,A        ASCII code for ' '
     20
CD32 52 MOV   %>14,B        Number of characters to blank out
     14
CD34 AB STA   @>223B(B)     Fill the PD buffer with ' 's
     22
     3B
CD37 CA DJNZ  B,FB          [CD34] Loop until done
     FB
CD39 0A RETS

CD3A 88 MOVD  %>206F,R113
     20
     6F
     71
CD3E 8E CALL  @>F033        SBA 433
     F0                     Pop the FP stack into SR 2012
     33
CD41 8E CALL  @>CB41
     CB
     41
CD44 52 MOV   %>01,B
     01
CD46 B9 POP   A
CD47 0A RETS

SBA 23E

CD48 88 MOVD  %>0060,R87    Destination, SR 2012
     00
     60
     57
CD4C 8E CALL  @>F05D        SBA 45D
     F0                     Convert STD to FP
     5D
CD4F 88 MOVD  %>038A,R1     SBA 38A
     03                     SR 2012:= INT(SR 2012)
     8A
     01
CD53 F8 TRAP7
CD54 D8 PUSH  R96
     60
CD56 E5 JPZ   02            [CD5A]
     02
CD58 D4 INV   R96
     60
CD5A 7D CMP   %>47,R96
     47
     60
CD5D E3 JHS   E5            [CD44]
     E5
CD5F 8E CALL  @>F021        SBA 421
     F0                     Move SR 2012 to SR 2009
     21
CD62 8E CALL  @>CB6C        Move SR 2007 to SR 2012
     CB
     6C
CD65 F5 TRAP10              Push SR 2012 onto the FP stack
CD66 8E CALL  @>C41E        Clear the display
     C4
     1E
CD69 72 MOV   %>11,R56
     11
     38
CD6C 22 MOV   %>02,A
     02
CD6E 8B STA   @>2103
     21
     03
CD71 8E CALL  @>F0B1        SBA 4B1
     F0                     Push SR 2009 onto the FP stack
     B1
CD74 8E CALL  @>CDE4        Put 256 in SR 2012
     CD
     E4
CD77 EE TRAP17              SR 2012:= SR 2009 / SR 2012
CD78 88 MOVD  %>038A,R1     SBA 38A
     03                     SR 2012:= INT(SR 2012)
     8A
     01
CD7C F8 TRAP7
CD7D F5 TRAP10              Push SR 2012 onto the FP stack
CD7E 8E CALL  @>F021        SBA 421
     F0                     Move SR 2012 to SR 2009
     21
CD81 8E CALL  @>CDE4        Put 256 in SR 2012
     CD
     E4
CD84 F1 TRAP14              SR 2012:= SR 2009 * SR 2012
CD85 7A SUB   %>08,R113
     08
     71
CD88 F4 TRAP11              Pop the FP stack into SR 2009
CD89 8E CALL  @>F009        SBA 409
     F0                     SR 2012:= SR 2009 - SR 2012
     09
CD8C B5 CLR   A
CD8D 8B STA   @>21AB
     21
     AB
CD90 8B STA   @>2105
     21
     05
CD93 12 MOV   R97,A
     61
CD95 77 BTJZ  %>01,R96,05   [CD9E]
     01
     60
     05
CD99 8B STA   @>21AB
     21
     AB
CD9C 12 MOV   R98,A
     62
CD9E 8B STA   @>21AC
     21
     AC
CDA1 8E CALL  @>F060        SBA 460
     F0                     Convert a 4 digit BCD number to binary
     60
CDA4 8A LDA   @>2103
     21
     03
CDA7 2D CMP   %>07,A
     07
CDA9 E3 JHS   8F            [CD3A]
     8F
CDAB C0 MOV   A,B
CDAC B3 INC   A
CDAD 8B STA   @>2103
     21
     03
CDB0 12 MOV   R65,A
     41
CDB2 AB STA   @>0038(B)
     00
     38
CDB5 78 ADD   %>10,R113
     10
     71
CDB8 F4 TRAP11              Pop the FP stack into SR 2009
CDB9 7A SUB   %>08,R113
     08
     71
CDBC 12 MOV   R73,A
     49
CDBE E6 JNZ   B1            [CD71]
     B1
CDC0 B9 POP   A
CDC1 E5 JPZ   03            [CDC6]
     03
CDC3 74 OR    %>04,R57
     04
     39
CDC6 8E CALL  @>C2DB
     C2
     DB
CDC9 F4 TRAP11              Pop the FP stack into SR 2009
CDCA 8E CALL  @>CB6C        Move SR 2007 to SR 2012
     CB
     6C
CDCD 8E CALL  @>F01E        SBA 41E
     F0                     Swap SR 2009 and SR 2012
     1E
CDD0 8E CALL  @>CB41
     CB
     41
CDD3 8E CALL  @>F01E        SBA 41E
     F0                     Swap SR 2009 and SR 2012
     1E
CDD6 C5 CLR   B
CDD7 0A RETS

CDD8 76 BTJO  %>04,R45,08   [CDE4] Test if flag 42 is set
     04
     2D
     08
CDDC 8E CALL  @>F018        SBA 418
     F0                     Clear SR 2012
     18
CDDF 88 MOVD  %>4064,R97    FP: 64
     40
     64
     61
CDE3 0A RETS

CDE4 8E CALL  @>F018        SBA 418
     F0                     Clear SR 2012
     18
CDE7 88 MOVD  %>4102,R97     FP: 256
     41                      
     02                      
     61                      
CDEB 72 MOV   %>56,R98       
     56                      
     62                     
CDEE 0A RETS

SBA 266
This SBA performs the 13d function

CDEF 76 BTJO  %>07,R45,24   [CE17] Test if flag 40, 41 or 42 is set
     07
     2D
     24
CDF3 EB TRAP20              Reset flags 35, 37, 38, 56, 61 and 62
CDF4 8E CALL  @>CB6C        Move SR 2007 to SR 2012
     CB
     6C
CDF7 8E CALL  @>CD30        SBA 26A
     CD                     Fill the first 20 positions of the PD buffer
     30                     with blanks
CDFA 22 MOV   %>2B,A        ASCII code for '+'
     2B
CDFC 8B STA   @>224F        First position of PD buffer
     22
     4F
CDFF 72 MOV   %>42,R64
     42
     40
CE02 22 MOV   %>02,A
     02
CE04 8E CALL  @>CB9C
     CB
     9C
CE07 88 MOVD  %>224F,R81    Source: the PD-buffer
     22
     4F
     51
CE0B 88 MOVD  %>219F,R83    Destination: the system alpha register
     21
     9F
     53
CE0F 88 MOVD  %>0010,R85    Number of bytes: 16
     00
     10
     55
CE13 F7 TRAP8               Move block
CE14 74 OR    %>20,R47      Set flag 61
     20
     2F
CE17 0A RETS

SBA 278
This SBA performs the RND function

CE18 76 BTJO  %>78,R43,08   [CE24] Test if flag 27, 28, 29 or 30 is set
     78
     2B
     08
CE1C 74 OR    %>80,R50      Set flag 87
     80
     32
CE1F 88 MOVD  %>011C,R1     SBA 11C
     01
     1C
     01
CE23 F8 TRAP7
CE24 76 BTJO  %>07,R45,EF   [CE17] Test if flag 40, 41 or 42 is set
     07
     2D
     EF
CE28 EB TRAP20              Reset flags 35, 37, 38, 56, 61 and 62
CE29 8E CALL  @>CA04        SBA 22A
     CA
     04
CE2C 88 MOVD  %>22A7,R81
     22
     A7
     51
CE30 8E CALL  @>CB45
     CB
     45
CE33 8C BR    @>C2C6
     C2
     C6

CE36 22 MOV   %>0D,A        Error message: INVALID ENTRY
     0D
CE38 F9 TRAP6

Code for the INV R# function

CE39 8E CALL  @>F03F        SBA 43F
     F0                     Convert STD in SR 2007 to FP in SR 2012
     3F
CE3C 52 MOV   %>07,B
     07
CE3E AA LDA   @>0060(B)
     00
     60
CE41 2D CMP   %>A0,A
     A0
CE43 E3 JHS   F1            [CE36]
     F1
CE45 B7 SWAP  A
CE46 2D CMP   %>A0,A
     A0
CE48 E3 JHS   EC            [CE36]
     EC
CE4A CA DJNZ  B,F2          [CE3E]
     F2
CE4C 76 BTJO  %>FF,R97,08   [CE58]
     FF
     61
     08
CE50 8E CALL  @>F018        SBA 418
     F0                     Clear SR 2012
     18
CE53 8E CALL  @>CF20        Move SR 2012 to SR 2113
     CF
     20
CE56 E0 JMP   1C            [CE74]
     1C

CE58 72 MOV   %>46,R96
     46
     60
CE5B F5 TRAP10              Push SR 2012 onto the FP stack
CE5C 88 MOVD  %>CF5F,R71    Address of data
     CF
     5F
     47
CE60 F6 TRAP9               Move data addressed by R70/71 into SR 2009
CE61 F1 TRAP14              SR 2012:= SR 2009 * SR 2012
CE62 88 MOVD  %>0330,R1     SBA 330
     03                     SR 2012:= Entier(SR 2102)
     30
     01
CE66 F8 TRAP7
CE67 8E CALL  @>CF20
     CF
     20
CE6A 88 MOVD  %>CF57,R71    Address of data
     CF
     57
     47
CE6E F6 TRAP9               Move data addressed by R70/71 into SR 2009
CE6F F1 TRAP14              SR 2012:= SR 2009 * SR 2012
CE70 F4 TRAP11              Pop the FP stack into SR 2009
CE71 8E CALL  @>F009        SBA 409
     F0                     SR 2012:= SR 2009 - SR 2012
     09
CE74 88 MOVD  %>2307,R71    Destination address of data, SR 2112
     23
     07
     47
CE78 8E CALL  @>CF24        Move SR 2012 to SR 2112
     CF
     24
CE7B 8C BR    @>CF1E
     CF
     1E

SBA 270
This SBA is used to generate random numbers

CE7E 76 BTJO  %>78,R43,08   [CE8A] Test if flag 27, 28, 29 or 30 is set
     78
     2B
     08
CE82 74 OR    %>80,R50      Set flag 87
     80
     32
CE85 88 MOVD  %>011C,R1     SBA 11C
     01
     1C
     01
CE89 F8 TRAP7
CE8A 76 BTJO  %>40,R44,AB   [CE39] Test if flag 38 is set
     40
     2C
     AB
CE8E 88 MOVD  %>2307,R71    Destination address of data, SR 2112
     23
     07
     47
CE92 F6 TRAP9               Move data addressed by R70/71 into SR 2009
CE93 8E CALL  @>F01E        SBA 41E
     F0                     Swap SR 2009 and SR 2012
     1E
CE96 F5 TRAP10              Push SR 2012 onto the FP stack
CE97 88 MOVD  %>CF3F,R71    Address of data
     CF
     3F
     47
CE9B F6 TRAP9               Move data addressed by R70/71 into SR 2009
CE9C F1 TRAP14              SR 2012:= SR 2009 * SR 2012
CE9D 88 MOVD  %>CF4F,R71    Address of data
     CF
     4F
     47
CEA1 F6 TRAP9               Move data addressed by R70/71 into SR 2009
CEA2 EF TRAP16              SR 2012:= SR 2009 + SR 2012
CEA3 F5 TRAP10              Push SR 2012 onto the FP stack
CEA4 88 MOVD  %>CF5F,R71    Address of data
     CF
     5F
     47
CEA8 F6 TRAP9               Move data addressed by R70/71 into SR 2009
CEA9 F1 TRAP14              SR 2012:= SR 2009 * SR 2012
CEAA 88 MOVD  %>0330,R1     SBA 330
     03                     SR 2012:= Entier(SR 2102)
     30
     01
CEAE F8 TRAP7
CEAF F5 TRAP10              Push SR 2012 onto the FP stack
CEB0 88 MOVD  %>CF57,R71    Address of data
     CF
     57
     47
CEB4 F6 TRAP9               Move data addressed by R70/71 into SR 2009
CEB5 F1 TRAP14              SR 2012:= SR 2009 * SR 2012
CEB6 7A SUB   %>08,R113
     08
     71
CEB9 F4 TRAP11              Pop the FP stack into SR 2009
CEBA 8E CALL  @>F009        SBA 409
     F0                     SR 2012:= SR 2009 - SR 2012
     09
CEBD 88 MOVD  %>2307,R71    Destination: SR 2112
     23
     07
     47
CEC1 8E CALL  @>CF24
     CF
     24
CEC4 88 MOVD  %>230F,R71    Source: SR 2113
     23
     0F
     47
CEC8 F6 TRAP9               Move data addressed by R70/71 into SR 2009
CEC9 8E CALL  @>F01E        SBA 41E
     F0                     Swap SR 2009 and SR 2012
     1E
CECC 88 MOVD  %>CF3F,R71    Address of data
     CF
     3F
     47
CED0 F6 TRAP9               Move data addressed by R70/71 into SR 2009
CED1 F1 TRAP14              SR 2012:= SR 2009 * SR 2012
CED2 8E CALL  @>F0B4        SBA 4B4
     F0                     Swap SR 2012 and the FP stack
     B4
CED5 88 MOVD  %>CF37,R71    Address of data
     CF
     37
     47
CED9 F6 TRAP9               Move data addressed by R70/71 into SR 2009
CEDA F1 TRAP14              SR 2012:= SR 2009 * SR 2012
CEDB F4 TRAP11              Pop the FP stack into SR 2009
CEDC EF TRAP16              SR 2012:= SR 2009 + SR 2012
CEDD 88 MOVD  %>CF47,R71    Address of data
     CF
     47
     47
CEE1 F6 TRAP9               Move data addressed by R70/71 into SR 2009
CEE2 EF TRAP16              SR 2012:= SR 2009 + SR 2012
CEE3 78 ADD   %>18,R113
     18
     71
CEE6 F4 TRAP11              Pop the FP stack into SR 2009
CEE7 EF TRAP16              SR 2012:= SR 2009 + SR 2012
CEE8 F5 TRAP10              Push SR 2012 onto the FP stack
CEE9 88 MOVD  %>CF5F,R71    Address of data
     CF
     5F
     47
CEED F6 TRAP9               Move data addressed by R70/71 into SR 2009
CEEE F1 TRAP14              SR 2012:= SR 2009 * SR 2012
CEEF 88 MOVD  %>0330,R1     SBA 330
     03                     SR 2012:= Entier(SR 2102)
     30
     01
CEF3 F8 TRAP7
CEF4 88 MOVD  %>CF57,R71    Address of data
     CF
     57
     47
CEF8 F6 TRAP9               Move data addressed by R70/71 into SR 2009
CEF9 F1 TRAP14              SR 2012:= SR 2009 * SR 2012
CEFA F4 TRAP11              Pop the FP stack into SR 2009
CEFB 8E CALL  @>F009        SBA 409
     F0                     SR 2012:= SR 2009 - SR 2012
     09
CEFE 8E CALL  @>CF20
     CF
     20
CF01 88 MOVD  %>CF5F,R71    Address of data
     CF
     5F
     47
CF05 F6 TRAP9               Move data addressed by R70/71 into SR 2009
CF06 F1 TRAP14              SR 2012:= SR 2009 * SR 2012
CF07 F5 TRAP10              Push SR 2012 onto the FP stack
CF08 88 MOVD  %>2307,R71    Source: SR 2112
     23
     07
     47
CF0C F6 TRAP9               Move data addressed by R70/71 into SR 2009
CF0D 8E CALL  @>F018        SBA 418
     F0                     Clear SR 2012
     18
CF10 88 MOVD  %>3901,R97    FP: 1.E-14
     39
     01
     61
CF14 F1 TRAP14              SR 2012:= SR 2009 * SR 2012
CF15 F4 TRAP11              Pop the FP stack into SR 2012
CF16 EF TRAP16              SR 2012:= SR 2009 + SR 2012
CF17 88 MOVD  %>2067,R113
     20
     67
     71
CF1B 8E CALL  @>F042        SBA 442
     F0                     Convert FP in SR 2012 to STD in SR 2007
     42
CF1E EB TRAP20              Reset flags 35, 37, 38, 56, 61 and 62
CF1F 0A RETS

CF20 88 MOVD  %>230F,R71    Destination address of data
     23
     0F
     47
CF24 52 MOV   %>08,B        Number of bytes to move
     08
CF26 AA LDA   @>005F(B)     Source of data, SR 2012
     00
     5F
CF29 9B STA   *R71          Destination
     47
CF2B DB DECD  R71           Decrement address
     47
CF2D CA DJNZ  B,F7          [CF26] Loop until done
     F7
CF2F 0A RETS

Data                        Ŀ
                             Formulas used in R#:                       
CF30 43  1438982                                                     
CF31 01                     Original contents of SR 2112: X            
CF32 43                        "        "     "  SR 2113: Y            
CF33 89                                                                
CF34 82                     Constant 1, 1439882: a                     
CF35 00                        "     2,  420821: b                     
CF36 00                        "     3, 2113248: c                     
CF37 00                       "     4, 6540519: d                     
                                "     5, 1.E+07 : e                     
CF38 42  420821              "     6, 1.E-07 : f                     
CF39 42                        "     7, 1.E-14 : g                     
CF3A 08                                                                
CF3B 21                     SBA 330: Int [= Mathematical integer!]     
CF3C 00                                                                
CF3D 00                     Intermediate result 1, Int(f(bX + d)) : Q  
CF3E 00                          "         "    2, aX + bY + c + Q: R  
CF3F 00                         "         "    3, R - e * Int(fR): S  
                                  "         "    4, bX + d - eQ    : T  
CF40 43  2113248                                                     
CF41 02                     Results:                                   
CF42 11                                                                
CF43 32                     Contents of SR 2112: T                     
CF44 48                        "     "  SR 2113: S                     
CF45 00                                                                
CF46 00                     Next R#            : fS + gT               
CF47 00                   

CF48 43  6540519
CF49 06  
CF4A 54  
CF4B 05  
CF4C 19  
CF4D 00  
CF4E 00  
CF4F 00 


CF50 43  10000000
CF51 10  
CF52 00  
CF53 00  
CF54 00  
CF55 00  
CF56 00  
CF57 00 

CF58 3C  0.0000001
CF59 10  
CF5A 00  
CF5B 00  
CF5C 00  
CF5D 00  
CF5E 00  
CF5F 00 

CF60 75 XOR   %>80,R44      Toggle flag 39
     80
     2C
CF63 8E CALL  @>C83D        SBA 256
     C8                     Update the indicators
     3D

SBA 236

CF66 76 BTJO  %>80,R46,12   [CF7C] Test if flag 55 is set
     80
     2E
     12
CF6A 8E CALL  @>CF8A        SBA 234
     CF                     Wait for key
     8A
CF6D 12 MOV   R37,A
     25
CF6F 2D CMP   %>36,A        Test if key pressed was '2nd'
     36
CF71 E2 JEQ   ED            [CF60]
     ED
CF73 77 BTJZ  %>80,R44,02   [CF79] Test if flag 39 is reset
     80
     2C
     02
CF77 24 OR    %>80,A        Set MSB of key, to bring in range 80-BF
     80
CF79 D0 MOV   A,R37
     25
CF7B 0A RETS

CF7C 73 AND   %>7F,R46      Reset flag 55
     7F
     2E
CF7F 73 AND   %>7F,R44      Reset flag 39
     7F
     2C
CF82 12 MOV   R37,A
     25
CF84 E5 JPZ   03            [CF89]
     03
CF86 74 OR    %>80,R44      Set flag 39
     80
     2C
CF89 0A RETS

SBA 234

CF8A 8E CALL  @>D001        SBA 280
     D0                     Set the address of INT 2 to TRAP 3 [= >FF63]
     01
CF8D 88 MOVD  %>8CA0,R69    Hexadecimal for 36000
     8C
     A0
     45
CF91 72 MOV   %>28,R64
     28
     40
CF94 22 MOV   %>80,A        Timer control : 1 0 0 00000
     80
CF96 52 MOV   %>8C,B        Interrupt mask: 10 00 11 00
     8C
CF98 8E CALL  @>F093        SBA 493
     F0                     Start the timer and wait for an interrupt
     93
CF9B 52 MOV   %>FF,B
     FF
CF9D 8E CALL  @>F084        SBA 484
     F0                     Scan (a) specific column(s) of the keyboard
     84
CFA0 E6 JNZ   20            [CFC2]
     20
CFA2 DA DJNZ  R64,EF        [CF94]
     40
     EF
CFA5 22 MOV   %>FF,A
     FF
CFA7 8B STA   @>205B
     20
     5B
CFAA 8E CALL  @>F0A5        SBA 4A5
     F0
     A5
CFAD 22 MOV   %>9F,A        Timer control : 1 0 0 11111
     9F
CFAF 52 MOV   %>8C,B        Interrupt mask: 10 00 11 00
     8C
CFB1 8E CALL  @>F093        SBA 493
     F0                     Start the timer and wait for an interrupt
     93
CFB4 76 BTJO  %>02,R49,04   [CFBC] Test if flag 73 is set
     02
     31
     04
CFB8 DB DECD  R69           Decrement the auto-off counter
     45
CFBA E7 JNC   3D            [CFF9] Turn the machine off
     3D
CFBC 8E CALL  @>D01A
     D0
     1A
CFBF E3 JC    E9            [CFAA]
     E9
CFC1 0A RETS

CFC2 8E CALL  @>D01A
     D0
     1A
CFC5 E7 JNC   FA            [CFC1]
     FA
CFC7 76 BTJO  %>78,R43,C6   [CF91] Test if flag 27, 28, 29 or 30 is set
     78
     2B
     C6
CFCB 76 BTJO  %>10,R47,C2   [CF91] Test if flag 60 is set
     10
     2F
     C2
CFCF 52 MOV   %>01,B        ?00000001: Col 1
     01
CFD1 8E CALL  @>F084        SBA 484
     F0                     Scan (a) specific column(s) of the keyboard
     84
CFD4 2D CMP   %>10,A        ?00010000: Row 5, HELP
     10
CFD6 E6 JNE   B9            [CF91]
     B9
CFD8 C3 INC   B             ?00000010: Col 2
CFD9 8E CALL  @>F084        SBA 484
     F0                     Scan (a) specific column(s) of the keyboard
     84
CFDC 2D CMP   %>10,A        ?00010000: Row 5, ALPHA
     10
CFDE E6 JNE   B1            [CF91]
     B1
CFE0 52 MOV   %>40,B        ?01000000: Col 7
     40
CFE2 8E CALL  @>F084        SBA 484
     F0                     Scan (a) specific column(s) of the keyboard
     84
CFE5 2D CMP   %>08,A        ?00001000: Row 4, TESTS
     08
CFE7 E6 JNE   A8            [CF91]
     A8
CFE9 52 MOV   %>BC,B        ?10111100: Cols 3, 4, 5, 6 and 8
     BC
CFEB 8E CALL  @>F084        SBA 484
     F0                     Scan (a) specific column(s) of the keyboard
     84
CFEE E6 JNZ   A1            [CF91]
     A1
CFF0 EB TRAP20              Reset flags 35, 37, 38, 56, 61 and 62
CFF1 22 MOV   %>1B,A        Used to enter SELFTESTS: [TEST+HELP+ALPHA]
     1B
CFF3 52 MOV   %>01,B
     01
CFF5 0D LDSP
CFF6 8C BR    @>F087        SBA 487
     F0                     Execute a special function depending on the value
     87                     in A

The following code is responsible for turning off the TI-95 if the user hasn't
pushed any keys for approximately 20 minutes

CFF9 52 MOV   %>01,B
     01
CFFB 0D LDSP                Delete the stack
CFFC 88 MOVD  %>0358,R1     SBA 358
     03                     Turn off the TI-95
     58
     01
D000 F8 TRAP7

SBA 280
This SBA enables INT 2, by pointing the soft INT 2 code to TRAP 3

D001 22 MOV   %>8C,A        Opcode for BR @
     8C
D003 8B STA   @>209B
     20
     9B
D006 88 MOVD  %>FFF8,R69    Address of TRAP 3
     FF
     F8
     45
D00A 9A LDA   *R69          MSB of address loaded is FF
     45
D00C 8B STA   @>209C
     20
     9C
D00F D3 INC   R69
     45
D011 9A LDA   *R69          LSB of address loaded is 63
     45
D013 8B STA   @>209D
     20
     9D
D016 A2 MOVP  %>FF,P2       Timer latch value, 255
     FF
     02
D019 0A RETS

D01A 72 MOV   %>FF,R66
     FF
     42
D01D C5 CLR   B
D01E 07 SETC
D01F CD RRC   B
D020 E2 JZ    37            [D059]
     37
D022 DD RRC   R66
     42
D024 8E CALL  @>F084        SBA 484
     F0                     Scan (a) specific column(s) of the keyboard
     84
D027 E2 JZ    F6            [D01F]
     F6
D029 98 MOVD  R1,R65
     01
     41
D02C 32 MOV   R66,B
     42
D02E E2 JZ    05            [D035]
     05
D030 8E CALL  @>F084        SBA 484
     F0                     Scan (a) specific column(s) of the keyboard
     84
D033 E6 JNZ   24            [D059]
     24
D035 32 MOV   R65,B
     41
D037 8E CALL  @>F084        SBA 484
     F0                     Scan (a) specific column(s) of the keyboard
     84
D03A 1D CMP   R64,A
     40
D03C E6 JNE   DC            [D01A]
     DC
D03E B5 CLR   A
D03F B3 INC   A
D040 CD RRC   B
D041 E7 JNC   FC            [D03F]
     FC
D043 32 MOV   R64,B
     40
D045 28 ADD   %>08,A
     08
D047 CD RRC   B
D048 E7 JNC   FB            [D045]
     FB
D04A E6 JNZ   0D            [D059]
     0D
D04C 2A SUB   %>09,A
     09
D04E 8D CMPA  @>205B
     20
     5B
D051 E2 JEQ   06            [D059]
     06
D053 8B STA   @>205B
     20
     5B
D056 D0 MOV   A,R37
     25
D058 0A RETS

D059 07 SETC
D05A 0A RETS

SBA 25E
This SBA performs the KW function

D05B F3 TRAP12              Reset flags 35, 37, 38 and 59
D05C 76 BTJO  %>80,R46,03   [D063] Test if flag 55 is set
     80
     2E
     03
D060 73 AND   %>7F,R44      Reset flag 39
     7F
     2C
D063 8E CALL  @>C757        SBA 226
     C7                     Pause without delay
     57
D066 8E CALL  @>CF66        SBA 236
     CF                     Wait for key
     66
D069 73 AND   %>7F,R44      Reset flag 39
     7F
     2C
D06C 88 MOVD  %>0025,R65    Address used by SBA 320
     00
     25
     41
D070 88 MOVD  %>0320,R1     SBA 320
     03                     RCB without restrictions
     20
     01
D074 8C BR    @>F08D
     F0
     8D

SBA 262
This SBA scans for BRK or HLT. If neither of them is detected, the instruction
following this SBA is skipped

D077 88 MOVD  %>0201,R1     Values to scan for BRK
     02
     01
     01
D07B 8E CALL  @>F05A        SBA 45A
     F0                     Scan for (a) specific key(s) to be pressed
     5A
D07E E6 JNZ   0B            [D08B]
     0B
D080 88 MOVD  %>0202,R1     Values to scan for HLT
     02
     02
     01
D084 8E CALL  @>F05A        SBA 45A
     F0                     Scan for (a) specific key(s) to be pressed
     5A
D087 E6 JNZ   06            [D08F]
     06
D089 E0 JMP   44            [D0CF]
     44

D08B 22 MOV   %>08,A        Keycode for BRK
     08
D08D E0 JMP   02            [D091]
     02

D08F 22 MOV   %>09,A        Keycode for HLT
     09
D091 8B STA   @>205B
     20
     5B
D094 0A RETS

SBA 27C
This SBA suspends a program until no keys are held down

D095 8E CALL  @>D001        SBA 280
     D0                     Set the address of INT 2 to TRAP 3 [= >FF63]
     01
D098 22 MOV   %>80,A        Timer control : 1 0 0 00000
     80
D09A 52 MOV   %>8C,B        Interrupt mask: 10 00 11 00
     8C
D09C 8E CALL  @>F093        SBA 493
     F0                     Start the timer and wait for an interrupt
     93
D09F 52 MOV   %>FF,B
     FF
D0A1 8E CALL  @>F084        SBA 484
     F0                     Scan (a) specific column(s) of the keyboard
     84
D0A4 E6 JNZ   F2            [D098]
     F2
D0A6 0A RETS

SBA 232
This SBA fills the filenames above F1-F4 upon RUN <MEM> or RUN <NEW>

D0A7 8A LDA   @>2090        0: MEM
     20                     1: NEW
     90
D0AA E2 JZ    45            [D0F1]
     45
D0AC 8A LDA   @>BFFB        Type byte
     BF
     FB
D0AF 26 BTJO  %>20,A,E2     [D094] A ROM has no files
     20
     E2
D0B2 88 MOVD  %>BFED,R69    Address of first char of first filename
     BF
     ED
     45
D0B6 8A LDA   @>BFF7        LSB of the number of files
     BF
     F7
D0B9 C0 MOV   A,B
D0BA 8A LDA   @>BFF6        MSB of the number of files
     BF
     F6
D0BD D5 CLR   R66
     42
D0BF 98 MOVD  R1,R65
     01
     41
D0C2 E6 JNZ   12            [D0D6]
     12
D0C4 C1 TSTB
D0C5 E6 JNZ   0F            [D0D6]
     0F
D0C7 B5 CLR   A
D0C8 8B STA   @>2092
     20
     92
D0CB B5 CLR   A
D0CC 8B STA   @>2091
     20
     91
D0CF 88 MOVD  %>038E,R1     SBA 38E
     03                     Skip the next instruction in the keystroke
     8E                     program
     01
D0D3 8C BR    @>F08D
     F0
     8D

D0D6 88 MOVD  %>0001,R1
     00
     01
     01
D0DA 8D CMPA  @>2091        MSB of filenumber
     20
     91
D0DD E6 JNE   07            [D0E6]
     07
D0DF B6 XCHB  A
D0E0 8D CMPA  @>2092        LSB of filenumber
     20
     92
D0E3 E2 JEQ   3F            [D124]
     3F
D0E5 B6 XCHB  A
D0E6 7A SUB   %>08,R69
     08
     45
D0E9 7B SBB   %>00,R68
     00
     44
D0EC C3 INC   B
D0ED 29 ADC   %>00,A
     00
D0EF E0 JMP   E9            [D0DA]
     E9

Entrypoint for filenames of <MEM>

D0F1 8A LDA   @>20B5        LSB of startaddress of programmemory
     20
     B5
D0F4 D0 MOV   A,R69
     45
D0F6 8A LDA   @>20B4        MSB of startaddress of programmemory
     20
     B4
D0F9 D0 MOV   A,R68
     44
D0FB DB DECD  R69           Decrement to last byte of File Space
     45
D0FD 9A LDA   *R69          Load LSB of number of files
     45
D0FF C0 MOV   A,B
D100 DB DECD  R69
     45
D102 9A LDA   *R69          Load MSB of number of files
     45
D104 7A SUB   %>09,R69
     09
     45
D107 7B SBB   %>00,R68
     00
     44
D10A E0 JMP   B1            [D0BD]
     B1

D10C 32 MOV   R66,B
     42
D10E E2 JZ    B7            [D0C7]
     B7
D110 B5 CLR   A
D111 AB STA   @>20F4(B)      Clear address above Fx, based on value in b
     20                      
     F4                      
D114 AB STA   @>20F5(B)      
     20                      
     F5                      
D117 AB STA   @>20F6(B)      
     20                      
     F6                     
D11A 58 ADD   %>03,B        Add 3 to B
     03
D11C 5D CMP   %>0C,B        Compare with 12
     0C
D11E E7 JL    F0            [D110] B < 12?, clear next Fx
     F0
D120 22 MOV   %>01,A
     01
D122 E0 JMP   A4            [D0C8]
     A4

D124 3D CMP   R64,B
     40
D126 E7 JL    07            [D12F]
     07
D128 E6 JNZ   E2            [D10C]
     E2
D12A 4D CMP   R0,R65
     00
     41
D12D E7 JL    DD            [D10C]
     DD
D12F 9A LDA   *R69
     45
D131 2D CMP   %>2B,A        ASCII code for '+', indicating a datafile
     2B
D133 E2 JEQ   20            [D155]
     20
D135 32 MOV   R66,B
     42
D137 5D CMP   %>0C,B
     0C
D139 E2 JEQ   94            [D0CF]
     94
D13B AB STA   @>20E5(B)
     20
     E5
D13E 78 ADD   %>02,R69
     02
     45
D141 79 ADC   %>00,R68
     00
     44
D144 9A LDA   *R69
     45
D146 AB STA   @>20E7(B)
     20
     E7
D149 DB DECD  R69
     45
D14B 9A LDA   *R69
     45
D14D AB STA   @>20E6(B)
     20
     E6
D150 DB DECD  R69
     45
D152 78 ADD   %>03,R66
     03
     42
D155 8A LDA   @>2092
     20
     92
D158 C0 MOV   A,B
D159 8A LDA   @>2091
     20
     91
D15C C3 INC   B
D15D 29 ADC   %>00,A
     00
D15F 8B STA   @>2091
     20
     91
D162 B6 XCHB  A
D163 8B STA   @>2092
     20
     92
D166 7A SUB   %>08,R69
     08
     45
D169 7B SBB   %>00,R68
     00
     44
D16C E0 JMP   B6            [D124]
     B6

SBA 242

This SBA is used to effectuate the new partitioning

Input:
>2250-2251: New number of registers
>2252-2253: Address of begin of registerarea
>2254-2255: Address of begin of programarea

Output:
New partitioning set

D16E D5 CLR   R69
     45
D170 8A LDA   @>20B4        MSB of beginaddress of programarea
     20
     B4
D173 D0 MOV   A,R80
     50
D175 8A LDA   @>20B5        LSB of beginaddress of programarea
     20
     B5
D178 D0 MOV   A,R81
     51
D17A 8A LDA   @>20B3        LSB of beginaddress of registers
     20
     B3
D17D D0 MOV   A,R85
     55
D17F 8A LDA   @>20B2        MSB of beginaddress of registers
     20
     B2
D182 D0 MOV   A,R84
     54
D184 8A LDA   @>2255
     22
     55
D187 C0 MOV   A,B
D188 8A LDA   @>2254
     22
     54
D18B 98 MOVD  R1,R83
     01
     53
D18E 3A SUB   R81,B
     51
D190 1B SBB   R80,A
     50
D192 E6 JNZ   06            [D19A]
     06
D194 C1 TSTB
D195 E6 JNZ   03            [D19A]
     03
D197 8C BR    @>D24F
     D2
     4F

D19A 98 MOVD  R1,R65
     01
     41
D19D 77 BTJZ  %>20,R43,06   [D1A7] Test if flag 29 is reset
     20
     2B
     06
D1A1 48 ADD   R1,R119
     01
     77
D1A4 49 ADC   R0,R118
     00
     76
D1A7 8A LDA   @>20B7        Load LSB of user PC
     20
     B7
D1AA C0 MOV   A,B
D1AB 8A LDA   @>20B6        Load MSB of user PC
     20
     B6
D1AE 38 ADD   R65,B
     41
D1B0 19 ADC   R64,A
     40
D1B2 8B STA   @>20B6        Store MSB of user PC back
     20
     B6
D1B5 62 MOV   B,A
D1B6 8B STA   @>20B7        Store LSB of user PC back
     20
     B7
D1B9 88 MOVD  %>23E0,R1     Address of begin of user memory
     23
     E0
     01
D1BD 1D CMP   R80,A
     50
D1BF E6 JNE   04            [D1C5]
     04
D1C1 3D CMP   R81,B
     51
D1C3 E2 JEQ   46            [D20B]
     46
D1C5 DB DECD  R81
     51
D1C7 9A LDA   *R81
     51
D1C9 C0 MOV   A,B
D1CA DB DECD  R81
     51
D1CC 9A LDA   *R81
     51
D1CE CF RLC   B
D1CF BF RLC   A
D1D0 CF RLC   B
D1D1 BF RLC   A
D1D2 CF RLC   B
D1D3 BF RLC   A
D1D4 58 ADD   %>08,B
     08
D1D6 29 ADC   %>00,A
     00
D1D8 98 MOVD  R1,R67
     01
     43
D1DB DB DECD  R81
     51
D1DD 9A LDA   *R81
     51
D1DF C0 MOV   A,B
D1E0 DB DECD  R81
     51
D1E2 9A LDA   *R81
     51
D1E4 38 ADD   R65,B
     41
D1E6 19 ADC   R64,A
     40
D1E8 9B STA   *R81
     51
D1EA D3 INC   R81
     51
D1EC 79 ADC   %>00,R80
     00
     50
D1EF 62 MOV   B,A
D1F0 9B STA   *R81
     51
D1F2 4A SUB   R67,R81
     43
     51
D1F5 4B SBB   R66,R80
     42
     50
D1F8 78 ADD   %>03,R81
     03
     51
D1FB 79 ADC   %>00,R80
     00
     50
D1FE 4A SUB   R67,R83
     43
     53
D201 4B SBB   R66,R82
     42
     52
D204 77 BTJZ  %>80,R64,09   [D211]
     80
     40
     09
D208 8C BR    @>D2A9
     D2
     A9

D20B D3 INC   R69
     45
D20D D5 CLR   R66
     42
D20F D5 CLR   R67
     43
D211 8A LDA   @>2253
     22
     53
D214 C0 MOV   A,B
D215 8A LDA   @>2252
     22
     52
D218 1D CMP   R84,A
     54
D21A E7 JL    06            [D222]
     06
D21C E6 JNE   07            [D225]
     07
D21E 3D CMP   R85,B
     55
D220 E3 JHS   03            [D225]
     03
D222 98 MOVD  R85,R1
     55
     01
D225 3A SUB   R83,B
     53
D227 1B SBB   R82,A
     52
D229 4A SUB   R81,R85
     51
     55
D22C 4B SBB   R80,R84
     50
     54
D22F 4D CMP   R0,R84
     00
     54
D232 E7 JL    0A            [D23E]
     0A
D234 E6 JNE   05            [D23B]
     05
D236 4D CMP   R1,R85
     01
     55
D239 E7 JL    03            [D23E]
     03
D23B 98 MOVD  R1,R85
     01
     55
D23E 48 ADD   R85,R81
     55
     51
D241 49 ADC   R84,R80
     54
     50
D244 DB DECD  R81
     51
D246 48 ADD   R85,R83
     55
     53
D249 49 ADC   R84,R82
     54
     52
D24C DB DECD  R83
     53
D24E F7 TRAP8               Move block
D24F 88 MOVD  %>20B5,R83    Destination address
     20
     B5
     53
D253 88 MOVD  %>2255,R81    Source of data
     22
     55
     51
D257 88 MOVD  %>0006,R85    Number of bytes to move, 6
     00
     06
     55
D25B F7 TRAP8               Move block
D25C 77 BTJZ  %>20,R43,14   [D274] Test if flag 29 is reset
     20
     2B
     14
D260 8A LDA   @>2252
     22
     52
D263 D0 MOV   A,R116
     74
D265 8A LDA   @>2253
     22
     53
D268 D0 MOV   A,R117
     75
D26A 8A LDA   @>2255
     22
     55
D26D D0 MOV   A,R115
     73
D26F 8A LDA   @>2254
     22
     54
D272 D0 MOV   A,R114
     72
D274 77 BTJZ  %>01,R69,30   [D2A8]
     01
     45
     30

SBA 26E
This SBA is used to clear the internal File Space, by

 - setting the number of files to 0
 - setting the amount of free space to the size - 8 bytes
 - setting the amount of used space to 0

Note that this SBA doen't actually clear the files

D278 8A LDA   @>20B5        MSB of the beginaddress of programmemory
     20
     B5
D27B D0 MOV   A,R65
     41
D27D 8A LDA   @>20B4        LSB of the beginaddress of programmemory
     20
     B4
D280 D0 MOV   A,R64
     40
D282 98 MOVD  R65,R67
     41
     43
D285 B5 CLR   A              Clear the directory
D286 52 MOV   %>08,B         
     08                      
D288 DB DECD  R65            
     41                      
D28A 9B STA   *R65           
     41                      
D28C CA DJNZ  B,FA           [D288]
     FA
D28E 88 MOVD  %>23E0,R1     Begin address of user memory
     23
     E0
     01
D292 4A SUB   R1,R65         Calculate the amount of free space and store
     01                        it at the appropriate location
     41                      
D295 4B SBB   R0,R64         
     00                      
     40                      
D298 12 MOV   R65,A          
     41                      
D29A DB DECD  R67            
     43                      
D29C DB DECD  R67            
     43                      
D29E DB DECD  R67            
     43                      
D2A0 9B STA   *R67           
     43                      
D2A2 12 MOV   R64,A          
     40                      
D2A4 DB DECD  R67            
     43                      
D2A6 9B STA   *R67           
     43                     
D2A8 0A RETS

D2A9 4A SUB   R81,R85
     51
     55
D2AC 4B SBB   R80,R84
     50
     54
D2AF 88 MOVD  %>23E0,R1     Begin address of user memory
     23
     E0
     01
D2B3 4D CMP   R0,R82
     00
     52
D2B6 E7 JL    07            [D2BF]
     07
D2B8 E6 JNE   14            [D2CE]
     14
D2BA 4D CMP   R1,R83
     01
     53
D2BD E3 JHS   0F            [D2CE]
     0F
D2BF 98 MOVD  R1,R83
     01
     53
D2C2 48 ADD   R67,R81
     43
     51
D2C5 49 ADC   R66,R80
     42
     50
D2C8 4A SUB   R67,R85
     43
     55
D2CB 4B SBB   R66,R84
     42
     54
D2CE 8E CALL  @>F096        SBA 496
     F0                     Move block
     96
D2D1 DB DECD  R65
     41
D2D3 D4 INV   R65
     41
D2D5 D4 INV   R64
     40
D2D7 98 MOVD  R65,R85
     41
     55
D2DA 8A LDA   @>20B3
     20
     B3
D2DD D0 MOV   A,R83
     53
D2DF 8A LDA   @>20B2
     20
     B2
D2E2 D0 MOV   A,R82
     52
D2E4 DB DECD  R83
     53
D2E6 8E CALL  @>F099        SBA 499
     F0                     Clear block
     99
D2E9 8C BR    @>D24F
     D2
     4F

D2EC 98 MOVD  R115,R97       Save the LOW, HIGH and RUN PC
     73                      
     61                      
D2EF 98 MOVD  R117,R99       
     75                      
     63                      
D2F2 98 MOVD  R119,R101      
     77                      
     65                     
D2F5 8A LDA   @>20B2         Replace them with the values from SR 2038
     20                      
     B2                      
D2F8 D0 MOV   A,R116         
     74                      
D2FA 8A LDA   @>20B3         
     20                      
     B3                      
D2FD D0 MOV   A,R117         
     75                      
D2FF 8A LDA   @>20B4         
     20                      
     B4                      
D302 D0 MOV   A,R114         
     72                      
D304 D0 MOV   A,R118         
     76                      
D306 8A LDA   @>20B5         
     20                      
     B5                      
D309 D0 MOV   A,R115         
     73                      
D30B D0 MOV   A,R119         
     77                     
D30D 0A RETS

SBA 244
This SBA is used to find the end of the program currently in PGM. It also
gives the length of the last instruction. If there is no program, this length
is zero.

Input: -

Output:
Address of last instruction: >22BB-22BC
Length  of last instruction: >22BD        [Zero for empty program]

D30E 8E CALL  @>D2EC        Replace LOW, HIGH and RUN PC with values from
     D2                     SR 2038
     EC
D311 D5 CLR   R78
     4E
D313 8E CALL  @>DF16        Calculate length of next instruction and store
     DF                     it in R79
     16
D316 7D CMP   %>01,R79
     01
     4F
D319 E2 JEQ   21            [D33C] Check for NOP
     21
D31B E3 JHS   45            [D362] Next
     45
D31D 4A SUB   R78,R119       Calculate address of last instruction
     4E                      
     77                      
D320 7B SBB   %>00,R118      
     00                      
     76                     
D323 12 MOV   R78,A          Store length of last instruction
     4E                      
D325 8B STA   @>22BD         
     22                      
     BD                     
D328 98 MOVD  R119,R1        Store address of last instruction
     77                      
     01                      
D32B 8B STA   @>22BB         
     22                      
     BB                      
D32E 62 MOV   B,A            
D32F 8B STA   @>22BC         
     22                      
     BC                     
D332 98 MOVD  R97,R115       Restore original contents of SR 2014
     61                      
     73                      
D335 98 MOVD  R99,R117       
     63                      
     75                      
D338 98 MOVD  R101,R119      
     65                      
     77                     
D33B 0A RETS

D33C 76 BTJO  %>FF,R64,22   [D362] Not NOP?, next
     FF
     40
     22
D340 98 MOVD  R119,R81      Save current PC
     77
     51
D343 98 MOVD  R117,R69      Address of first byte after programarea
     75
     45
D346 4A SUB   R119,R69       Number of bytes in programarea after current
     77                        instruction
     45                      
D349 4B SBB   R118,R68       
     76                      
     44                     
D34C DB DECD  R69           See >D343
     45
D34E DB DECD  R69
     45
D350 E7 JNC   0B            [D35D]
     0B
D352 D3 INC   R119
     77
D354 79 ADC   %>00,R118
     00
     76
D357 9A LDA   *R119         Next instruction
     77
D359 E2 JZ    F3            [D34E] NOP?
     F3
D35B E0 JMP   B6            [D313] Next instruction
     B6

D35D 98 MOVD  R81,R119      Restore saved PC
     51
     77
D360 E0 JMP   BB            [D31D]
     BB

D362 42 MOV   R79,R78       Save instruction length
     4F
     4E
D365 48 ADD   R79,R119       Add to PC
     4F                      
     77                      
D368 79 ADC   %>00,R118      
     00                      
     76                     
D36B E0 JMP   A6            [D313] Next instruction
     A6

SBA 246

D36D 88 MOVD  %>22CF,R83    LEARN display instruction block counter, SR 2104
     22                     and 2105
     CF
     53
D371 88 MOVD  %>0010,R85
     00
     10
     55
D375 8E CALL  @>F099        SBA 499
     F0                     Clear block
     99
D378 98 MOVD  R119,R77      RUN PC
     77
     4D
D37B 98 MOVD  R119,R83
     77
     53
D37E 7A SUB   %>19,R83      Go 25 bytes back
     19
     53
D381 7B SBB   %>00,R82
     00
     52
D384 98 MOVD  R115,R119     Begin address of RUN area
     73
     77
D387 98 MOVD  R83,R1
     53
     01
D38A 3A SUB   R119,B
     77
D38C 1B SBB   R118,A
     76
D38E E7 JNC   1C            [D3AC]
     1C
D390 9A LDA   *R119
     77
D392 D3 INC   R119
     77
D394 79 ADC   %>00,R118
     00
     76
D397 2D CMP   %>FC,A        Exclude: SBA, STB, RCB and LBL
     FC
D399 E7 JL    EC            [D387]
     EC
D39B 2D CMP   %>FF,A        LBL?
     FF
D39D E2 JEQ   E8            [D387]
     E8
D39F DB DECD  R119
     77
D3A1 8E CALL  @>DF16        Calculate length of next instruction
     DF
     16
D3A4 48 ADD   R79,R119
     4F
     77
D3A7 79 ADC   %>00,R118
     00
     76
D3AA E0 JMP   DB            [D387]
     DB

D3AC 8E CALL  @>DF16        Calculate length of next instruction
     DF
     16
D3AF 8E CALL  @>D713        Shift previous instructionlengths backwards
     D7
     13
D3B2 12 MOV   R79,A
     4F
D3B4 8B STA   @>22CF
     22
     CF
D3B7 E2 JZ    16            [D3CF] Instruction length is 0 when the end of
     16                            programmemory is reached
D3B9 48 ADD   R0,R119
     00
     77
D3BC 79 ADC   %>00,R118
     00
     76
D3BF 98 MOVD  R77,R1
     4D
     01
D3C2 3A SUB   R119,B
     77
D3C4 1B SBB   R118,A
     76
D3C6 E3 JC    E4            [D3AC]
     E4
D3C8 4A SUB   R79,R119
     4F
     77
D3CB 7B SBB   %>00,R118
     00
     76
D3CE 0A RETS

D3CF 98 MOVD  R77,R119      Restore the RUN PC
     4D
     77
D3D2 0A RETS

TRAP 19

D3D3 88 MOVD  %>F09C,R71    SBA 49C
     F0                     Load the mnemonic of the instructioncode in R69
     9C                     into SR 2012
     47
D3D7 F0 TRAP15
D3D8 52 MOV   %>FD,B
     FD
D3DA E0 JMP   06            [D3E2]
     06

D3DC 2D CMP   %>20,A        ASCII code for ' '
     20
D3DE E6 JNE   02            [D3E2]
     02
D3E0 D3 INC   R83
     53
D3E2 AA LDA   @>FF63(B)
     FF
     63
D3E5 9B STA   *R83
     53
D3E7 D2 DEC   R83
     53
D3E9 C3 INC   B
D3EA E7 JNC   F0            [D3DC]
     F0
D3EC 0A RETS

The following routine is executed after the user has entered an instruction
at the last step of programmemory

D3ED 74 OR    %>80,R46      Set flag 55
     80
     2E
D3F0 72 MOV   %>22,R37      Make LEARN last key pressed
     22
     25
D3F3 0A RETS

D3F4 12 MOV   R66,A
     42
D3F6 E2 JZ    50            [D448]
     50
D3F8 22 MOV   %>60,A
     60
D3FA 32 MOV   R65,B
     41
D3FC AB STA   @>2200(B)
     22
     00
D3FF E0 JMP   47            [D448]
     47

D401 8A LDA   @>22CF
     22
     CF
D404 E2 JZ    E7            [D3ED] Exit LEARN mode
     E7
D406 8E CALL  @>CD30        SBA 26A
     CD                     Fill the first 20 positions of the PD buffer
     30                     with blanks
D409 D5 CLR   R64
     40
D40B D5 CLR   R66
     42
D40D 72 MOV   %>40,R65
     40
     41
D410 72 MOV   %>10,R67
     10
     43
D413 98 MOVD  R119,R77
     77
     4D
D416 E0 JMP   12            [D42A]
     12

D418 32 MOV   R67,B
     43
D41A AA LDA   @>22BF(B)
     22
     BF
D41D E2 JZ    D5            [D3F4]
     D5
D41F 23 AND   %>7F,A
     7F
D421 AB STA   @>22BF(B)
     22
     BF
D424 4A SUB   R0,R119
     00
     77
D427 7B SBB   %>00,R118
     00
     76
D42A 88 MOVD  %>219F,R83
     21
     9F
     53
D42E 98 MOVD  R119,R81
     77
     51
D431 9A LDA   *R119
     77
D433 D0 MOV   A,R69
     45
D435 E6 JNZ   14            [D44B]
     14
D437 8A LDA   @>2104
     21
     04
D43A E6 JNZ   0F            [D44B]
     0F
D43C 22 MOV   %>8F,A
     8F
D43E 8B STA   @>2104
     21
     04
D441 D3 INC   R64
     40
D443 D3 INC   R65
     41
D445 DA DJNZ  R67,D0        [D418]
     43
     D0
D448 8C BR    @>D4E0
     D4
     E0

D44B 7D CMP   %>20,R69      ASCII code for ' '
     20
     45
D44E E7 JL    1A            [D46A]
     1A
D450 7D CMP   %>80,R69
     80
     45
D453 E3 JHS   15            [D46A]
     15
D455 8A LDA   @>2104
     21
     04
D458 E6 JNZ   02            [D45C]
     02
D45A D3 INC   R66
     42
D45C 12 MOV   R69,A
     45
D45E ED TRAP18              Store in the PD buffer
D45F 76 BTJO  %>FF,R66,26   [D489]
     FF
     42
     26
D463 D3 INC   R66
     42
D465 22 MOV   %>60,A        ASCII code for '`'
     60
D467 ED TRAP18              Store in the PD buffer
D468 E0 JMP   1F            [D489]
     1F

D46A EC TRAP19
D46B 32 MOV   R67,B
     43
D46D AA LDA   @>22BF(B)
     22
     BF
D470 BA DJNZ  A,2A          [D49C]
     2A
D472 12 MOV   R66,A
     42
D474 E2 JZ    13            [D489]
     13
D476 D5 CLR   R66
     42
D478 D5 CLR   R64
     40
D47A 22 MOV   %>60,A
     60
D47C 32 MOV   R65,B
     41
D47E AB STA   @>2200(B)
     22
     00
D481 C3 INC   B
D482 C3 INC   B
D483 D1 MOV   B,R65
     41
D485 5D CMP   %>50,B
     50
D487 E3 JHS   57            [D4E0]
     57
D489 88 MOVD  %>219F,R1
     21
     9F
     01
D48D 3A SUB   R83,B
     53
D48F 56 BTJO  %>FE,B,0D     [D49F]
     FE
     0D
D492 7D CMP   %>90,R69
     90
     45
D495 E3 JHS   08            [D49F]
     08
D497 72 MOV   %>01,R64
     01
     40
D49A E0 JMP   14            [D4B0]
     14

D49C 8C BR    @>D588
     D5
     88

D49F 12 MOV   R64,A
     40
D4A1 E2 JZ    04            [D4A7]
     04
D4A3 22 MOV   %>20,A        ASCII code for ' '
     20
D4A5 ED TRAP18              Store in the PD buffer
D4A6 C3 INC   B
D4A7 72 MOV   %>01,R64
     01
     40
D4AA 76 BTJO  %>FF,R66,02   [D4B0]
     FF
     42
     02
D4AE D5 CLR   R64
     40
D4B0 D3 INC   R83
     53
D4B2 9A LDA   *R83
     53
D4B4 D6 XCHB  R65
     41
D4B6 AB STA   @>2200(B)
     22
     00
D4B9 C3 INC   B
D4BA 5D CMP   %>50,B
     50
D4BC E3 JHS   22            [D4E0]
     22
D4BE D6 XCHB  R65
     41
D4C0 CA DJNZ  B,EE          [D4B0]
     EE
D4C2 8A LDA   @>2104
     21
     04
D4C5 E6 JNZ   08            [D4CF]
     08
D4C7 12 MOV   R65,A
     41
D4C9 B4 INV   A
D4CA 2A SUB   %>2F,A
     2F
D4CC 8B STA   @>2104
     21
     04
D4CF 76 BTJO  %>FF,R64,07   [D4DA]
     FF
     40
     07
D4D3 D3 INC   R65
     41
D4D5 7D CMP   %>50,R65
     50
     41
D4D8 E3 JHS   06            [D4E0]
     06
D4DA 98 MOVD  R81,R119
     51
     77
D4DD DA DJNZ  R67,66        [D546]
     43
     66
D4E0 98 MOVD  R77,R119
     4D
     77
D4E3 77 BTJZ  %>40,R48,3D   [D524] Test if flag 70 is reset
     40
     30
     3D
D4E7 8A LDA   @>22CF
     22
     CF
D4EA E5 JPZ   03            [D4EF]
     03
D4EC 98 MOVD  R92,R119
     5C
     77
D4EF 88 MOVD  %>0398,R1     SBA 398
     03                     Convert the binary PC to decimal
     98
     01
D4F3 F8 TRAP7
D4F4 98 MOVD  R77,R119
     4D
     77
D4F7 52 MOV   %>0F,B
     0F
D4F9 8E CALL  @>DE56
     DE
     56
D4FC 88 MOVD  %>2205,R83    Base address for use in TRAP 18
     22
     05
     53
D500 22 MOV   %>3D,A        ASCII code for '='
     3D
D502 ED TRAP18              Store in the PD buffer
D503 22 MOV   %>43,A        ASCII code for 'C'
     43
D505 ED TRAP18              Store in the PD buffer
D506 22 MOV   %>50,A        ASCII code for 'P'
     50
D508 ED TRAP18              Store in the PD buffer
D509 88 MOVD  %>220B,R83    Next base address
     22
     0B
     53
D50D 52 MOV   %>02,B        Load loopcounter
     02
D50F 12 MOV   R65,A         Load LSB of LEARN PC
     41
D511 B8 PUSH  A             Save
D512 8E CALL  @>D6D8        Convert least significant nibble to ASCII
     D6
     D8
D515 B9 POP   A
D516 8E CALL  @>D6D7        Convert most significant nibble to ASCII
     D6
     D7
D519 12 MOV   R64,A         Get MSB of LEARN PC
     40
D51B CA DJNZ  B,F4          [D511] Repeat conversion
     F4
D51D 88 MOVD  %>2200,R92
     22
     00
     5C
D521 8E CALL  @>C813        SBA 222
     C8                     Put 15 characters in the LCD RAM of the Fx keys
     13
D524 8E CALL  @>C7A3
     C7
     A3
D527 76 BTJO  %>80,R46,1A   [D545] Test if flag 55 is set
     80
     2E
     1A
D52B 8E CALL  @>D001        SBA 280
     D0                     Set the address of INT 2 to TRAP 3 [= >FF63]
     01
D52E 8A LDA   @>20AA
     20
     AA
D531 D0 MOV   A,R69
     45
D533 88 MOVD  %>1020,R65
     10
     20
     41
D537 7D CMP   %>25,R37      Keycode for <-
     25
     25
D53A E2 JEQ   17            [D553]
     17
D53C 88 MOVD  %>1040,R65
     10
     40
     41
D540 7D CMP   %>26,R37      Keycode for ->
     26
     25
D543 E2 JEQ   0E            [D553]
     0E
D545 0A RETS

D546 8C BR    @>D418
     D4
     18

D549 8C BR    @>D63F
     D6
     3F

D54C 22 MOV   %>9F,A        Timer control : 1 0 0 11111
     9F
D54E 52 MOV   %>8C,B        Interrupt mask: 10 00 11 00
     8C
D550 8E CALL  @>F093        SBA 493
     F0                     Start the timer and wait for an interrupt
     93
D553 98 MOVD  R65,R1
     41
     01
D556 8E CALL  @>F05A        SBA 45A
     F0                     Scan for (a) specific key(s) to be pressed
     5A
D559 E2 JZ    18            [D573]
     18
D55B DA DJNZ  R69,EE        [D54C]
     45
     EE
D55E 8E CALL  @>F0A5        SBA 45A
     F0                     Scan for (a) specific key(s) to be pressed
     A5
D561 22 MOV   %>04,A
     04
D563 7D CMP   %>25,R37      Keycode for <-
     25
     25
D566 E2 JEQ   05            [D56D]
     05
D568 8E CALL  @>C592
     C5
     92
D56B E0 JMP   03            [D570]
     03

D56D 8E CALL  @>C22E
     C2
     2E
D570 8C BR    @>C757        SBA 226
     C7                     Pause without delay
     57

D573 22 MOV   %>FF,A
     FF
D575 8B STA   @>205B        SAVKEY
     20
     5B
D578 0A RETS

D579 73 AND   %>7F,R78
     7F
     4E
D57C E2 JZ    CB            [D549]
     CB
D57E 7D CMP   %>10,R69      Instruction code for = [MRG/RCA =]
     10
     45
D581 E6 JNE   31            [D5B4]
     31
D583 22 MOV   %>3D,A        ASCII code for '='
     3D
D585 ED TRAP18              Store in the PD buffer
D586 E0 JMP   3E            [D5C6]
     3E

D588 D0 MOV   A,R79
     4F
D58A 32 MOV   R69,B
     45
D58C AA LDA   @>D613(B)     Read info byte for field instructions
     D6
     13
D58F D0 MOV   A,R78
     4E
D591 8E CALL  @>D6AB        Increment PC and fetch next byte
     D6
     AB
D594 77 BTJZ  %>40,R78,11   [D5A9] Exclude DFN, IND, DFA and LBL
     40
     4E
     11
D598 2D CMP   %>F8,A        Instructioncode for IND
     F8
D59A E6 JNE   0D            [D5A9]
     0D
D59C 52 MOV   %>04,B
     04
D59E AA LDA   @>D6E3(B)     Text: 'IND '
     D6
     E3
D5A1 ED TRAP18              Store in the PD buffer
D5A2 CA DJNZ  B,FA          [D59E]
     FA
D5A4 DA DJNZ  R79,E3        [D58A]
     4F
     E3
D5A7 E0 JMP   1D            [D5C6]
     1D

D5A9 22 MOV   %>20,A        ASCII code for ' '
     20
D5AB ED TRAP18              Store in the PD buffer
D5AC 76 BTJO  %>80,R79,19   [D5C9]
     80
     4F
     19
D5B0 76 BTJO  %>80,R78,C5   [D579]
     80
     4E
     C5
D5B4 8E CALL  @>D6B5
     D6
     B5
D5B7 76 BTJO  %>10,R78,43   [D5FE]
     10
     4E
     43
D5BB 73 AND   %>07,R78
     07
     4E
D5BE E2 JZ    06            [D5C6]
     06
D5C0 8E CALL  @>D6D1
     D6
     D1
D5C3 DA DJNZ  R78,2D        [D5F3]
     4E
     2D
D5C6 8C BR    @>D472
     D4
     72

D5C9 73 AND   %>7F,R79
     7F
     4F
D5CC 22 MOV   %>8F,A
     8F
D5CE 8B STA   @>2104
     21
     04
D5D1 D3 INC   R65
     41
D5D3 76 BTJO  %>80,R78,2F   [D606]
     80
     4E
     2F
D5D7 8A LDA   @>21AF
     21
     AF
D5DA 76 BTJO  %>10,R78,1E   [D5FC]
     10
     4E
     1E
D5DE 2D CMP   %>03,A
     03
D5E0 E3 JHS   0D            [D5EF]
     0D
D5E2 D3 INC   R78
     4E
D5E4 77 BTJZ  %>04,R78,07   [D5EF]
     04
     4E
     07
D5E8 D0 MOV   A,R78
     4E
D5EA 8E CALL  @>D6AB
     D6
     AB
D5ED E0 JMP   D1            [D5C0]
     D1

D5EF D0 MOV   A,R78
     4E
D5F1 E0 JMP   CD            [D5C0]
     CD

D5F3 76 BTJO  %>01,R78,C9   [D5C0]
     01
     4E
     C9
D5F7 DA DJNZ  R79,F0        [D5EA]
     4F
     F0
D5FA E0 JMP   CA            [D5C6]
     CA

D5FC D0 MOV   A,R78
     4E
D5FE 73 AND   %>07,R78
     07
     4E
D601 8E CALL  @>D690
     D6
     90
D604 E0 JMP   C0            [D5C6]
     C0

D606 73 AND   %>7F,R78
     7F
     4E
D609 E6 JNZ   CC            [D5D7]
     CC
D60B EC TRAP19
D60C 22 MOV   %>3A,A        ASCII code for ':'
     3A
D60E ED TRAP18              Store in the PD buffer
D60F 8A LDA   @>21AF
     21
     AF
D612 2D CMP   %>03,A
     03
D614 E7 JL    10            [D626]
     10
D616 72 MOV   %>03,R78
     03
     4E
D619 8E CALL  @>D688
     D6
     88
D61C 22 MOV   %>40,A        ASCII code for '@'
     40
D61E ED TRAP18              Store in the PD buffer
D61F 8A LDA   @>21AF
     21
     AF
D622 2A SUB   %>03,A
     03
D624 E2 JZ    A0            [D5C6]
     A0
D626 D0 MOV   A,R78
     4E
D628 8E CALL  @>D688
     D6
     88
D62B E0 JMP   99            [D5C6]
     99

D62D 8E CALL  @>D672
     D6
     72
D630 7A SUB   %>03,R79
     03
     4F
D633 E4 JP    02            [D637]
     02
D635 E0 JMP   13            [D64A]
     13

D637 22 MOV   %>40,A        ASCII code for '@'
     40
D639 ED TRAP18              Store in the PD buffer
D63A 72 MOV   %>04,R78
     04
     4E
D63D E0 JMP   AB            [D5EA]
     AB

D63F 8A LDA   @>219D
     21
     9D
D642 2D CMP   %>41,A
     41
D644 E2 JEQ   E7            [D62D]
     E7
D646 EC TRAP19
D647 DA DJNZ  R79,03        [D64D]
     4F
     03
D64A 8C BR    @>D472
     D4
     72

D64D 8E CALL  @>D6AB
     D6
     AB
D650 2D CMP   %>02,A
     02
D652 E6 JNE   06            [D65A]
     06
D654 22 MOV   %>20,A        ASCII code for ' '
     20
D656 ED TRAP18              Store in the PD buffer
D657 EC TRAP19
D658 E0 JMP   F0            [D64A]
     F0

D65A 22 MOV   %>3A,A        ASCII code for ':'
     3A
D65C ED TRAP18              Store in the PD buffer
D65D 72 MOV   %>03,R78
     03
     4E
D660 8E CALL  @>D690
     D6
     90
D663 12 MOV   R78,A
     4E
D665 E6 JNZ   E3            [D64A]
     E3
D667 22 MOV   %>40,A        ASCII code for '@'
     40
D669 ED TRAP18              Store in the PD buffer
D66A 72 MOV   %>02,R78
     02
     4E
D66D 8E CALL  @>D688
     D6
     88
D670 E0 JMP   D8            [D64A]
     D8

D672 7D CMP   %>90,R69      Compare with F1
     90
     45
D675 E7 JL    08            [D67F]
     08
D677 7D CMP   %>95,R69      Compare with LR (First function after F5)
     95
     45
D67A E3 JHS   03            [D67F]
     03
D67C EC TRAP19
D67D E0 JMP   03            [D682]
     03

D67F 8E CALL  @>D6A4
     D6
     A4
D682 22 MOV   %>3A,A        ASCII code for ':'
     3A
D684 ED TRAP18              Store in the PD buffer
D685 72 MOV   %>03,R78
     03
     4E
D688 8E CALL  @>D6AB
     D6
     AB
D68B 8E CALL  @>DE44
     DE
     44
D68E E7 JNC   0E            [D69E]
     0E
D690 12 MOV   R69,A
     45
D692 2D CMP   %>20,A        Compare with ' '
     20
D694 E7 JL    09            [D69F] Replace non-ASCII with '?'
     09
D696 2D CMP   %>80,A        Compare with first character after 7F
     80
D698 E3 JHS   05            [D69F] Replace non-ASCII with '?'
     05
D69A ED TRAP18              Store in the PD buffer
D69B DA DJNZ  R78,EA        [D688]
     4E
     EA
D69E 0A RETS

D69F 8E CALL  @>D6A4
     D6
     A4
D6A2 E0 JMP   F7            [D69B]
     F7

D6A4 22 MOV   %>3F,A        ASCII code for '?'
     3F

TRAP 18
This TRAP stores a character in the PD buffer and moves the PD cursor to the
next location

D6A6 9B STA   *R83          Store character
     53
D6A8 DB DECD  R83           Decrement pointer
     53
D6AA 0A RETS

The following routine increments the PC and stores the instructioncode at the
new PC into R69.

D6AB D3 INC   R119
     77
D6AD 79 ADC   %>00,R118
     00
     76
D6B0 9A LDA   *R119
     77
D6B2 D0 MOV   A,R69
     45
D6B4 0A RETS

D6B5 77 BTJZ  %>08,R78,0D   [D6C6]
     08
     4E
     0D
D6B9 12 MOV   R69,A
     45
D6BB 2D CMP   %>41,A        Compare with 'A'
     41
D6BD E7 JL    08            [D6C7]
     08
D6BF 2D CMP   %>5B,A        Compare with '[' (First character after 'Z')
     5B
D6C1 E3 JHS   04            [D6C7]
     04
D6C3 ED TRAP18              Store in the PD buffer
D6C4 D5 CLR   R78
     4E
D6C6 0A RETS

D6C7 26 BTJO  %>F0,A,04     [D6CE]
     F0
     04
D6CA 77 BTJZ  %>02,R46,F8   [D6C6] Test if flag 49 is reset
     02
     2E
     F8
D6CE D3 INC   R78
     4E
D6D0 0A RETS

D6D1 12 MOV   R69,A
     45
D6D3 76 BTJO  %>01,R78,01   [D6D8]
     01
     4E
     01
D6D7 B7 SWAP  A

The following instructions convert the digits 0-F into their corresponding
ASCII codes. These codes are subsequently stored in the PD buffer.

D6D8 23 AND   %>0F,A        Clear first 4 bits
     0F
D6DA 28 ADD   %>30,A        Add 30
     30
D6DC 2D CMP   %>3A,A        Compare with >3A
     3A
D6DE E7 JL    02            [D6E2] Less?, then it was a decimal digit
     02
D6E0 28 ADD   %>07,A        Add 7 for hexadecimal digits
     07
D6E2 ED TRAP18              Store in the PD buffer
D6E3 0A RETS

Data

D6E4 44  'D'
D6E5 4E  'N'
D6E6 49  'I'
D6E7 20  ' '

Table with field- and length infobytes for all keycodes between >D5 and >FF

D6E8 42 SF       First nibble indicates the type of field:
D6E9 42 RF
D6EA 42 TF       0: A stand alone IND has no fields
D6EB 43 DEV      1: Indicates LBL
D6EC 41 SHW      4: Alpha, decimal numeric and IND
D6ED 43 CHR         Alpha is only allowed if second nibble is B
D6EE 41 FIX      5: Alpha and IND
D6EF 53 DF       6: Hexadecimal numeric and IND
D6F0 53 NAM      8: DFN and DFA
D6F1 53 PUT      C: Alpha, decimal numeric, = and IND
D6F2 53 GET
D6F3 4B RCL      Second nibble indicates length of field in non-SYS mode
D6F4 4B EXC
D6F5 4B STO      0: DFN and DFA
D6F6 4B ST+      1: 1 position
D6F7 4B ST-      2: 2 positions
D6F8 4B ST*      3: 3 positions
D6F9 4B ST/      4: 4 positions
D6FA 4B DSZ      B: 3 positions and alpha
D6FB 4B INC
D6FC 4B IF<
D6FD 4B IF=
D6FE 4B IF>
D6FF CB MRG
D700 CB RCA
D701 4B STA
D702 53 RD
D703 53 WRT
D704 53 VFY
D705 4B CIO
D706 42 WID
D707 42 COL
D708 52 GTL
D709 52 SBL
D70A 80 DFN
D70B 0B IND
D70C 64 GTO
D70D 64 SBR
D70E 80 DFA
D70F 63 SBA
D710 64 STB
D711 64 RCB
D712 12 LBL

The following routine moves the LEARN display instruction lengths one position
back, to make room for the length of the next instruction.

D713 88 MOVD  %>22C1,R81    Source of data
     22
     C1
     51
D717 88 MOVD  %>22C0,R83    Destination address
     22
     C0
     53
D71B 88 MOVD  %>000F,R85    Number of bytes to move
     00
     0F
     55
D71F 8C BR    @>F096        SBA 496
     F0                     Move block
     96

D722 C0 MOV   A,B
D723 77 BTJZ  %>04,R47,05   [D72C] Test if flag 58 is reset
     04
     2F
     05
D727 8E CALL  @>F06C        SBA 46C
     F0                     Insert a NOP at the current PC
     6C
D72A 52 MOV   %>01,B
     01
D72C 98 MOVD  R119,R81
     77
     51
D72F 12 MOV   R36,A
     24
D731 9B STA   *R81
     51
D733 D3 INC   R81
     51
D735 79 ADC   %>00,R80
     00
     50
D738 B5 CLR   A
D739 CA DJNZ  B,F6          [D731]
     F6
D73B D3 INC   R119
     77
D73D 79 ADC   %>00,R118
     00
     76
D740 0A RETS

D741 8A LDA   @>22CF
     22
     CF
D744 E2 JZ    3C            [D782]
     3C
D746 8E CALL  @>D722
     D7
     22
D749 8A LDA   @>22CE
     22
     CE
D74C B3 INC   A
D74D 8B STA   @>22CE
     22
     CE
D750 E0 JMP   1D            [D76F]
     1D

SBA 24C

D752 8A LDA   @>205D
     20
     5D
D755 D0 MOV   A,R36
     24

SBA 248
This SBA is used to enter a non-field instruction in programmemory

D757 8A LDA   @>22CF
     22
     CF
D75A E6 JNZ   08            [D764]
     08
D75C 8E CALL  @>D36D        SBA 246
     D3
     6D
D75F 8A LDA   @>22CF
     22
     CF
D762 E2 JZ    1E            [D782]
     1E
D764 8E CALL  @>D722
     D7
     22
D767 22 MOV   %>01,A
     01
D769 8B STA   @>22CF
     22
     CF
D76C 8E CALL  @>D713        Move down instructionlengths
     D7
     13
D76F 8E CALL  @>DF16        Calculate the length of the next instruction
     DF
     16
D772 12 MOV   R79,A
     4F
D774 8B STA   @>22CF
     22
     CF
D777 E6 JNZ   09            [D782]
     09
D779 8A LDA   @>22CE
     22
     CE
D77C 4A SUB   R0,R119
     00
     77
D77F 7B SBB   %>00,R118
     00
     76
D782 0A RETS

SBA 24E
This SBA performs the learn DEL function

D783 77 BTJZ  %>20,R48,FB   [D782] Test if flag 69 is reset
     20
     30
     FB
D787 73 AND   %>FB,R47      Reset flag 58
     FB
     2F
D78A 8A LDA   @>22CF
     22
     CF
D78D E2 JZ    F3            [D782]
     F3
D78F D0 MOV   A,R79
     4F
D791 8E CALL  @>F06F        SBA 46F
     F0                     Delete the instruction at the current PC
     6F
D794 E0 JMP   D9            [D76F]
     D9

SBA 250
This SBA performs the learn INS function

D796 77 BTJZ  %>20,R48,E8   [D782] Test if flag 69 is reset
     20
     30
     E8
D79A 74 OR    %>04,R47      Set flag 58
     04
     2F
D79D 0A RETS

D79E 8A LDA   @>22CE        Lenght of the previous instruction
     22
     CE
D7A1 26 BTJO  %>FE,A,20     [D7C4] Greater than 1?, continue ...
     FE                            else check for INV
     20
D7A4 98 MOVD  R119,R81      Get copy of PC
     77
     51
D7A7 DB DECD  R81           Go back to previous instruction
     51
D7A9 9A LDA   *R81          Get previous instruction
     51
D7AB 2D CMP   %>05,A        Compare with INV
     05
D7AD E6 JNE   15            [D7C4] Not INV?, continue ...
     15                            else change GTL/SBL into GTO/SBR
D7AF 78 ADD   %>04,R36      GTL -> GTO and SBL -> SBR
     04
     24
D7B2 12 MOV   R36,A
     24
D7B4 9B STA   *R81
     51
D7B6 22 MOV   %>44,A        Infobyte for GTO and SBR.
     44
D7B8 E0 JMP   1A            [D7D4]
     1A

SBA 252
This SBA is used to enter a field instruction in programmemory

D7BA 7D CMP   %>F5,R36      Compare with GTL
     F5
     24
D7BD E2 JEQ   DF            [D79E] GTL?, check previous to convert INV GTL
     DF                            into GTO
D7BF 7D CMP   %>F6,R36      Compare with SBL
     F6
     24
D7C2 E2 JEQ   DA            [D79E] SBL?, check previous to convert INV SBL
     DA                            into SBR
D7C4 8E CALL  @>D757        SBA 248
     D7                     Enter a non-field instruction in programmemory
     57
D7C7 32 MOV   R36,B
     24
D7C9 AA LDA   @>D613(B)     Load fieldindicator for function
     D6
     13
D7CC 27 BTJZ  %>08,A,05     [D7D4]
     08
     05
D7CF 77 BTJZ  %>02,R46,01   [D7D4] Test if flag 49 is reset
     02
     2E
     01
D7D3 B3 INC   A             In SYS mode we have one more position in the field
D7D4 8B STA   @>20AC
     20
     AC
D7D7 8E CALL  @>C754        Reset flag 39, followed by SBA 226
     C7
     54
D7DA 8E CALL  @>CF66        SBA 236
     CF                     Wait for key
     66
D7DD 7D CMP   %>A6,R37      Keycode for INS [2nd ->]
     A6
     25
D7E0 E6 JNE   05            [D7E7]
     05
D7E2 74 OR    %>04,R47      Set flag 58
     04
     2F
D7E5 E0 JMP   F0            [D7D7]
     F0

D7E7 8A LDA   @>20AC
     20
     AC
D7EA 27 BTJZ  %>40,A,32     [D81F]
     40
     32
D7ED 7D CMP   %>BE,R37      Keycode for IND
     BE
     25
D7F0 E6 JNE   2D            [D81F]
     2D
D7F2 72 MOV   %>F8,R36      Programcode for IND
     F8
     24
D7F5 8E CALL  @>D741
     D7
     41
D7F8 E0 JMP   CD            [D7C7]
     CD

D7FA 52 MOV   %>E3,B        Programcode for ST+
     E3
D7FC 7D CMP   %>31,R37      Keycode for +
     31
     25
D7FF E2 JEQ   12            [D813]
     12
D801 C3 INC   B             Change ST+ into ST-
D802 7D CMP   %>32,R37      Keycode for -
     32
     25
D805 E2 JEQ   0C            [D813]
     0C
D807 C3 INC   B             Change ST- into ST*
D808 7D CMP   %>33,R37      Keycode for x
     33
     25
D80B E2 JEQ   06            [D813]
     06
D80D C3 INC   B             Change ST* into ST/
D80E 7D CMP   %>30,R37      Keycode for /
     30
     25
D811 E6 JNE   1D            [D830]
     1D
D813 D1 MOV   B,R36
     24
D815 98 MOVD  R119,R81
     77
     51
D818 DB DECD  R81
     51
D81A 62 MOV   B,A
D81B 9B STA   *R81
     51
D81D E0 JMP   B8            [D7D7]
     B8

D81F B5 CLR   A
D820 8B STA   @>21AF
     21
     AF
D823 8A LDA   @>20AC
     20
     AC
D826 E1 JN    23            [D84B]
     23
D828 26 BTJO  %>10,A,1A     [D845]
     10
     1A
D82B 7D CMP   %>E2,R36      Programcode for STO
     E2
     24
D82E E2 JEQ   CA            [D7FA]
     CA
D830 27 BTJZ  %>08,A,46     [D879]
     08
     46
D833 88 MOVD  %>0322,R1     SBA 322
     03                     Test if scancode comes from a letter
     22
     01
D837 F8 TRAP7
D838 C1 TSTB
D839 E2 JZ    24            [D85F]
     24
D83B 58 ADD   %>40,B
     40
D83D D1 MOV   B,R36
     24
D83F 73 AND   %>7F,R44      Reset flag 39
     7F
     2C
D842 8C BR    @>D741
     D7
     41

D845 8C BR    @>D937
     D9
     37

D848 8C BR    @>D9BB
     D9
     BB

D84B 23 AND   %>7F,A
     7F
D84D E2 JZ    F9            [D848]
     F9
D84F 8B STA   @>20AC
     20
     AC
D852 7D CMP   %>38,R37      Keycode for =
     38
     25
D855 E6 JNE   D9            [D830]
     D9
D857 72 MOV   %>10,R36      Programcode for =
     10
     24
D85A E0 JMP   E3            [D83F]
     E3

D85C 8C BR    @>D92D
     D9
     2D

D85F 77 BTJZ  %>02,R46,16   [D879] Test if flag 49 is reset
     02
     2E
     16
D863 7D CMP   %>3A,R37      Keycode for 5
     3A
     25
D866 E2 JEQ   0A            [D872] 5 is not allowed as the first digit
     0A                            of a 4-digit register field
D868 7D CMP   %>3E,R37      Keycode for 4
     3E
     25
D86B E2 JEQ   05            [D872] 4 is not allowed as the first digit
     05                            of a 4-digit register field
D86D 7D CMP   %>3F,R37      Keycode for 1
     3F
     25
D870 E6 JNE   07            [D879] 1 is not allowed as the first digit
     07                            of a 4-digit register field
D872 8A LDA   @>20AC
     20
     AC
D875 B2 DEC   A
D876 8B STA   @>20AC
     20
     AC
D879 8A LDA   @>20AC
     20
     AC
D87C B3 INC   A
D87D D5 CLR   R36
     24
D87F 27 BTJZ  %>04,A,03     [D885]
     04
     03
D882 8E CALL  @>D741
     D7
     41
D885 8A LDA   @>22CF
     22
     CF
D888 E2 JZ    D2            [D85C]
     D2
D88A 8E CALL  @>D741
     D7
     41
D88D 8A LDA   @>22CF
     22
     CF
D890 C0 MOV   A,B
D891 8A LDA   @>22CE
     22
     CE
D894 C1 TSTB
D895 E2 JZ    06            [D89D]
     06
D897 4A SUB   R0,R119
     00
     77
D89A 7B SBB   %>00,R118
     00
     76
D89D 24 OR    %>80,A
     80
D89F 8B STA   @>22CE
     22
     CE
D8A2 88 MOVD  %>22CE,R81    Source of data
     22
     CE
     51
D8A6 88 MOVD  %>22CF,R83    Destination
     22
     CF
     53
D8AA 88 MOVD  %>000F,R85    Number of bytes to move
     00
     0F
     55
D8AE F7 TRAP8               Move block
D8AF 88 MOVD  %>0324,R1     SBA 324
     03                     Test if scancode comes from a digit
     24
     01
D8B3 F8 TRAP7
D8B4 C1 TSTB
D8B5 E1 JN    64            [D91B]
     64
D8B7 98 MOVD  R119,R81
     77
     51
D8BA 8A LDA   @>22CF
     22
     CF
D8BD 23 AND   %>7F,A
     7F
D8BF B2 DEC   A
D8C0 48 ADD   R0,R81
     00
     51
D8C3 79 ADC   %>00,R80
     00
     50
D8C6 98 MOVD  R81,R92
     51
     5C
D8C9 9A LDA   *R81
     51
D8CB B7 SWAP  A
D8CC B8 PUSH  A
D8CD 23 AND   %>F0,A
     F0
D8CF 68 ADD   B,A
D8D0 9B STA   *R81
     51
D8D2 DB DECD  R81
     51
D8D4 8A LDA   @>21AF
     21
     AF
D8D7 B3 INC   A
D8D8 8B STA   @>21AF
     21
     AF
D8DB C9 POP   B
D8DC 2D CMP   %>03,A
     03
D8DE E7 JL    0A            [D8EA]
     0A
D8E0 9A LDA   *R81
     51
D8E2 B7 SWAP  A
D8E3 23 AND   %>F0,A
     F0
D8E5 53 AND   %>0F,B
     0F
D8E7 68 ADD   B,A
D8E8 9B STA   *R81
     51
D8EA 8A LDA   @>20AC
     20
     AC
D8ED B2 DEC   A
D8EE 8B STA   @>20AC
     20
     AC
D8F1 26 BTJO  %>07,A,17     [D90B]
     07
     17
D8F4 73 AND   %>7F,R44      Reset flag 39
     7F
     2C
D8F7 8A LDA   @>22CF
     22
     CF
D8FA E2 JZ    OE            [D90A]
     0E
D8FC 23 AND   %>7F,A
     7F
D8FE 8B STA   @>22CF
     22
     CF
D901 48 ADD   R0,R119
     00
     77
D904 79 ADC   %>00,R118
     00
     76
D907 8C BR    @>D76C
     D7
     6C

D90A 0A RETS

D90B 8E CALL  @>C754
     C7
     54
D90E 8E CALL  @>CF66        SBA 236
     CF                     Wait for key
     66
D911 7D CMP   %>A6,R37      Keycode for INS
     A6
     25
D914 E6 JNE   99            [D8AF]
     99
D916 74 OR    %>04,R47      Set flag 58
     04
     2F
D919 E0 JMP   F0            [D90B]
     F0

D91B 8A LDA   @>20AC
     20
     AC
D91E 27 BTJZ  %>20,A,0C     [D92D]
     20
     0C
D921 88 MOVD  %>03BA,R1     SBA 3BA
     03                     Test if scancode comes from a hexdigit
     BA
     01
D925 F8 TRAP7
D926 C1 TSTB
D927 E2 JZ    04            [D92D]
     04
D929 58 ADD   %>09,B
     09
D92B E0 JMP   8A            [D8B7]
     8A

D92D 7D CMP   %>26,R37      Keycode for ->
     26
     25
D930 E2 JEQ   C5            [D8F7]
     C5
D932 74 OR    %>80,R46      Set flag 55
     80
     2E
D935 E0 JMP   C0            [D8F7]
     C0

D937 8A LDA   @>20AC
     20
     AC
D93A 23 AND   %>07,A
     07
D93C 8B STA   @>20AC
     20
     AC
D93F D0 MOV   A,R78
     4E
D941 72 MOV   %>20,R36
     20
     24
D944 8A LDA   @>22CF
     22
     CF
D947 E2 JZ    E4            [D92D]
     E4
D949 8E CALL  @>D741
     D7
     41
D94C DA DJNZ  R78,F5        [D944]
     4E
     F5
D94F 8A LDA   @>22CF
     22
     CF
D952 C0 MOV   A,B
D953 8A LDA   @>22CE
     22
     CE
D956 C1 TSTB
D957 E2 JZ    06            [D95F]
     06
D959 4A SUB   R0,R119
     00
     77
D95C 7B SBB   %>00,R118
     00
     76
D95F 24 OR    %>80,A
     80
D961 8B STA   @>22CE
     22
     CE
D964 88 MOVD  %>22CE,R81
     22
     CE
     51
D968 88 MOVD  %>22CF,R83
     22
     CF
     53
D96C 88 MOVD  %>000F,R85
     00
     0F
     55
D970 F7 TRAP8               Move block
D971 8E CALL  @>C5A4        SBA 21C
     C5                     Convert scancode to ASCII or 0 at >2107
     A4
D974 C1 TSTB
D975 E2 JZ    B6            [D92D] Key has no corresponding ASCII code
     B6
D977 8A LDA   @>22CF
     22
     CF
D97A 23 AND   %>7F,A
     7F
D97C C0 MOV   A,B
D97D 8A LDA   @>20AC
     20
     AC
D980 3A SUB   R0,B
     00
D982 8A LDA   @>21AF
     21
     AF
D985 38 ADD   R0,B
     00
D987 B3 INC   A
D988 8B STA   @>21AF
     21
     AF
D98B 98 MOVD  R119,R81
     77
     51
D98E 48 ADD   R1,R81
     01
     51
D991 79 ADC   %>00,R80
     00
     50
D994 98 MOVD  R81,R92
     51
     5C
D997 D3 INC   R92
     5C
D999 79 ADC   %>00,R91
     00
     5B
D99C 12 MOV   R37,A
     25
D99E 9B STA   *R81
     51
D9A0 8A LDA   @>20AC
     20
     AC
D9A3 8D CMPA  @>21AF
     21
     AF
D9A6 E2 JEQ   10            [D9B8]
     10
D9A8 8E CALL  @>C754
     C7
     54
D9AB 8E CALL  @>CF66        SBA 236
     CF                     Wait for key
     66
D9AE 7D CMP   %>A6,R37      Keycode for INS
     A6
     25
D9B1 E6 JNE   BE            [D971]
     BE
D9B3 74 OR    %>04,R47      Set flag 58
     04
     2F
D9B6 E0 JMP   F0            [D9A8]
     F0

D9B8 8C BR    @>D8F7
     D8
     F7

D9BB 12 MOV   R37,A
     25
D9BD 23 AND   %>7F,A
     7F
D9BF 2D CMP   %>37,A        Keycode for DEL
     37
D9C1 E6 JNE   06            [D9C9]
     06
D9C3 72 MOV   %>02,R36
     02
     24
D9C6 8C BR    @>D83F
     D8
     3F

D9C9 52 MOV   %>05,B        Loopcounter
     05
D9CB AD CMPA  @>D9FB(B)     Compare with table
     D9
     FB
D9CE E2 JEQ   06            [D9D6] Match?, Fx key found [(B)=x]
     06
D9D0 CA DJNZ  B,F9          [D9CB] Loop back
     F9
D9D2 74 OR    %>80,R46      Set flag 55
     80
     2E
D9D5 0A RETS

D9D6 72 MOV   %>8F,R36      Programcode to create Fx
     8F
     24
D9D9 48 ADD   R1,R36        Add B to obtain correct Fx code
     01
     24
D9DC 8E CALL  @>D741
     D7
     41
D9DF 8E CALL  @>C754
     C7
     54
D9E2 8E CALL  @>CF66        SBA 236
     CF                     Wait for key
     66
D9E5 7D CMP   %>A6,R37      Keycode for INS
     A6
     25
D9E8 E6 JNE   05            [D9EF]
     05
D9EA 74 OR    %>04,R47      Set flag 58
     04
     2F
D9ED E0 JMP   F0            [D9DF]
     F0

D9EF 12 MOV   R37,A
     25
D9F1 23 AND   %>7F,A
     7F
D9F3 2D CMP   %>37,A        Keycode for DEL
     37
D9F5 E2 JEQ   CC            [D9C3]
     CC
D9F7 22 MOV   %>05,A
     05
D9F9 8C BR    @>D93C
     D9
     3C

Data to obtain correct Fx programcode

D9FC 02
D9FD 03
D9FE 04
D9FF 05
DA00 06

SBA 254
This SBA is used to enter a SHW instruction in programmemory

DA01 42 MOV   R36,R37
     24
     25
DA04 72 MOV   %>D9,R36      Programcode for SHW
     D9
     24
DA07 8E CALL  @>D757        SBA 248
     D7                     Enter a non-field instruction in programmemory
     57
DA0A 42 MOV   R37,R36
     25
     24
DA0D 73 AND   %>0F,R36
     0F
     24
DA10 8E CALL  @>D741
     D7
     41

The following two instructions cause the redisplay of the STAT menu after a
SHW instruction has been entered.

DA13 74 OR    %>80,R46      Set flag 55
     80
     2E
DA16 72 MOV   %>1A,R37      Enter keycode for STAT-key
     1A
     25
DA19 0A RETS

SBA 25A
This SBA performs the CP, Clear Program, function. To prevent accidental
clearing, this function only works in learn mode, that is if flag 69 is set.

DA1A 77 BTJZ  %>20,R48,FB   [DA19] Test if flag 69 is reset
     20
     30
     FB
DA1E F3 TRAP12              Reset flags 35, 37, 38 and 59
DA1F 8E CALL  @>DA2F
     DA
     2F
DA22 98 MOVD  R115,R119
     73
     77
DA25 8C BR    @>D36D        SBA 246
     D3
     6D

SBA 27E
This SBA also performs the CP function. It is used by the RD and GET functions,
but only if a programfile is read.

DA28 22 MOV   %>2B,A        ASCII code for '+'
     2B
DA2A 8D CMPA  @>22DA        First position of file name
     22
     DA
DA2D E2 JEQ   EA            [DA19] Equal?, datafile
     EA
DA2F 8A LDA   @>20B3        LSB of beginaddress of registerarea
     20
     B3
DA32 D0 MOV   A,R83
     53
DA34 8A LDA   @>20B2        MSB of beginaddress of registerarea
     20
     B2
DA37 D0 MOV   A,R82
     52
DA39 98 MOVD  R83,R85
     53
     55
DA3C DB DECD  R83
     53
DA3E 8A LDA   @>20B5        LSB of beginaddress of programmemory
     20
     B5
DA41 C0 MOV   A,B
DA42 8A LDA   @>20B4        MSB of beginaddress of programmemory
     20
     B4
DA45 4A SUB   R1,R85
     01
     55
DA48 4B SBB   R0,R84
     00
     54
DA4B 8C BR    @>F099        SBA 499
     F0                     Clear block
     99

SBA 282
This SBA is performs the PAR function

DA4E 76 BTJO  %>10,R47,C7   [DA19] Test if flag 60 is set
     10
     2F
     C7
DA52 76 BTJO  %>20,R48,11   [DA67] Test if flag 69 is set
     20
     30
     11
DA56 76 BTJO  %>07,R45,BF   [DA19] Test if flag 40, 41 or 42 is set
     07
     2D
     BF
DA5A 72 MOV   %>90,R50      Reset flags 80..83 and 85..86, set flags 84 and 87
     90
     32
DA5D 88 MOVD  %>0114,R1     SBA 114
     01
     14
     01
DA61 F8 TRAP7
DA62 22 MOV   %>1E,A
     1E
DA64 8C BR    @>CFF3
     CF
     F3

DA67 8C BR    @>D757        SBA 248
     D7                     Enter a non-field instruction in programmemory
     57

SBA 258
This SBA performs the [INV] ASM function

DA6A 76 BTJO  %>10,R47,AB   [DA19] Test if flag 60 is set
     10
     2F
     AB
DA6E 76 BTJO  %>20,R48,F5   [DA67] Test if flag 69 is set
     20
     30
     F5
DA72 D5 CLR   R50           Reset flags 80..87
     32
DA74 88 MOVD  %>0114,R1     SBA 114
     01
     14
     01
DA78 F8 TRAP7
DA79 8E CALL  @>D2EC        Save RUN PC etc from SR 2014 and replace them by
     D2                     the values from SR 2038
     EC
DA7C D5 CLR   R66           Flag to indicate RUN, as RUN GTL/SBL may not be
     42                     assembled!
DA7E B5 CLR   A
DA7F 8B STA   @>2105        This prevents errors in the label search
     21
     05
DA82 77 BTJZ  %>40,R44,03   [DA89] Test if flag 38 is reset
     40
     2C
     03
DA86 8C BR    @>DB2C        Routine for INV ASM
     DB
     2C

Entry point for the ASM function

DA89 8E CALL  @>DF16        Calculate the length of the next instruction
     DF
     16
DA8C 76 BTJO  %>FF,R79,04   [DA94] R79 = 0 at the end of the programmemory
     FF
     4F
     04

Common code to be executed at the end of ASM and INV ASM

DA90 F3 TRAP12              Reset flags 35, 37, 38 and 59
DA91 8C BR    @>D332        Restore the RUN PC etc saved at >DA79
     D3
     32

DA94 7D CMP   %>01,R79      RUN has a length of 1
     01
     4F
DA97 E6 JNE   11            [DAAA] IL <> 1?, check for GTL, SBL or DFN
     11
DA99 D5 CLR   R66           Clear the RUN flag
     42
DA9B 7D CMP   %>CF,R64      Instructioncode for RUN
     CF
     40
DA9E E6 JNE   02            [DAA2] Not RUN?, next instruction
     02
DAA0 D3 INC   R66           Set the RUN incicator
     42
DAA2 48 ADD   R79,R119       Address of next instruction
     4F                      
     77                      
DAA5 79 ADC   %>00,R118      
     00                      
     76                     
DAA8 E0 JMP   DF            [DA89]
     DF

DAAA 7D CMP   %>03,R79      GTL and SBL have a length of 3
     03
     4F
DAAD E6 JNE   65            [DB14] IL <> 3?, check for DFN
     65
DAAF 9A LDA   *R119         Load code at current PC
     77
DAB1 2D CMP   %>F5,A        Compare with GTL
     F5
DAB3 E2 JEQ   08            [DABD]
     08
DAB5 2D CMP   %>F6,A        Compare with SBL
     F6
DAB7 E2 JEQ   04            [DABD]
     04
DAB9 D5 CLR   R66           Clear the RUN flag
     42
DABB E0 JMP   E5            [DAA2]
     E5

DABD 76 BTJO  %>FF,R66,F8   [DAB9] Previous RUN?, do not assemble
     FF
     42
     F8
DAC1 98 MOVD  R119,R69      Save PC
     77
     45
DAC4 D3 INC   R119           Increment PC to address of first character
     77                        after GTL or SBL
DAC6 79 ADC   %>00,R118      
     00                      
     76                     
DAC9 9A LDA   *R119         Load character
     77
DACB 2D CMP   %>20,A        Compare with ' '
     20
DACD E7 JL    40            [DB0F] Non ASCII?, do not assemble
     40
DACF 2D CMP   %>80,A        Compare with first character after '<-'
     80
DAD1 E3 JHS   3C            [DB0F] Non ASCII?, do not assemble
     3C
DAD3 D0 MOV   A,R72         Store for use in SBA 469
     48
DAD5 D3 INC   R119           Increment PC to address of second character
     77                        after GTL or SBL
DAD7 79 ADC   %>00,R118      
     00                      
     76                     
DADA 9A LDA   *R119         Load character
     77
DADC 2D CMP   %>20,A        Compare with ' '
     20
DADE E7 JL    2F            [DB0F] Non ASCII?, do not assemble
     2F
DAE0 2D CMP   %>80,A        Compare with first character after '<-'
     80
DAE2 E3 JHS   2B            [DB0F] Non ASCII?, do not assemble
     2B
DAE4 D0 MOV   A,R73         Store for use in SBA 469
     49
DAE6 98 MOVD  R115,R77       Store begin- and endaddress of programarea
     73                      
     4D                      
DAE9 98 MOVD  R117,R75       
     75                      
     4B                     
DAEC 8E CALL  @>F069        SBA 469
     F0                     Search for a label
     69
DAEF 7D CMP   %>00,R76      0 indicates that the label hasn't been found
     00
     4C
DAF2 E2 JEQ   1B            [DB0F] Label not found?, next
     1B
DAF4 98 MOVD  R119,R73      Save PC
     77
     49
DAF7 98 MOVD  R77,R119      Address of first byte after label
     4D
     77
DAFA 88 MOVD  %>0398,R1     SBA 398
     03                     Convert the binary PC to decimal
     98
     01
DAFE F8 TRAP7
DAFF 12 MOV   R65,A         LSB of converted address
     41
DB01 9B STA   *R73          Store as second byte of GTO/SBR address
     49
DB03 DB DECD  R73
     49
DB05 12 MOV   R64,A         MSB of converted address
     40
DB07 9B STA   *R73          Store a first byte of GTO/SBR address
     49
DB09 9A LDA   *R69          Load GTL, SBL or DFN instructioncode
     45
DB0B 28 ADD   %>04,A        Adding 4 changes it into GTO, SBR or DFA
     04
DB0D 9B STA   *R69
     45
DB0F 98 MOVD  R69,R119      Restore PC
     45
     77
DB12 E0 JMP   8E            [DAA2] Continue with next instruction
     8E

DB14 D5 CLR   R66           Clear the RUN flag
     42
DB16 7D CMP   %>07,R79      DFN and DFA have a length of 7
     07
     4F
DB19 E6 JNE   A0            [DABB] IL <> 7?, next
     A0
DB1B 9A LDA   *R119         Load instructioncode
     77
DB1D 2D CMP   %>F7,A        Programcode for DFN
     F7
DB1F E6 JNE   9A            [DABB] Code <> DFN?, next
     9A
DB21 98 MOVD  R119,R69      Save PC
     77
     45
DB24 78 ADD   %>05,R119      Address of first character of label
     05                        associated with DFN
     77                      
DB27 79 ADC   %>00,R118      
     00                      
     76                     
DB2A E0 JMP   9D            [DAC9]
     9D

Entry point for the INV ASM function

DB2C 8E CALL  @>DF16        Calculate the length of the next instruction
     DF
     16
DB2F 76 BTJO  %>FF,R79,03   [DB36] IL <> 0?, not end of memory
     FF
     4F
     03
DB33 8C BR    @>DA90        Common end of ASM and INV ASM functions
     DA
     90

DB36 7D CMP   %>01,R79      RUN has a length of 1
     01
     4F
DB39 E6 JNE   11            [DB4C] IL <> 1?, check GTO, SBR or DFA
     11
DB3B D5 CLR   R66           Clear the RUN flag
     42
DB3D 7D CMP   %>CF,R64      Instructioncode for RUN
     CF
     40
DB40 E6 JNE   02            [DB44] Code <> RUN?, next
     02
DB42 D3 INC   R66           Set the RUN flag
     42
DB44 48 ADD   R79,R119       Address of next instruction
     4F                      
     77                      
DB47 79 ADC   %>00,R118      
     00                      
     76                     
DB4A E0 JMP   E0            [DB2C]
     E0

DB4C 7D CMP   %>03,R79      GTO and SBR have a length of 3
     03
     4F
DB4F E6 JNE   7F            [DBD0] Check for DFA
     7F
DB51 9A LDA   *R119         Load instructioncode
     77
DB53 2D CMP   %>F9,A        Programcode for GTO
     F9
DB55 E2 JEQ   08            [DB5F]
     08
DB57 2D CMP   %>FA,A        Programcode for SBR
     FA
DB59 E2 JEQ   04            [DB5F]
     04
DB5B D5 CLR   R66           Claer the RUN flag
     42
DB5D E0 JMP   E5            [DB44] Next
     E5

DB5F 76 BTJO  %>FF,R66,F8   [DB5B] Previous RUN?, do not assemble
     FF
     42
     F8
DB63 98 MOVD  R119,R69      Save PC
     77
     45
DB66 D3 INC   R119           Address of MSB of address after GTO, SBR
     77                        or DFA
DB68 79 ADC   %>00,R118      
     00                      
     76                     
DB6B 9A LDA   *R119         Load MSB of address
     77
DB6D 8B STA   @>21AB        Store for use in SBA 460
     21
     AB
DB70 D3 INC   R119           Address of LSB of address after GTO, SBR
     77                        or DFA
DB72 79 ADC   %>00,R118      
     00                      
     76                     
DB75 9A LDA   *R119         Load LSB of address
     77
DB77 8B STA   @>21AC        Store for use in SBA 460
     21
     AC
DB7A 8E CALL  @>F060        SBA 460
     F0                     Convert a 4 digit BCD number to binary
     60
DB7D 7A SUB   %>03,R65       Subtracting 3 from the address after the
     03                        GTO, SBR or DFA should give the address of
     41                        a LBL, relative to the beginning of program-
DB80 7B SBB   %>00,R64         memory
     00                      
     40                     
DB83 E7 JNC   45            [DBCA] Address < 0?, next
     45
DB85 48 ADD   R115,R65       Calculate the absolute address of the
     73                        expected LBL
     41                      
DB88 49 ADC   R114,R64       
     72                      
     40                     
DB8B 98 MOVD  R119,R73      Save the current PC
     77
     49
DB8E 98 MOVD  R65,R119      Absolute address of expected LBL
     41
     77
DB91 9A LDA   *R119         Load programcode at calculated address
     77
DB93 2D CMP   %>FF,A        Programcode for LBL
     FF
DB95 E6 JNE   33            [DBCA] No LBL?, next
     33
DB97 D3 INC   R119           Address of first charcter after LBL
     77                      
DB99 79 ADC   %>00,R118      
     00                      
     76                     
DB9C 9A LDA   *R119
     77
DB9E 2D CMP   %>20,A        Compare with ' '
     20
DBA0 E7 JL    28            [DBCA] Non ASCII?, do not disassemble
     28
DBA2 2D CMP   %>80,A        Compare with first character after '<-'
     80
DBA4 E3 JHS   24            [DBCA] Non ASCII?, do not disassemble
     24
DBA6 D0 MOV   A,R64         Save character
     40
DBA8 D3 INC   R119           Address of second character after LBL
     77                      
DBAA 79 ADC   %>00,R119      
     00                      
     77                     
DBAD 8E CALL  @>F057        SBA 457
     F0                     Fetch code at RUN PC and increment RUN PC,
     57                     set flag 71 if RUN PC out of range
DBB0 76 BTJO  %>80,R48,16   [DBCA] Test if flag 71 is set
     80
     30
     16
DBB4 2D CMP   %>20,A        Compare with ' '
     20
DBB6 E7 JL    12            [DBCA] Non ASCII?, do not disassemble
     12
DBB8 2D CMP   %>80,A        Compare with first character after '<-'
     80
DBBA E3 JHS   0E            [DBCA] Non ASCII?, do not disassemble
     0E
DBBC 9B STA   *R73          Store as second character after GTO, SBR or DFA
     49
DBBE DB DECD  R73
     49
DBC0 12 MOV   R64,A         Get first character back
     40
DBC2 9B STA   *R73          Store as first character after GTO, SBR or DFA
     49
DBC4 9A LDA   *R69          Load GTO, SBR or DFA instructioncode
     45
DBC6 2A SUB   %>04,A        Subtracting 4 changes it into GTL, SBL or DFN
     04
DBC8 9B STA   *R69
     45
DBCA 98 MOVD  R69,R119      Restore PC
     45
     77
DBCD 8C BR    @>DB44        Next
     DB
     44

DBD0 D5 CLR   R66           Clear the RUN flag
     42
DBD2 7D CMP   %>07,R79      DFN and DFA have a length of 7
     07
     4F
DBD5 E6 JNE   F6            [DBCD] IL <> 7?, next
     F6
DBD7 9A LDA   *R119         Load programcode
     77
DBD9 2D CMP   %>FB,A        Instructioncode for DFA
     FB
DBDB E6 JNE   F0            [DBCD] Code <> DFA?, next
     F0
DBDD 98 MOVD  R119,R69      Save PC
     77
     45
DBE0 78 ADD   %>05,R119      Address of address after DFA
     05                      
     77                      
DBE3 79 ADC   %>00,R118      
     00                      
     76                     
DBE6 E0 JMP   83            [DB6B]
     83

SBA 272
This SBA is used to list a number of programsteps

DBE8 8A LDA   @>20B3         Save the max PC
     20                      
     B3                      
DBEB 8B STA   @>22FC         
     22                      
     FC                      
DBEE 8A LDA   @>20B2         
     20                      
     B2                      
DBF1 8B STA   @>22FB         
     22                      
     FB                     
DBF4 8A LDA   @>22BD         Replace the max PC by the address of
     22                        the first byte following the last
     BD                        instruction of the program. The address
DBF7 D0 MOV   A,R66            can be found by SBA 244.
     42                      
DBF9 8A LDA   @>22BC         
     22                      
     BC                      
DBFC C0 MOV   A,B            
DBFD 8A LDA   @>22BB         
     22                      
     BB                      
DC00 38 ADD   R66,B          
     42                      
DC02 29 ADC   %>00,A         
     00                      
DC04 8B STA   @>20B2         
     20                      
     B2                      
DC07 62 MOV   B,A            
DC08 8B STA   @>20B3         
     20                      
     B3                     
DC0B 8E CALL  @>DC18
     DC
     18
DC0E 8C BR    @>DEC8
     DE
     C8

DC11 74 OR    %>01,R48      Set flag 64
     01
     30
DC14 98 MOVD  R81,R119      Restore the saved RUN PC
     51
     77
DC17 0A RETS

DC18 98 MOVD  R119,R81      Save the RUN PC
     77
     51
DC1B 8A LDA   @>20B7
     20
     B7
DC1E D0 MOV   A,R119
     77
DC20 8A LDA   @>20B6
     20
     B6
DC23 D0 MOV   A,R118
     76
DC25 8E CALL  @>DE44
     DE
     44
DC28 E7 JL    E7            [DC11]
     E7
DC2A 8E CALL  @>DE51        Fill the entire PD buffer with blanks
     DE
     51
DC2D 88 MOVD  %>224F,R83
     22
     4F
     53
DC31 98 MOVD  R115,R67
     73
     43
DC34 8A LDA   @>20B5
     20
     B5
DC37 D0 MOV   A,R115
     73
DC39 8A LDA   @>20B4
     20
     B4
DC3C D0 MOV   A,R114
     72
DC3E 88 MOVD  %>0398,R1     SBA 398
     03                     Convert the binary PC to decimal
     98
     01
DC42 F8 TRAP7
DC43 98 MOVD  R67,R115
     43
     73
DC46 52 MOV   %>02,B
     02
DC48 12 MOV   R64,A
     40
DC4A B8 PUSH  A
DC4B 8E CALL  @>D6D7        Convert the MSN of a to ASCII and store the
     D6                     result in the PD buffer
     D7
DC4E B9 POP   A
DC4F 8E CALL  @>D6D8        Convert the LSN of a to ASCII and store the
     D6                     result in the PD buffer
     D8
DC52 12 MOV   R65,A
     41
DC54 CA DJNZ  B,F4          [DC4A]
     F4
DC56 72 MOV   %>4A,R65
     4A
     41
DC59 72 MOV   %>50,R67
     50
     43
DC5C 77 BTJZ  %>04,R49,07   [DC67] Test if flag 74 is reset
     04
     31
     07
DC60 8A LDA   @>213B        Load device width
     21
     3B
DC63 2D CMP   %>10,A        Compare with 16
     10
DC65 E3 JHS   02            [DC69]
     02
DC67 22 MOV   %>10,A
     10
DC69 4A SUB   R0,R67
     00
     43
DC6C D5 CLR   R64
     40
DC6E D5 CLR   R66
     42
DC70 9A LDA   *R119         Load the current instructioncode
     77
DC72 D0 MOV   A,R69         Save it
     45
DC74 88 MOVD  %>219F,R83
     21
     9F
     53
DC78 98 MOVD  R119,R77
     77
     4D
DC7B 7D CMP   %>20,R69      ASCII code for ' '
     20
     45
DC7E E7 JL    13            [DC93]
     13
DC80 7D CMP   %>80,R69      First character after '<-'
     80
     45
DC83 E3 JHS   0E            [DC93]
     0E
DC85 76 BTJO  %>FF,R66,05   [DC8E]
     FF
     42
     05
DC89 D3 INC   R66
     42
DC8B 22 MOV   %>60,A        ASCII code for '`'
     60
DC8D ED TRAP18              Store in the PD buffer
DC8E 12 MOV   R69,A
     45
DC90 ED TRAP18              Store in the PD buffer
DC91 E0 JMP   33            [DCC6]
     33

DC93 EC TRAP19
DC94 7D CMP   %>F8,R69      Instructioncode for IND
     F8
     45
DC97 E2 JEQ   14            [DCAD]
     14
DC99 7D CMP   %>FF,R69      Instructioncode for LBL
     FF
     45
DC9C E6 JNE   0A            [DCA8]
     0A
DC9E 7D CMP   %>4A,R65
     4A
     41
DCA1 E2 JEQ   05            [DCA8]
     05
DCA3 7A SUB   %>50,R83
     50
     53
DCA6 E0 JMP   05            [DCAD]
     05

DCA8 7D CMP   %>D5,R69      All instructioncodes after SF (can) have fields
     D5
     45
DCAB E3 JHS   4B            [DCF8]
     4B
DCAD 12 MOV   R66,A
     42
DCAF E2 JZ    15            [DCC6]
     15
DCB1 D5 CLR   R66
     42
DCB3 D5 CLR   R64
     40
DCB5 22 MOV   %>60,A        ASCII code for '`'
     60
DCB7 32 MOV   R65,B
     41
DCB9 AB STA   @>2200(B)
     22
     00
DCBC C2 DEC   B
DCBD C2 DEC   B
DCBE E1 JN    19            [DCD9]
     19
DCC0 D1 MOV   B,R65
     41
DCC2 3D CMP   R67,B
     43
DCC4 E7 JL    13            [DCD9]
     13
DCC6 88 MOVD  %>219F,R1
     21
     9F
     01
DCCA 3A SUB   R83,B
     53
DCCC 56 BTJO  %>FE,B,2C     [DCFB]
     FE
     2C
DCCF 7D CMP   %>90,R69
     90
     45
DCD2 E3 JHS   27            [DCFB]
     27
DCD4 72 MOV   %>01,R64
     01
     40
DCD7 E0 JMP   38            [DD11]
     38

DCD9 98 MOVD  R77,R119
     4D
     77
DCDC 7D CMP   %>4A,R65
     4A
     41
DCDF E6 JNE   14            [DCF5]
     14
DCE1 D8 PUSH  R81
     51
DCE3 D8 PUSH  R80
     50
DCE5 8E CALL  @>DD7B
     DD
     7B
DCE8 8E CALL  @>DE51
     DE
     51
DCEB 72 MOV   %>4F,R65
     4F
     41
DCEE D9 POP   R80
     50
DCF0 D9 POP   R81
     51
DCF2 8C BR    @>DC59
     DC
     59

DCF5 8C BR    @>DD6E
     DD
     6E

DCF8 8C BR    @>DD89
     DD
     89

DCFB 12 MOV   R64,A
     40
DCFD E2 JZ    09            [DD08]
     09
DCFF D2 DEC   R65
     41
DD01 E1 JN    D6            [DCD9]
     D6
DD03 4D CMP   R67,R65
     43
     41
DD06 E7 JL    D1            [DCD9]
     D1
DD08 72 MOV   %>01,R64
     01
     40
DD0B 76 BTJO  %>FF,R66,02   [DD11]
     FF
     42
     02
DD0F D5 CLR   R64
     40
DD11 12 MOV   R65,A
     41
DD13 1A SUB   R67,A
     43
DD15 E7 JNC   C2            [DCD9]
     C2
DD17 B3 INC   A
DD18 6A SUB   B,A
DD19 E7 JNC   BE            [DCD9]
     BE
DD1B D0 MOV   A,R68
     44
DD1D 26 BTJO  %>FE,A,0C     [DD2C]
     FE
     0C
DD20 12 MOV   R66,A
     42
DD22 E2 JZ    08            [DD2C]
     08
DD24 D2 DEC   R68
     44
DD26 E7 JNC   B1            [DCD9]
     B1
DD28 C3 INC   B
DD29 22 MOV   %>60,A        ASCII code for '`'
     60
DD2B ED TRAP18              Store in the PD buffer
DD2C 88 MOVD  %>219F,R83
     21
     9F
     53
DD30 9A LDA   *R83
     53
DD32 D6 XCHB  R65
     41
DD34 AB STA   @>2200(B)
     22
     00
DD37 C2 DEC   B
DD38 D2 DEC   R83
     53
DD3A D6 XCHB  R65
     41
DD3C CA DJNZ  B,F2          [DD30]
     F2
DD3E 76 BTJO  %>FF,R64,08   [DD4A]
     FF
     40
     08
DD42 D2 DEC   R65
     41
DD44 D2 DEC   R68
     44
DD46 E5 JPZ   02            [DD4A]
     02
DD48 D5 CLR   R68
     44
DD4A 8E CALL  @>D6AB
     D6
     AB
DD4D 8E CALL  @>DE44
     DE
     44
DD50 E7 JNC   07            [DD59]
     07
DD52 12 MOV   R68,A
     44
DD54 E2 JZ    18            [DD6E]
     18
DD56 8C BR    @>DC74
     DC
     74

DD59 74 OR    %>01,R48      Set flag 64
     01
     30
DD5C 98 MOVD  R77,R119
     4D
     77
DD5F 12 MOV   R68,A
     44
DD61 E2 JZ    0B            [DD6E]
     0B
DD63 12 MOV   R66,A
     42
DD65 E2 JZ    07            [DD6E]
     07
DD67 32 MOV   R65,B
     41
DD69 22 MOV   %>60,A
     60
DD6B AB STA   @>2200(B)
     22
     00
DD6E 98 MOVD  R119,R1
     77
     01
DD71 8B STA   @>20B6
     20
     B6
DD74 62 MOV   B,A
DD75 8B STA   @>20B7
     20
     B7
DD78 98 MOVD  R81,R119
     51
     77
DD7B 88 MOVD  %>224F,R92    Starting address of PD buffer
     22
     4F
     5C
DD7F 72 MOV   %>50,R93
     50
     5D
DD82 88 MOVD  %>012A,R1     SBA 12A
     01
     2A
     01
DD86 8C BR    @>F08D
     F0
     8D

DD89 32 MOV   R69,B
     45
DD8B AA LDA   @>D613(B)     Load infobyte for field instruction
     D6
     13
DD8E D0 MOV   A,R78
     4E
DD90 8E CALL  @>D6AB
     D6
     AB
DD93 8E CALL  @>DE44
     DE
     44
DD96 E7 JNC   42            [DDDA]
     42
DD98 77 BTJZ  %>40,R78,0F   [DDAB]
     40
     4E
     0F
DD9C 7D CMP   %>F8,R69      Instructioncode for IND
     F8
     45
DD9F E6 JNE   0A            [DDAB]
     0A
DDA1 52 MOV   %>04,B         PUT ' IND' in the PD buffer
     04                      
DDA3 AA LDA   @>D6E3(B)      
     D6                      
     E3                      
DDA6 ED TRAP18               
DDA7 CA DJNZ  B,FA          [DDA3]
     FA
DDA9 E0 JMP   DE            [DD89]
     DE

DDAB 22 MOV   %>20,A        ASCII code for ' '
     20
DDAD ED TRAP18              Store in the PD buffer
DDAE 76 BTJO  %>80,R78,2B   [DDDD]
     80
     4E
     2B
DDB2 76 BTJO  %>10,R78,1E   [DDD4]
     10
     4E
     1E
DDB6 8E CALL  @>D6B5
     D6
     B5
DDB9 73 AND   %>07,R78
     07
     4E
DDBC E2 JZ    1C            [DDDA]
     1C
DDBE 8E CALL  @>D6D1
     D6
     D1
DDC1 DA DJNZ  R78,02        [DDC6]
     4E
     02
DDC4 E0 JMP   14            [DDDA]
     14

DDC6 76 BTJO  %>01,R78,F4   [DDBE]
     01
     4E
     F4
DDCA 8E CALL  @>D6AB
     D6
     AB
DDCD 8E CALL  @>DE44
     DE
     44
DDD0 E7 JNC   08            [DDDA]
     08
DDD2 E0 JMP   EA            [DDBE]
     EA

DDD4 73 AND   %>07,R78
     07
     4E
DDD7 8E CALL  @>D690
     D6
     90
DDDA 8C BR    @>DCAD
     DC
     AD

DDDD 73 AND   %>7F,R78
     7F
     4E
DDE0 E2 JZ    10            [DDF2]
     10
DDE2 7D CMP   %>10,R69
     10
     45
DDE5 E6 JNE   CB            [DDB2]
     CB
DDE7 22 MOV   %>3D,A        ASCII code for '='
     3D
DDE9 ED TRAP18              Store in the PD buffer
DDEA E0 JMP   EE            [DDDA]
     EE

DDEC DB DECD  R119
     77
DDEE D3 INC   R83
     53
DDF0 E0 JMP   E8            [DDDA]
     E8

DDF2 8A LDA   @>219D        3rd character of system alpha register
     21
     9D
DDF5 2D CMP   %>41,A        ASCII code for 'A' [from DFA]
     41
DDF7 E2 JEQ   3B            [DE34]
     3B
DDF9 7D CMP   %>02,R69
     02
     45
DDFC E2 JEQ   1B            [DE19]
     1B
DDFE 7D CMP   %>90,R69      Instructioncode for F1
     90
     45
DE01 E7 JL    E9            [DDEC]
     E9
DE03 7D CMP   %>95,R69      Instructioncode for LR, the instruction after F5
     95
     45
DE06 E3 JHS   E4            [DDEC]
     E4
DE08 EC TRAP19
DE09 8E CALL  @>D6AB
     D6
     AB
DE0C 8E CALL  @>DE44
     DE
     44
DE0F E7 JNC   C9            [DDDA]
     C9
DE11 7D CMP   %>02,R69
     02
     45
DE14 E6 JNE   06            [DE1C]
     06
DE16 22 MOV   %>20,A        ASCII code for ' '
     20
DE18 ED TRAP18              Store in the PD buffer
DE19 EC TRAP19
DE1A E0 JMP   BE            [DDDA]
     BE

DE1C 22 MOV   %>3A,A        ASCII code for ':'
     3A
DE1E ED TRAP18              Store in the PD buffer
DE1F 72 MOV   %>03,R78
     03
     4E
DE22 8E CALL  @>D690
     D6
     90
DE25 12 MOV   R78,A
     4E
DE27 E6 JNZ   B1            [DDDA]
     B1
DE29 22 MOV   %>40,A        ASCII code for '@'
     40
DE2B ED TRAP18              Store in the PD buffer
DE2C 72 MOV   %>02,R78
     02
     4E
DE2F 8E CALL  @>D688
     D6
     88
DE32 E0 JMP   A6            [DDDA]
     A6

DE34 8E CALL  @>D672
     D6
     72
DE37 12 MOV   R78,A
     4E
DE39 E6 JNZ   9F            [DDDA]
     9F
DE3B 22 MOV   %>40,A        ASCII code for '@'
     40
DE3D ED TRAP18              Store in the PD buffer
DE3E 72 MOV   %>04,R78
     04
     4E
DE41 8C BR    @>DDCA
     DD
     CA

DE44 8A LDA   @>20B3
     20
     B3
DE47 C0 MOV   A,B
DE48 8A LDA   @>20B2
     20
     B2
DE4B CB DECD  B
DE4C 3A SUB   R119,B
     77
DE4E 1B SBB   R118,A
     76
DE50 0A RETS

DE51 73 AND   %>FE,R50      Reset flag 80
     FE
     32

The following instructions fill the entire PD buffer with blanks

DE54 52 MOV   %>50,B
     50
DE56 22 MOV   %>20,A        ASCII code for ' '
     20
DE58 AB STA   @>21FF(B)
     21
     FF
DE5B CA DJNZ  B,FB          [DE58]
     FB
DE5D 0A RETS

SBA 274
This SBA is used to list a label

DE5E 8A LDA   @>20B7        LSB of current PC
     20
     B7
DE61 D0 MOV   A,R77
     4D
DE63 8A LDA   @>20B6        MSB of current PC
     20
     B6
DE66 D0 MOV   A,R76
     4C
DE68 8A LDA   @>20B3        LSB of max PC
     20
     B3
DE6B D0 MOV   A,R75
     4B
DE6D 8B STA   @>22FC        Save
     22
     FC
DE70 8A LDA   @>20B2        MSB of max PC
     20
     B2
DE73 D0 MOV   A,R74
     4A
DE75 8B STA   @>22FB        Save
     22
     FB
DE78 D5 CLR   R73            Zeroes will stop SBA 469 from comparing
     49                        the characters following the label
DE7A D5 CLR   R72            
     48                     
DE7C B5 CLR   A              This zero prevents SBA 469 from generating
DE7D 8B STA   @>2105           errors
     21                      
     05                     
DE80 8E CALL  @>F069        SBA 469
     F0                     Search for a label
     69
DE83 12 MOV   R76,A
     4C
DE85 E2 JZ    4E            [DED5] Zero? No more labels found
     4E
DE87 8B STA   @>20B6        MSB of address of label
     20
     B6
DE8A 12 MOV   R77,A
     4D
DE8C 8B STA   @>20B7        LSB of address of label
     20
     B7
DE8F 78 ADD   %>03,R77       A LBL instruction has a length of 3 bytes
     03                      
     4D                      
DE92 79 ADC   %>00,R76       
     00                      
     4C                     
DE95 98 MOVD  R77,R1
     4D
     01
DE98 3A SUB   R75,B
     4B
DE9A 1B SBB   R74,A
     4A
DE9C E3 JC    0A            [DEA8] Carry?, LBL exceeds current partitioning,
     0A                            so repartitioning isn't necessary
DE9E 12 MOV   R76,A          Set max PC temporarily to the address of the
     4C                        byte following the label, to prevent the
DEA0 8B STA   @>20B2           listing routine to list more than just the
     20                        LBL xx.
     B2                      
DEA3 12 MOV   R77,A          
     4D                      
DEA5 8B STA   @>20B3         
     20                      
     B3                     
DEA8 8E CALL  @>DC18        List the LBL xx instruction
     DC
     18
DEAB 73 AND   %>FE,R48      Reset flag 64
     FE
     30

If the temporary max PC is equal to the saved max PC, the actual end of
programmemory has been reached. This will be signalled by setting flag 64,
if they are not equal, the current PC will be replaced by the address of the
first byte following the label and the max PC will be restored to its
original value.

DEAE 8A LDA   @>20B3
     20
     B3
DEB1 C0 MOV   A,B
DEB2 8A LDA   @>20B2
     20
     B2
DEB5 8D CMPA  @>22FB
     22
     FB
DEB8 E6 JNE   07            [DEC1]
     07
DEBA B6 XCHB  A
DEBB 8D CMPA  @>22FC
     22
     FC
DEBE E2 JEQ   15            [DED5]
     15
DEC0 B6 XCHB  A
DEC1 8B STA   @>20B6
     20
     B6
DEC4 62 MOV   B,A
DEC5 8B STA   @>20B7
     20
     B7
DEC8 8A LDA   @>22FC
     22
     FC
DECB 8B STA   @>20B3
     20
     B3
DECE 8A LDA   @>22FB
     22
     FB
DED1 8B STA   @>20B2
     20
     B2
DED4 0A RETS

DED5 74 OR    %>01,R48      Set flag 64
     01
     30
DED8 0A RETS

The following code is used to calculate the length of the next instruction in
system programs

DED9 98 MOVD  R39,R67       Save SYS PC in R66/67
     27
     43
DEDC 88 MOVD  %>F07E,R71    SBA 47E
     F0                     Increment SYS PC, change SYS page and load code
     7E                     at new PC
     47
DEE0 F0 TRAP15
DEE1 72 MOV   %>01,R79      Set instruction length to 1
     01
     4F
DEE4 2D CMP   %>D5,A        Compare fetched code with 'SF'
     D5
DEE6 E7 JL    1C            [DF04] Less than 'SF'?, length 1
     1C
DEE8 D0 MOV   A,R64         Save fetched code
     40
DEEA 88 MOVD  %>F07E,R71    SBA 47E
     F0                     Increment SYS PC, change SYS page and load code
     7E                     at new PC
     47
DEEE F0 TRAP15
DEEF 2D CMP   %>F8,A        Compare fetched code with 'IND'
     F8
DEF1 E6 JNE   04            [DEF7] Code not 'IND'
     04
DEF3 D3 INC   R79           Increment instruction length
     4F
DEF5 E0 JMP   F1            [DEE8]
     F1

DEF7 C0 MOV   A,B           Move code to B
DEF8 D6 XCHB  R64           Exchange with previous code
     40
DEFA AA LDA   @>DEEA(B)     Load info byte for previous code
     DE
     EA
DEFD E1 JN    09            [DF08] Negative?
     09
DEFF 23 AND   %>07,A        Mask out first 5 bits of info byte to obtain
     07                     the length
DF01 48 ADD   R0,R79        Add length to instruction length
     00
     4F
DF04 98 MOVD  R67,R39       Restore saved SYS PC
     43
     27
DF07 0A RETS

DF08 23 AND   %>0F,A        Mask out first 4 bits of info byte to obtain
     0F                     pointer (0, 2 or 4)
DF0A C0 MOV   A,B           Move to pointer register
DF0B 12 MOV   R64,A         Get previous code back
     40
DF0D AE CALL  @>DFB9(B)
     DF
     B9
DF10 E0 JMP   F2            [DF04]
     F2

SBA 27A
This SBA calculates the length of the next instruction

DF12 76 BTJO  %>08,R43,C3   [DED9] Test if flag 27 is set
     08
     2B
     C3
DF16 D5 CLR   R79           Set instruction length to 0
     4F
DF18 98 MOVD  R119,R69      Save RUN PC in R68/69
     77
     45
DF1B 8E CALL  @>F057        SBA 457
     F0                     Fetch code at RUN PC and increment RUN PC,
     57                     set flag 71 if RUN PC out of range
DF1E 76 BTJO  %>80,R48,48   [DF6A] Test if flag 71 is set
     80
     30
     48
DF22 D0 MOV   A,R64         Save fetched code
     40
DF24 D3 INC   R79           Increment instruction length
     4F
DF26 2D CMP   %>F8,A        Compare fetched code with 'IND'
     F8
DF28 E2 JEQ   40            [DF6A] 'IND'?, length 1
     40
DF2A 2D CMP   %>D5,A        Compare fetched code with 'SF'
     D5
DF2C E7 JL    3C            [DF6A] Less than 'SF'?, length 1
     3C
DF2E C0 MOV   A,B           Move code to B
DF2F AA LDA   @>DEEA(B)     Load info byte for multi-byte instruction
     DE
     EA
DF32 27 BTJZ  %>40,A,0F     [DF44] Test if fetched code is 'DFN', 'IND',
     40                     'DFA' or 'LBL'
     0F
DF35 8E CALL  @>F057        SBA 457
     F0                     Fetch code at RUN PC and increment RUN PC,
     57                     set flag 71 if RUN PC out of range
DF38 76 BTJO  %>80,R48,2E   [DF6A] Test if flag 71 is set
     80
     30
     2E
DF3C 2D CMP   %>F8,A        Compare fetched code with 'IND'
     F8
DF3E E6 JNE   0B            [DF4B] Fetched code not 'IND'
     0B
DF40 D3 INC   R79           Increment length
     4F
DF42 D0 MOV   A,R64         Save fetched code
     40
DF44 8E CALL  @>F057        SBA 457
     F0                     Fetch code at RUN PC and increment RUN PC,
     57                     set flag 71 if RUN PC out of range
DF47 76 BTJO  %>80,R48,1F   [DF6A] Test if flag 71 is set
     80
     30
     1F
DF4B C0 MOV   A,B           Move fetched code to B
DF4C D6 XCHB  R64           Exchange with previous code
     40
DF4E AA LDA   @>DEEA(B)     Load info byte of previous code
     DE
     EA
DF51 E1 JN    1B            [DF6E] Test if negative
     1B
DF53 23 AND   %>07,A        Mask out first 5 bits of info byte to
     07                     obtain the length
DF55 48 ADD   R0,R79        Add length to instruction length
     00
     4F
DF58 98 MOVD  R69,R1        Move saved RUN PC to A/B
     45
     01
DF5B 38 ADD   R79,B          Increment saved RUN PC with length of next
     4F                        instruction
DF5D 29 ADC   %>00,A         
     00                     
DF5F CB DECD  B             Decrement RUN PC with 1
DF60 3A SUB   R117,B         Subtract MAX PC from RUN PC
     75                      
DF62 1B SBB   R116,A         
     74                     
DF64 E7 JNC   04            [DF6A] No carry indicates RUN PC <= MAX PC
     04
DF66 C3 INC   B             Increment negative difference
DF67 4A SUB   R1,R79        Calculate corrected length
     01
     4F
DF6A 98 MOVD  R69,R119      Restore saved RUN PC
     45
     77
DF6D 0A RETS

DF6E 23 AND   %>0F,A        Mask first 4 bits of info byte to obtain
     0F                     pointer (0, 2 or 4)
DF70 C0 MOV   A,B           Move to pointer register
DF71 12 MOV   R64,A         Get previous code back
     40
DF73 AE CALL  @>DF78(B)
     DF
     78
DF76 E0 JMP   E0            [DF58]
     E0

DF78 E0 JMP   11            [DF8B]
     11

DF7A E0 JMP   04            [DF80]
     04

DF7C 2D CMP   %>10,A        Compare fetched code with '='
     10

DF7E E2 JEQ   08            [DF88] Code is '='
     08
DF80 2D CMP   %>41,A        Compare fetched code with 'A'
     41
DF82 E7 JL    2D            [DFB1] Jump if less than 'A'
     2D
DF84 2D CMP   %>5B,A        Compare fetched code with '[' (First character
     5B                     after 'Z')
DF86 E3 JHS   29            [DFB1] Jump if more than 'Z'
     29
DF88 D3 INC   R79           Increment instruction length
     4F
DF8A 0A RETS

DF8B 2D CMP   %>02,A        Compare fetched code with 'CLR'
     02
DF8D E2 JEQ   F9            [DF88] Jump if 'CLR'
     F9
DF8F 2D CMP   %>90,A        Compare fetched code with 'F1'
     90
DF91 E7 JL    22            [DFB5] Jump if less than F1
     22
DF93 2D CMP   %>95,A        Compare fetched code with 'LR' (First
     95                     code after 'F5')
DF95 E3 JHS   1E            [DFB5] Jump if more than 'F5'
     1E
DF97 8E CALL  @>F057        SBA 457
     F0                     Fetch code at RUN PC and increment RUN PC,
     57                     set flag 71 if RUN PC out of range
DF9A 76 BTJO  %>80,R48,EA   [DF88] Test if flag 71 is set
     80
     30
     EA
DF9E 2D CMP   %>02,A        Compare fetched code with 'CLR'
     02
DFA0 E2 JEQ   0F            [DFB1] Code is 'CLR'
     0F
DFA2 78 ADD   %>06,R79      Add 6 to instruction length
     06
     4F
DFA5 0A RETS

DFA6 2D CMP   %>02,A        Compare code with 'CLR'
     02
DFA8 E2 JEQ   DE            [DF88]
     DE
DFAA 88 MOVD  %>F07E,R71    SBA 47E
     F0                     Increment SYS PC, change SYS page and load code
     7E                     at new PC
     47
DFAE F0 TRAP15
DFAF E0 JMP   ED            [DF9E]
     ED

DFB1 78 ADD   %>02,R79      Add 2 to instruction length
     02
     4F
DFB4 0A RETS

DFB5 72 MOV   %>F7,R64      Change saved code into 'DFN'
     F7
     40
DFB8 0A RETS

DFB9 E0 JMP   EB            [DFA6]
     EB

DFBB E0 JMP   C3            [DF80]
     C3

DFBD E0 JMP   BD            [DF7C]
     BD

Infobytes for the length and fieldtype of the fieldinstructions

DFBF 41  SF       The first nibble of the infobyte indicates the type of
DFC0 41  RF       field:
DFC1 41  TF
DFC2 42  DEV      0: Fixed field instructions, DFA and LBL
DFC3 41  SHW      4: Field may be numeric OR alpha and IND
DFC4 42  CHR      8: Special cases, DFN and IND
DFC5 41  FIX      C: Field may be numeric AND alpha and IND
DFC6 43  DF
DFC7 43  NAM      The second nibble gives the length of the field in bytes:
DFC8 43  PUT
DFC9 43  GET      0: Special case, DFN
DFCA C2  RCL      1: 1 byte or IND
DFCB C2  EXC      2: 2 byte or IND
DFCC C2  STO      3: 3 byte or IND
DFCD C2  ST+      4: 2 byte or IND or =
DFCE C2  ST-      6: 6 bytes, only DFA
DFCF C2  ST*
DFD0 C2  ST/
DFD1 C2  DSZ
DFD2 C2  INC
DFD3 C2  IF<
DFD4 C2  IF=
DFD5 C2  IF>
DFD6 C4  MRG
DFD7 C4  RCA
DFD8 C2  STA
DFD9 43  RD
DFDA 43  WRT
DFDB 43  VFY
DFDC C2  CIO
DFDD 41  WID
DFDE 41  COL
DFDF 42  GTL
DFE0 42  SBL
DFE1 80  DFN
DFE2 82  IND
DFE3 42  GTO
DFE4 42  SBR
DFE5 06  DFA
DFE6 42  SBA
DFE7 42  STB
DFE8 42  RCB
DFE9 02  LBL

DFEA 00
DFEB 00
DFEC 00
DFED 00
DFEE 00
DFEF 00
DFF0 00
DFF1 00
DFF2 00
DFF3 00
DFF4 FF
DFF5 FF
DFF6 FF
DFF7 FF
DFF8 FF
DFF9 FF
DFFA FF
DFFB FF
DFFC FF
DFFD FF
DFFE 35
DFFF 60